
#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <tlhelp32.h>
#include <shlwapi.h>
#include <psapi.h>

#include <vector>
#include <algorithm>

#include "../MauHook/MauHook.h"
#include "main.h"
#include "resource.h"

#pragma comment(linker, "/merge:.rdata=.text")
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "psapi.lib")

HINSTANCE hInstance;
HFONT hFont = NULL;

TCHAR IniFileName[_MAX_FNAME + 1] = TEXT("MauSuji.ini");
BOOL LeftyMode = FALSE;

int NaviType;
BOOL ShowTaskTray;
int GestureDirection;
BOOL TimeOutType;
BOOL WheelRedirect;
BOOL WheelActive;
BOOL KuruKuruFlag;
int Priority;
int ClickWait;
int CheckInterval;
int MoveQuantity;
int GestureTimeOut;
int GestureStartQuantity;
int CornerTime;
int CornerPosX;
int CornerPosY;
BOOL CursorChange;
int NaviWidth;
int NaviDeleteTime;
int ScrollSensitivity;
int KuruKuruTimeOut;
int CircleRate;
LOGFONT lf;
COLORREF MainColor, SubColor, BackColor;
TCHAR NaviTitle[_MAX_PATH + 1];

TCHAR MoveUp[3];
TCHAR MoveDown[3];
TCHAR MoveLeft[3];
TCHAR MoveRight[3];
TCHAR MoveUpLeft[3];
TCHAR MoveUpRight[3];
TCHAR MoveDownLeft[3];
TCHAR MoveDownRight[3];
TCHAR CornerTopLeft[5];
TCHAR CornerTopRight[5];
TCHAR CornerBottomLeft[5];
TCHAR CornerBottomRight[5];

BOOL MouseHookFlag = TRUE;
BOOL IniChange = FALSE;
BOOL ImplementFlag = FALSE;
BOOL HookCheckFlag = TRUE;
BOOL KuruKuruTimeoutFlag = TRUE;

BOOL ShowParam;
int NaviHeight;
BOOL PopupFlag = FALSE, TimeOutFlag = FALSE, GestureTimeOutTimer = FALSE, NaviDrawFlag = FALSE, ClickOnlyFlag = FALSE;
int DoubleClickFlag = 0;
POINT StartPos, FinishPos, RealPos;
int MaxShadeWindow = 0;
int FinishActionNumber = -1;

TCHAR GestureCursor[_MAX_PATH + 1];
TCHAR WaitCursor[_MAX_PATH + 1];

TCHAR GestureString[50];
TCHAR CommentString[MAX_COMMENT + 1];

POINT MauSujiNavi, IniEditDialog, TargetDialog, ActionDialog, CommandDialog, NaviEditDialog, QuantityDialog, TipLocate;

BOOL ListViewHitTestFlag;
BOOL TreeViewHitTestFlag;

struct TargetWindow {
	int Number;
	int DefaultThru;
	BOOL HookType;
	BOOL WheelRedirect;
	BOOL FreeScroll;
	TCHAR FileName[_MAX_PATH + 1];
	TCHAR ClassName[MAX_CLASSNAME + 1];
	TCHAR ControlID[20];
	TCHAR Comment[MAX_COMMENT + 1];
};

struct ExecuteCommand {
	int TargetNumber;
	int Button;
	BYTE Modifier;
	int Move[MAX_GESTURE_LEVEL];
	int Repeat;
	int Case[MAX_ACTION_REPEAT];
	int Wait[MAX_ACTION_REPEAT];
	LONG Key[MAX_ACTION_REPEAT];
	int CommandTarget[MAX_ACTION_REPEAT];
	TCHAR Comment[MAX_COMMENT + 1];
	int BreakPoint;
};

struct MouseCapture {
	int Level;
	int Button;
	BYTE Modifier;
	int Move[MAX_GESTURE_LEVEL];
	BOOL Start;
} Gesture;

struct Command {
	int Locate;
	int Repeat;
	int Case[MAX_ACTION_REPEAT];
	int Wait[MAX_ACTION_REPEAT];
	LONG Key[MAX_ACTION_REPEAT];
	int CommandTarget[MAX_ACTION_REPEAT];
};

struct CommandExtInfo {
	int MainKey;
	int SubKey;
	int Sub2Key;
	TCHAR MainText[_MAX_PATH + 1];
	TCHAR SubText[_MAX_PATH + 1];
	TCHAR Sub2Text[_MAX_PATH + 1];
};

struct Case {
	int Number;
	TCHAR Name[30];
} CommandList[MAX_ACTION_CASE] = {
	{10,TEXT("L[𑗂")}, 
	{11,TEXT("L[")}, 
	{12,TEXT("L[𗣂")}, 
	{20,TEXT("{^")},
	{25,TEXT("Nbv{[hɃRs[")},
	{30,TEXT("vOs")},
	{35,TEXT("wavet@CĐ")},
	{40,TEXT("EBhE\@ύX")},
	{41,TEXT("EBhETCYύX")},
	{42,TEXT("EBhEʒuύX")},
	{55,TEXT("}EXJ[\ʒuύX")},
	{58,TEXT("JnʒuJ[\ړ")},
	{59,TEXT("IʒuJ[\ړ")},
	{50,TEXT("EBhE")},
	{60,TEXT("XN[")},
	{65,TEXT("̏ŃXN[")},
	{70,TEXT("SendMessage")},
	{71,TEXT("PostMessage")},
	{99,TEXT("ݒ")},
	{95,TEXT("u[N|Cg")},
	{96,TEXT("ANVIɎs")}
};

struct SearchChildInfo {
	int ClassFlag;
	HWND hwTarget;
	TCHAR ClassName[MAX_CLASSNAME + 1];
	int ControlID;
};

struct Zorder {
	int Number;
	TCHAR Name[30];
} ZorderList[MAX_ZORDER] = {
	{0,TEXT("Oɕ\")},
	{1,TEXT("ɕ\")},
	{2,TEXT("ɎOɕ\")},
	{3,TEXT("ɎOɕ\")},
	{4,TEXT("ɎOɕ\igOj")},
	{5,TEXT("̃TCYɖ߂")},
	{6,TEXT("ŏ")},
	{7,TEXT("ő剻")},
	{8,TEXT("")},
	{9,TEXT("ŏ̌̃TCY")},
	{10,TEXT("ő剻̌̃TCY")},
	{11,TEXT("ŏ̍ő剻")},
	{12,TEXT("EBhEVF[h")},
};

struct ShadeCheck {
	HWND hWnd;
	int Height;
	BOOL CheckFlag;
};

struct TargetWindow Default;
std::vector<struct TargetWindow> Target;
std::vector<struct ExecuteCommand> Action;
std::vector<struct CommandExtInfo> CommandExt;

void _SetForegroundWindow(HWND hwnd)
{
	int nTargetID, nForegroundID;
	DWORD sp_time;
	nForegroundID = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	nTargetID = GetWindowThreadProcessId(hwnd, NULL);
	AttachThreadInput(nTargetID, nForegroundID, TRUE);
	SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, &sp_time, 0);
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (LPVOID)0, 0);
	SetForegroundWindow(hwnd);
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (PVOID)sp_time, 0);
	AttachThreadInput(nTargetID, nForegroundID, FALSE);
}

BOOL GetWindowPosition(HWND hwnd, LPPOINT lpPoint)
{
	RECT rc;

	if(GetWindowRect(hwnd, &rc))
	{
		lpPoint->x = rc.left;
		lpPoint->y = rc.top;
		return TRUE;
	}
	return FALSE;
}

BOOL WritePrivateProfileInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, const int value, LPCTSTR lpFileName)
{
	TCHAR String[256];
	wsprintf(String, TEXT("%d"), value);
	return WritePrivateProfileString(lpAppName, lpKeyName, String, lpFileName);
}

void SortAction()
{
	int i, j, k;
	DWORD valueL, valueR;

	for(i=0;i<(int)Action.size()-1;i++)
	{
		for(j=i+1;j<(int)Action.size();j++)
		{
			valueL = (Action[i].TargetNumber * 0x100 * (MAX_TARGET_DATA + 1)) + (Action[i].Button * 0x100) + Action[i].Modifier;
			valueR = (Action[j].TargetNumber * 0x100 * (MAX_TARGET_DATA + 1)) + (Action[j].Button * 0x100) + Action[j].Modifier;

			if(valueL > valueR)
			{
				std::swap(Action[i], Action[j]);
			}
			else if(valueL == valueR)
			{
				k = 0;
				while(k < (int)Action.size() && Action[i].Move[k] == Action[j].Move[k])
					k ++;
				if(k < (int)Action.size())
				{
					if(Action[i].Move[k] > Action[j].Move[k])
					{
						std::swap(Action[i], Action[j]);
					}
				}
			}
		}
	}
}

int MinTargetNumber()
{
	int i;
	BOOL Number[MAX_TARGET_DATA] = {FALSE};
	int FoundNumber = MAX_TARGET_DATA;

	for(i=0; i<(int)Target.size(); i++)
		Number[Target[i].Number] = TRUE;

	for(i=MAX_TARGET_DATA-1; i>=1; i--)
		if(Number[i] == FALSE)
			FoundNumber = i;

	return FoundNumber;
}

void get_keyname(const LONG SendKey, LPTSTR lpszKeyName, int nSize)
{
	TCHAR szKeyName[1024] = TEXT("");
	UINT modifiers = ((HIBYTE(SendKey) & HOTKEYF_SHIFT) ? MOD_SHIFT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_CONTROL) ? MOD_CONTROL : 0) |
		((HIBYTE(SendKey) & HOTKEYF_ALT) ? MOD_ALT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_WIN) ? MOD_WIN : 0);
	UINT virtkey = LOBYTE(SendKey);
	UINT scan_code;
	int ext_flag = 0;

	if(modifiers & MOD_CONTROL)
		lstrcat(szKeyName, TEXT("Ctrl + "));
	if(modifiers & MOD_SHIFT)
		lstrcat(szKeyName, TEXT("Shift + "));
	if(modifiers & MOD_ALT)
		lstrcat(szKeyName, TEXT("Alt + "));
	if(modifiers & MOD_WIN)
		lstrcat(szKeyName, TEXT("Win + "));

	switch(virtkey)
	{
	case VK_LBUTTON:
		lstrcat(szKeyName, TEXT("Left mouse button"));
		break;
	case VK_RBUTTON:
		lstrcat(szKeyName, TEXT("Right mouse button"));
		break;
	case VK_MBUTTON:
		lstrcat(szKeyName, TEXT("Middle mouse button"));
		break;
	case VK_XBUTTON1:
		lstrcat(szKeyName, TEXT("X1 mouse button"));
		break;
	case VK_XBUTTON2:
		lstrcat(szKeyName, TEXT("X2 mouse button"));
		break;
	case VK_PAUSE:
		lstrcat(szKeyName, TEXT("Pause"));
		break;
	case VK_CAPITAL:
		lstrcat(szKeyName, TEXT("Caps Lock"));
		break;
	case VK_KANJI:
		lstrcat(szKeyName, TEXT("IME On/Off"));
		break;
	case VK_SNAPSHOT:
		lstrcat(szKeyName, TEXT("Print Screen"));
		break;
	case VK_LWIN:
		lstrcat(szKeyName, TEXT("Win"));
		break;
	case VK_SEPARATOR:
		lstrcat(szKeyName, TEXT("Num Enter"));
		break;
	case 0x5F:
		lstrcat(szKeyName, TEXT("Computer Sleep"));
		break;
	case VK_DECIMAL:
		lstrcat(szKeyName, TEXT("Num ."));
		break;
	case 0xA6:
		lstrcat(szKeyName, TEXT("Browser Back"));
		break;
	case 0xA7:
		lstrcat(szKeyName, TEXT("Browser Forward"));
		break;
	case 0xA8:
		lstrcat(szKeyName, TEXT("Browser Refresh"));
		break;
	case 0xA9:
		lstrcat(szKeyName, TEXT("Browser Stop"));
		break;
	case 0xAA:
		lstrcat(szKeyName, TEXT("Browser Search"));
		break;
	case 0xAB:
		lstrcat(szKeyName, TEXT("Browser Favorites"));
		break;
	case 0xAC:
		lstrcat(szKeyName, TEXT("Browser Start and Home"));
		break;
	case 0xAD:
		lstrcat(szKeyName, TEXT("Volume Mute"));
		break;
	case 0xAE:
		lstrcat(szKeyName, TEXT("Volume Down"));
		break;
	case 0xAF:
		lstrcat(szKeyName, TEXT("Volume Up"));
		break;
	case 0xB0:
		lstrcat(szKeyName, TEXT("Next Track"));
		break;
	case 0xB1:
		lstrcat(szKeyName, TEXT("Previous Track"));
		break;
	case 0xB2:
		lstrcat(szKeyName, TEXT("Stop Media"));
		break;
	case 0xB3:
		lstrcat(szKeyName, TEXT("Play/Pause Media"));
		break;
	case 0xB4:
		lstrcat(szKeyName, TEXT("Start Mail"));
		break;
	case 0xB5:
		lstrcat(szKeyName, TEXT("Select Media"));
		break;
	case 0xB6:
		lstrcat(szKeyName, TEXT("Start Application 1"));
		break;
	case 0xB7:
		lstrcat(szKeyName, TEXT("Start Application 2"));
		break;
	default:
		scan_code = MapVirtualKey(virtkey, 0);
		if(virtkey == VK_CANCEL ||
			virtkey == VK_DIVIDE ||
			virtkey == VK_APPS ||
			virtkey == VK_PRIOR ||
			virtkey == VK_NEXT ||
			virtkey == VK_END ||
			virtkey == VK_HOME ||
			virtkey == VK_LEFT ||
			virtkey == VK_UP ||
			virtkey == VK_RIGHT ||
			virtkey == VK_DOWN ||
			virtkey == VK_INSERT ||
			virtkey == VK_DELETE ||
			virtkey == VK_NUMLOCK) ext_flag = 1 << 24;
		GetKeyNameText((scan_code << 16) | ext_flag, szKeyName + lstrlen(szKeyName), 1024-lstrlen(szKeyName));
		break;
	}
	lstrcpyn(lpszKeyName, szKeyName, nSize);
}

void get_modifiername(const BYTE Modifier, LPTSTR lpszModifierName, int nSize)
{
	if(Modifier & MODIFIER_DISABLE)
	{
		lstrcpyn(lpszModifierName, TEXT(""), nSize);
	}
	else
	{
		if(Modifier & (MODIFIER_CONTROL | MODIFIER_SHIFT))
		{
			TCHAR szModifierName[1024] = TEXT("");
			if(Modifier & MODIFIER_CONTROL)
				lstrcat(szModifierName, TEXT("Ctrl + "));
			if(Modifier & MODIFIER_SHIFT)
				lstrcat(szModifierName, TEXT("Shift + "));
			lstrcpyn(lpszModifierName, szModifierName, nSize);
		}
	}
}

void OpenHelp()
{
	TCHAR HelpName[_MAX_PATH + 1];
	TCHAR ExePath[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];

	GetModuleFileName(NULL, ExePath, _MAX_PATH);
	_tsplitpath_s(ExePath, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);
	wsprintf(HelpName, TEXT("%s%sMauSuji.chm"), drive, dir);
	ShellExecute(NULL, NULL, TEXT("hh.exe"), HelpName, NULL, SW_SHOWDEFAULT);
}

INT_PTR CALLBACK DialogProcVersion(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_EDIT_OPENMAUSUJI_VERSION, OPENMAUSUJI_VERSION);
		SetDlgItemText(hDlg, IDC_EDIT_MAUSUJI_VERSION, MAUSUJI_VERSION);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			EndDialog(hDlg, TRUE);
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	}
	return FALSE;
}

void ShowVersionInfo(HWND hwnd)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_VERSION), hwnd, DialogProcVersion);
}

//init@C`FbN
BOOL IniCheck()
{
	int IniVerTemp;
	TCHAR IniName[_MAX_PATH + 1];
	TCHAR ExePath[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];

	GetModuleFileName(NULL, ExePath, _MAX_PATH);
	_tsplitpath_s(ExePath, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);

	wsprintf(IniName, TEXT("%s%s%s"), drive, dir, IniFileName);
	if(GetFileAttributes(IniName) != 0xFFFFFFFF)
	{
		IniVerTemp = GetPrivateProfileInt(TEXT("Main"), TEXT("IniVersion"), 0, IniName);
		if(IniVerTemp != INI_VERSION)
			return TRUE;	//o[WႤ
	}

	return FALSE;	//t@CȂA܂́Ao[Wv
}

//init@Cǂݍ
void IniRead()
{
	TCHAR IniName[_MAX_PATH + 1];
	TCHAR ExePath[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];
	TCHAR ProfileSection[100], ProfileKey[100];
	int i, j;

	CommandExt.clear();
	Target.clear();
	Action.clear();

	GetModuleFileName(NULL, ExePath, _MAX_PATH);
	_tsplitpath_s(ExePath, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);

	wsprintf(IniName, TEXT("%s%s%s"), drive, dir, IniFileName);

	lstrcpy(ProfileSection, TEXT("Main"));
	ShowTaskTray = GetPrivateProfileInt(ProfileSection, TEXT("TaskTrayIcon"), TRUE, IniName);
	GestureDirection = GetPrivateProfileInt(ProfileSection, TEXT("GestureDirection"), 4, IniName);
	TimeOutType = GetPrivateProfileInt(ProfileSection, TEXT("TimeOutType"), FALSE, IniName);
	Default.HookType = GetPrivateProfileInt(ProfileSection, TEXT("DefaultHookType"), 1, IniName);
	Priority = GetPrivateProfileInt(ProfileSection, TEXT("Priority"), 0x0020, IniName);
	ClickWait = GetPrivateProfileInt(ProfileSection, TEXT("ClickWait"), 50, IniName);
	WheelRedirect = GetPrivateProfileInt(ProfileSection, TEXT("WheelRedirect"), FALSE, IniName);
	WheelActive = GetPrivateProfileInt(ProfileSection, TEXT("WheelActive"), FALSE, IniName);
	KuruKuruFlag = GetPrivateProfileInt(ProfileSection, TEXT("KuruKuru"), FALSE, IniName);
	Default.FreeScroll = GetPrivateProfileInt(ProfileSection, TEXT("FreeScroll"), 0, IniName);
	ScrollSensitivity = GetPrivateProfileInt(ProfileSection, TEXT("ScrollSensitivity"), 30, IniName);
	KuruKuruTimeOut = GetPrivateProfileInt(ProfileSection, TEXT("KuruKuruTimeOut"), 200, IniName);
	CircleRate = GetPrivateProfileInt(ProfileSection, TEXT("CircleRate"), 60, IniName);
	Default.WheelRedirect = GetPrivateProfileInt(ProfileSection, TEXT("DefaultWheelRedirect"), WheelRedirect, IniName);
	CheckInterval = GetPrivateProfileInt(ProfileSection, TEXT("CheckInterval"), 50, IniName);
	MoveQuantity = GetPrivateProfileInt(ProfileSection, TEXT("GestureSensitivity"), 50, IniName);
	GestureTimeOut = GetPrivateProfileInt(ProfileSection, TEXT("GestureTimeOut"), 500, IniName);
	GestureStartQuantity = GetPrivateProfileInt(ProfileSection, TEXT("GestureStartSensitivity"), 30, IniName);
	CornerTime = GetPrivateProfileInt(ProfileSection, TEXT("CornerSensitivity"), 500, IniName);
	CornerPosX = GetPrivateProfileInt(ProfileSection, TEXT("CornerAreaX"), 70, IniName);
	CornerPosY = GetPrivateProfileInt(ProfileSection, TEXT("CornerAreaY"), 70, IniName);
	CursorChange = GetPrivateProfileInt(ProfileSection, TEXT("CursorChange"), TRUE, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("GestureCursor"), TEXT(""), GestureCursor, _MAX_PATH, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("WaitCursor"), TEXT(""), WaitCursor, _MAX_PATH, IniName);
	IniEditDialog.x = GetPrivateProfileInt(ProfileSection, TEXT("ConfigDialogX"), 0, IniName);
	IniEditDialog.y = GetPrivateProfileInt(ProfileSection, TEXT("ConfigDialogY"), 0, IniName);
	TargetDialog.x = GetPrivateProfileInt(ProfileSection, TEXT("TargetDialogX"), 0, IniName);
	TargetDialog.y = GetPrivateProfileInt(ProfileSection, TEXT("TargetDialogY"), 0, IniName);
	ActionDialog.x = GetPrivateProfileInt(ProfileSection, TEXT("ActionDialogX"), 0, IniName);
	ActionDialog.y = GetPrivateProfileInt(ProfileSection, TEXT("ActionDialogY"), 0, IniName);
	CommandDialog.x = GetPrivateProfileInt(ProfileSection, TEXT("CommandDialogX"), 0, IniName);
	CommandDialog.y = GetPrivateProfileInt(ProfileSection, TEXT("CommandDialogY"), 0, IniName);
	NaviEditDialog.x = GetPrivateProfileInt(ProfileSection, TEXT("NaviDialogX"), 0, IniName);
	NaviEditDialog.y = GetPrivateProfileInt(ProfileSection, TEXT("NaviDialogY"), 0, IniName);
	QuantityDialog.x = GetPrivateProfileInt(ProfileSection, TEXT("SensitivityDialogX"), 0, IniName);
	QuantityDialog.y = GetPrivateProfileInt(ProfileSection, TEXT("SensitivityDialogY"), 0, IniName);
	ListViewHitTestFlag = GetPrivateProfileInt(ProfileSection, TEXT("EnableListViewIcon"), TRUE, IniName);
	TreeViewHitTestFlag = GetPrivateProfileInt(ProfileSection, TEXT("EnableTreeViewIcon"), TRUE, IniName);

	lstrcpy(ProfileSection, TEXT("Navi"));
	NaviType = GetPrivateProfileInt(ProfileSection, TEXT("NaviType"), 1, IniName);
	MauSujiNavi.x = GetPrivateProfileInt(ProfileSection, TEXT("NaviPositionX"), 0, IniName);
	MauSujiNavi.y = GetPrivateProfileInt(ProfileSection, TEXT("NaviPositionY"), 0, IniName);
	NaviDeleteTime = GetPrivateProfileInt(ProfileSection, TEXT("NaviDeleteTime"), 1000, IniName);
	NaviWidth = GetPrivateProfileInt(ProfileSection, TEXT("NaviWidth"), 0, IniName);
	TipLocate.x = GetPrivateProfileInt(ProfileSection, TEXT("TipLocateX"), 0, IniName);
	TipLocate.y = GetPrivateProfileInt(ProfileSection, TEXT("TipLocateY"), 20, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("NaviTitle"), TEXT("}E"), NaviTitle, _MAX_PATH, IniName);
	lf.lfHeight = GetPrivateProfileInt(ProfileSection, TEXT("FontHeight"), 12, IniName);
	lf.lfWeight = GetPrivateProfileInt(ProfileSection, TEXT("FontWeight"), 0, IniName);
	lf.lfItalic = GetPrivateProfileInt(ProfileSection, TEXT("FontItalic"), 0, IniName);
	lf.lfCharSet = GetPrivateProfileInt(ProfileSection, TEXT("FontCharSet"), 128, IniName);
	MainColor = GetPrivateProfileInt(ProfileSection, TEXT("MainTextColor"), 0, IniName);
	SubColor = GetPrivateProfileInt(ProfileSection, TEXT("SubTextColor"), 8421504, IniName);
	BackColor = GetPrivateProfileInt(ProfileSection, TEXT("BackgroundColor"), 12582911, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("FontName"), TEXT("MS UI Gothic"), lf.lfFaceName, 69, IniName);

	lstrcpy(ProfileSection, TEXT("Character"));
	GetPrivateProfileString(ProfileSection, TEXT("Up"), TEXT(""), MoveUp, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("Down"), TEXT(""), MoveDown, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("Left"), TEXT(""), MoveLeft, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("Right"), TEXT(""), MoveRight, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("UpLeft"), TEXT(""), MoveUpLeft, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("UpRight"), TEXT(""), MoveUpRight, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("DownLeft"), TEXT(""), MoveDownLeft, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("DownRight"), TEXT(""), MoveDownRight, 3, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("CornerTopLeft"), TEXT(""), CornerTopLeft, 5, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("CornerTopRight"), TEXT(""), CornerTopRight, 5, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("CornerBottomLeft"), TEXT(""), CornerBottomLeft, 5, IniName);
	GetPrivateProfileString(ProfileSection, TEXT("CornerBottomRight"), TEXT(""), CornerBottomRight, 5, IniName);

	lstrcpy(ProfileSection, TEXT("Target"));
	i = 0;
	while(1)
	{
		struct TargetWindow t = {0};

		wsprintf(ProfileKey, TEXT("Number_%d"), i);
		t.Number = GetPrivateProfileInt(ProfileSection, ProfileKey, -1, IniName);
		wsprintf(ProfileKey, TEXT("Succession_%d"), i);
		t.DefaultThru = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
		wsprintf(ProfileKey, TEXT("HookType_%d"), i);
		t.HookType = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
		wsprintf(ProfileKey, TEXT("WheelRedirect_%d"), i);
		t.WheelRedirect = GetPrivateProfileInt(ProfileSection, ProfileKey, Default.WheelRedirect, IniName);
		wsprintf(ProfileKey, TEXT("FreeScroll_%d"), i);
		t.FreeScroll = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
		wsprintf(ProfileKey, TEXT("FileName%d"), i);
		GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), t.FileName, _MAX_PATH, IniName);
		wsprintf(ProfileKey, TEXT("ClassName%d"), i);
		GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), t.ClassName, MAX_CLASSNAME, IniName);
		wsprintf(ProfileKey, TEXT("ControlID%d"), i);
		GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), t.ControlID, 19, IniName);
		wsprintf(ProfileKey, TEXT("Comment%d"), i);
		GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), t.Comment, MAX_COMMENT, IniName);
		if(t.Number >= 0)
		{
			Target.push_back(t);
			i++;
			if(i >= MAX_TARGET_DATA)
				break;
		}
		else
		{
			break;
		}
	}

	lstrcpy(ProfileSection, TEXT("Action"));
	i = 0;
	while(1)
	{
		struct ExecuteCommand a = {0};

		wsprintf(ProfileKey, TEXT("TargetNumber%d"), i);
		a.TargetNumber = GetPrivateProfileInt(ProfileSection, ProfileKey, -1, IniName);
		wsprintf(ProfileKey, TEXT("Gesture%d"), i);
		a.Button = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
		wsprintf(ProfileKey, TEXT("Modifier%d"), i);
		a.Modifier = GetPrivateProfileInt(ProfileSection, ProfileKey, MODIFIER_DISABLE, IniName);
		for(j = 0; j < MAX_GESTURE_LEVEL; j++)
		{
			wsprintf(ProfileKey, TEXT("Gesture%d_%d"), i, j);
			a.Move[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
		}
		if(LeftyMode)
		{
			if(a.Button == BUTTON_L || a.Button == BUTTON_R)
				a.Button = BUTTON_L + BUTTON_R - a.Button;
			if(a.Move[0] > 0 && (a.Move[0] == BUTTON_L || a.Move[0] == BUTTON_R))
				a.Move[0] = BUTTON_L + BUTTON_R - a.Move[0];
		}
		wsprintf(ProfileKey, TEXT("Comment%d"), i, j);
		GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), a.Comment, MAX_COMMENT, IniName);

		j = -1;
		do{
			struct CommandExtInfo c = {0};

			j++;
			wsprintf(ProfileKey, TEXT("Case%d_%d"), i, j);
			a.Case[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
			wsprintf(ProfileKey, TEXT("CommandTarget%d_%d"), i, j);
			a.CommandTarget[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
			if(a.Case[j] < 0)
			{
				a.CommandTarget[j] = -1;
				a.Case[j] = abs(a.Case[j]);
			}
			switch( a.Case[j] )
			{
			case 25:
			case 30:
			case 35:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				a.Wait[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				a.Key[j] = (LONG)CommandExt.size();
				wsprintf(ProfileKey, TEXT("MainText%d_%d"), i, j);
				GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), c.MainText, _MAX_PATH, IniName);
				wsprintf(ProfileKey, TEXT("SubText%d_%d"), i, j);
				GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), c.SubText, _MAX_PATH, IniName);
				CommandExt.push_back(c);
				break;
			case 65:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				a.Wait[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				wsprintf(ProfileKey, TEXT("Key%d_%d"), i, j);
				a.Key[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 65546, IniName);
				break;
			case 70:
			case 71:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				a.Wait[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				a.Key[j] = (LONG)CommandExt.size();
				wsprintf(ProfileKey, TEXT("Message%d_%d"), i, j);
				GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), c.MainText, _MAX_PATH, IniName);
				wsprintf(ProfileKey, TEXT("MessageType%d_%d"), i, j);
				c.MainKey = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				wsprintf(ProfileKey, TEXT("wParam%d_%d"), i, j);
				GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), c.SubText, _MAX_PATH, IniName);
				wsprintf(ProfileKey, TEXT("wParamType%d_%d"), i, j);
				c.SubKey = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				wsprintf(ProfileKey, TEXT("lParam%d_%d"), i, j);
				GetPrivateProfileString(ProfileSection, ProfileKey, TEXT(""), c.Sub2Text, _MAX_PATH, IniName);
				wsprintf(ProfileKey, TEXT("lParamType%d_%d"), i, j);
				c.Sub2Key = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				CommandExt.push_back(c);
				break;
			case 99:
			case 95:
			case 96:
				break;
			default:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				a.Wait[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				wsprintf(ProfileKey, TEXT("Key%d_%d"), i, j);
				a.Key[j] = GetPrivateProfileInt(ProfileSection, ProfileKey, 0, IniName);
				break;
			}
		}while(j < MAX_ACTION_REPEAT && a.Case[j] != 0);

		a.Repeat = j;
		a.BreakPoint = 0;
		if(a.TargetNumber >= 0)
		{
			Action.push_back(a);
			i++;
			if(i >= MAX_ACTION_DATA)
				break;
		}
		else
		{
			break;
		}
	}

	SortAction();
}

//init@C
void IniWrite()
{
	TCHAR IniName[_MAX_PATH + 1];
	TCHAR ExePath[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];
	TCHAR ProfileSection[100], ProfileKey[100];
	int i, j;

	GetModuleFileName(NULL, ExePath, _MAX_PATH);
	_tsplitpath_s(ExePath, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);

	wsprintf(IniName, TEXT("%s%s%s"), drive, dir, IniFileName);

	lstrcpy(ProfileSection, TEXT("Main"));
	WritePrivateProfileInt(ProfileSection, TEXT("IniVersion"), INI_VERSION, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("TaskTrayIcon"), ShowTaskTray, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("GestureDirection"), GestureDirection, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("TimeOutType"), TimeOutType, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("DefaultHookType"), Default.HookType, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("Priority"), Priority, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("ClickWait"), ClickWait, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("WheelRedirect"), WheelRedirect, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("WheelActive"), WheelActive, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("KuruKuru"), KuruKuruFlag, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("FreeScroll"), Default.FreeScroll, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("ScrollSensitivity"), ScrollSensitivity, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("KuruKuruTimeOut"), KuruKuruTimeOut, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CircleRate"), CircleRate, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("DefaultWheelRedirect"), Default.WheelRedirect, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CheckInterval"), CheckInterval, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("GestureSensitivity"), MoveQuantity, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("GestureTimeOut"), GestureTimeOut, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("GestureStartSensitivity"), GestureStartQuantity, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CornerSensitivity"), CornerTime, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CornerAreaX"), CornerPosX, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CornerAreaY"), CornerPosY, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CursorChange"), CursorChange, IniName);
	if(GestureCursor[0])
		WritePrivateProfileString(ProfileSection, TEXT("GestureCursor"), GestureCursor, IniName);
	if(WaitCursor[0])
		WritePrivateProfileString(ProfileSection, TEXT("WaitCursor"), WaitCursor, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("ConfigDialogX"), IniEditDialog.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("ConfigDialogY"), IniEditDialog.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("TargetDialogX"), TargetDialog.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("TargetDialogY"), TargetDialog.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("ActionDialogX"), ActionDialog.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("ActionDialogY"), ActionDialog.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CommandDialogX"), CommandDialog.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("CommandDialogY"), CommandDialog.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("NaviDialogX"), NaviEditDialog.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("NaviDialogY"), NaviEditDialog.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("SensitivityDialogX"), QuantityDialog.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("SensitivityDialogY"), QuantityDialog.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("EnableListViewIcon"), ListViewHitTestFlag, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("EnableTreeViewIcon"), TreeViewHitTestFlag, IniName);

	lstrcpy(ProfileSection, TEXT("Navi"));
	WritePrivateProfileInt(ProfileSection, TEXT("NaviType"), NaviType, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("NaviPositionX"), MauSujiNavi.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("NaviPositionY"), MauSujiNavi.y, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("NaviDeleteTime"), NaviDeleteTime, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("NaviWidth"), NaviWidth, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("TipLocateX"), TipLocate.x, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("TipLocateY"), TipLocate.y, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("NaviTitle"), NaviTitle, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("FontHeight"), lf.lfHeight, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("FontWeight"), lf.lfWeight, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("FontItalic"), lf.lfItalic, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("FontCharSet"), lf.lfCharSet, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("MainTextColor"), MainColor, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("SubTextColor"), SubColor, IniName);
	WritePrivateProfileInt(ProfileSection, TEXT("BackgroundColor"), BackColor, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("FontName"), lf.lfFaceName, IniName);

	lstrcpy(ProfileSection, TEXT("Character"));
	WritePrivateProfileString(ProfileSection, TEXT("Up"), MoveUp, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("Down"), MoveDown, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("Left"), MoveLeft, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("Right"), MoveRight, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("UpLeft"), MoveUpLeft, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("UpRight"), MoveUpRight, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("DownLeft"), MoveDownLeft, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("DownRight"), MoveDownRight, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("CornerTopLeft"), CornerTopLeft, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("CornerTopRight"), CornerTopRight, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("CornerBottomLeft"), CornerBottomLeft, IniName);
	WritePrivateProfileString(ProfileSection, TEXT("CornerBottomRight"), CornerBottomRight, IniName);

	lstrcpy(ProfileSection, TEXT("Target"));
	WritePrivateProfileString(ProfileSection, NULL, NULL, IniName);
	for(i = 0; i < (int)Target.size(); i++)
	{
		wsprintf(ProfileKey, TEXT("Number_%d"), i);
		WritePrivateProfileInt(ProfileSection, ProfileKey, Target[i].Number, IniName);
		wsprintf(ProfileKey, TEXT("Succession_%d"), i);
		WritePrivateProfileInt(ProfileSection, ProfileKey, Target[i].DefaultThru, IniName);
		wsprintf(ProfileKey, TEXT("HookType_%d"), i);
		WritePrivateProfileInt(ProfileSection, ProfileKey, Target[i].HookType, IniName);
		wsprintf(ProfileKey, TEXT("WheelRedirect_%d"), i);
		WritePrivateProfileInt(ProfileSection, ProfileKey, Target[i].WheelRedirect, IniName);
		wsprintf(ProfileKey, TEXT("FreeScroll_%d"), i);
		WritePrivateProfileInt(ProfileSection, ProfileKey, Target[i].FreeScroll, IniName);
		if(Target[i].FileName[0])
		{
			wsprintf(ProfileKey, TEXT("FileName%d"), i);
			WritePrivateProfileString(ProfileSection, ProfileKey, Target[i].FileName, IniName);
		}
		if(Target[i].ClassName[0])
		{
			wsprintf(ProfileKey, TEXT("ClassName%d"), i);
			WritePrivateProfileString(ProfileSection, ProfileKey, Target[i].ClassName, IniName);
		}
		if(Target[i].ControlID[0])
		{
			wsprintf(ProfileKey, TEXT("ControlID%d"), i);
			WritePrivateProfileString(ProfileSection, ProfileKey, Target[i].ControlID, IniName);
		}
		if(Target[i].Comment[0])
		{
			wsprintf(ProfileKey, TEXT("Comment%d"), i);
			WritePrivateProfileString(ProfileSection, ProfileKey, Target[i].Comment, IniName);
		}
	}

	lstrcpy(ProfileSection, TEXT("Action"));
	WritePrivateProfileString(ProfileSection, NULL, NULL, IniName);
	for(i = 0; i < (int)Action.size(); i++)
	{
		wsprintf(ProfileKey, TEXT("TargetNumber%d"), i);
		WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].TargetNumber, IniName);
		wsprintf(ProfileKey, TEXT("Gesture%d"), i);
		if(LeftyMode && (Action[i].Button == BUTTON_L || Action[i].Button == BUTTON_R))
			WritePrivateProfileInt(ProfileSection, ProfileKey, BUTTON_L + BUTTON_R - Action[i].Button, IniName);
		else
			WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Button, IniName);
		if(!(Action[i].Modifier & MODIFIER_DISABLE))
		{
			wsprintf(ProfileKey, TEXT("Modifier%d"), i);
			WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Modifier, IniName);
		}
		wsprintf(ProfileKey, TEXT("Gesture%d_%d"), i, 0);
		if(LeftyMode && Action[i].Move[0] > 0 && (Action[i].Move[0] == BUTTON_L || Action[i].Move[0] == BUTTON_R))
			WritePrivateProfileInt(ProfileSection, ProfileKey, BUTTON_L + BUTTON_R - Action[i].Move[0], IniName);
		else
			WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Move[0], IniName);
		j = 1;
		while(j < MAX_GESTURE_LEVEL && Action[i].Move[j] > 0)
		{
			wsprintf(ProfileKey, TEXT("Gesture%d_%d"), i, j);
			WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Move[j], IniName);
			j++;
		}
		if(Action[i].Comment[0])
		{
			wsprintf(ProfileKey, TEXT("Comment%d"), i, j);
			WritePrivateProfileString(ProfileSection, ProfileKey, Action[i].Comment, IniName);
		}
		for(j = 0; j < Action[i].Repeat; j++)
		{
			wsprintf(ProfileKey, TEXT("Case%d_%d"), i, j);
			WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Case[j], IniName);
			wsprintf(ProfileKey, TEXT("CommandTarget%d_%d"), i, j);
			WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].CommandTarget[j], IniName);
			switch( Action[i].Case[j] )
			{
			case 25:
			case 30:
			case 35:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Wait[j], IniName);
				if(CommandExt[Action[i].Key[j]].MainText[0])
				{
					wsprintf(ProfileKey, TEXT("MainText%d_%d"), i, j);
					WritePrivateProfileString(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].MainText, IniName);
				}
				if(CommandExt[Action[i].Key[j]].SubText[0])
				{
					wsprintf(ProfileKey, TEXT("SubText%d_%d"), i, j);
					WritePrivateProfileString(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].SubText, IniName);
				}
				break;
			case 70:
			case 71:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Wait[j], IniName);
				wsprintf(ProfileKey, TEXT("Message%d_%d"), i, j);
				WritePrivateProfileString(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].MainText, IniName);
				wsprintf(ProfileKey, TEXT("MessageType%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].MainKey, IniName);
				wsprintf(ProfileKey, TEXT("wParam%d_%d"), i, j);
				WritePrivateProfileString(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].SubText, IniName);
				wsprintf(ProfileKey, TEXT("wParamType%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].SubKey, IniName);
				wsprintf(ProfileKey, TEXT("lParam%d_%d"), i, j);
				WritePrivateProfileString(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].Sub2Text, IniName);
				wsprintf(ProfileKey, TEXT("lParamType%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, CommandExt[Action[i].Key[j]].Sub2Key, IniName);
				break;
			case 99:
			case 95:
			case 96:
				break;
			default:
				wsprintf(ProfileKey, TEXT("Wait%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Wait[j], IniName);
				wsprintf(ProfileKey, TEXT("Key%d_%d"), i, j);
				WritePrivateProfileInt(ProfileSection, ProfileKey, Action[i].Key[j], IniName);
				break;
			}
		}
	}
}

void GestureToString(int GestureCode, LPTSTR lpszText, int nSize)
{
	TCHAR szText[1024];

	switch(GestureCode)
	{
	case BUTTON_L:
		lstrcpyn(lpszText, TEXT("L "), nSize);
		break;
	case BUTTON_M:
		lstrcpyn(lpszText, TEXT("M "), nSize);
		break;
	case BUTTON_R:
		lstrcpyn(lpszText, TEXT("R "), nSize);
		break;
	case BUTTON_X1:
		lstrcpyn(lpszText, TEXT("X1 "), nSize);
		break;
	case BUTTON_X2:
		lstrcpyn(lpszText, TEXT("X2 "), nSize);
		break;
	case MOVE_UP:
		lstrcpyn(lpszText, MoveUp, nSize);
		break;
	case MOVE_DOWN:
		lstrcpyn(lpszText, MoveDown, nSize);
		break;
	case MOVE_LEFT:
		lstrcpyn(lpszText, MoveLeft, nSize);
		break;
	case MOVE_RIGHT:
		lstrcpyn(lpszText, MoveRight, nSize);
		break;
	case MOVE_UPLEFT:
		lstrcpyn(lpszText, MoveUpLeft, nSize);
		break;
	case MOVE_UPRIGHT:
		lstrcpyn(lpszText, MoveUpRight, nSize);
		break;
	case MOVE_DOWNLEFT:
		lstrcpyn(lpszText, MoveDownLeft, nSize);
		break;
	case MOVE_DOWNRIGHT:
		lstrcpyn(lpszText, MoveDownRight, nSize);
		break;
	case WHEEL_UP:
		wsprintf(szText, TEXT("Wheel %s"), MoveUp);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case WHEEL_DOWN:
		wsprintf(szText, TEXT("Wheel %s"), MoveDown);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case WHEEL_LEFT:
		wsprintf(szText, TEXT("Wheel %s"), MoveLeft);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case WHEEL_RIGHT:
		wsprintf(szText, TEXT("Wheel %s"), MoveRight);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_TOP_A:
		wsprintf(szText, TEXT("Corner %sA"), MoveUp);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_BOTTOM_A:
		wsprintf(szText, TEXT("Corner %sA"), MoveDown);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_LEFT_A:
		wsprintf(szText, TEXT("Corner %sA"), MoveLeft);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_RIGHT_A:
		wsprintf(szText, TEXT("Corner %sA"), MoveRight);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_TOP_B:
		wsprintf(szText, TEXT("Corner %sB"), MoveUp);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_BOTTOM_B:
		wsprintf(szText, TEXT("Corner %sB"), MoveDown);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_LEFT_B:
		wsprintf(szText, TEXT("Corner %sB"), MoveLeft);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_RIGHT_B:
		wsprintf(szText, TEXT("Corner %sB"), MoveRight);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_TOP_C:
		wsprintf(szText, TEXT("Corner %sC"), MoveUp);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_BOTTOM_C:
		wsprintf(szText, TEXT("Corner %sC"), MoveDown);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_LEFT_C:
		wsprintf(szText, TEXT("Corner %sC"), MoveLeft);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_RIGHT_C:
		wsprintf(szText, TEXT("Corner %sC"), MoveRight);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_TOPLEFT:
		wsprintf(szText, TEXT("Corner %s"), CornerTopLeft);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_TOPRIGHT:
		wsprintf(szText, TEXT("Corner %s"), CornerTopRight);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_BOTTOMLEFT:
		wsprintf(szText, TEXT("Corner %s"), CornerBottomLeft);
		lstrcpyn(lpszText, szText, nSize);
		break;
	case CORNER_BOTTOMRIGHT:
		wsprintf(szText, TEXT("Corner %s"), CornerBottomRight);
		lstrcpyn(lpszText, szText, nSize);
		break;
	default:
		lstrcpyn(lpszText, TEXT(" "), nSize);
		break;
	}
}

void ExecuteSendKey(int Case, LONG SendKey)
{
	UINT modifiers = ((HIBYTE(SendKey) & HOTKEYF_SHIFT) ? MOD_SHIFT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_CONTROL) ? MOD_CONTROL : 0) |
		((HIBYTE(SendKey) & HOTKEYF_ALT) ? MOD_ALT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_WIN) ? MOD_WIN : 0);
	UINT virtkey = LOBYTE(SendKey);
	UINT Extend = 0;

	switch(virtkey)
	{
	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_PRIOR:
	case VK_NEXT:
	case VK_LEFT:
	case VK_UP:
	case VK_RIGHT:
	case VK_DOWN:
	case VK_NUMLOCK:
	case VK_CANCEL:
	case VK_SNAPSHOT:
	case VK_SEPARATOR:
	case VK_DIVIDE:
		Extend = KEYEVENTF_EXTENDEDKEY;
		break;
	}

	if(Case == 10 || Case == 11)
	{
		//gݍ킹L[
		if(modifiers & MOD_SHIFT)
			keybd_event(VK_SHIFT, (BYTE)MapVirtualKey(VK_SHIFT, 0), 0, 0);
		if(modifiers & MOD_CONTROL)
			keybd_event(VK_CONTROL, (BYTE)MapVirtualKey(VK_CONTROL, 0), 0, 0);
		if(modifiers & MOD_ALT)
			keybd_event(VK_MENU, (BYTE)MapVirtualKey(VK_MENU, 0), 0, 0);
		if(modifiers & MOD_WIN)
			keybd_event(VK_LWIN, (BYTE)MapVirtualKey(VK_LWIN, 0), 0, 0);

		switch(virtkey)
		{
		case VK_LBUTTON:
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			break;
		case VK_RBUTTON:
			mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
			break;
		case VK_MBUTTON:
			mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, 0, 0);
			break;
		case VK_XBUTTON1:
			mouse_event(MOUSEEVENTF_XDOWN, 0, 0, XBUTTON1, 0);
			break;
		case VK_XBUTTON2:
			mouse_event(MOUSEEVENTF_XDOWN, 0, 0, XBUTTON2, 0);
			break;
		default:
			keybd_event((BYTE)virtkey, (BYTE)MapVirtualKey(virtkey, 0), Extend, 0);
			break;
		}
		Sleep(ClickWait);
	}

	if(Case == 10 || Case == 12)
	{
		switch(virtkey)
		{
		case VK_LBUTTON:
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			break;
		case VK_RBUTTON:
			mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
			break;
		case VK_MBUTTON:
			mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, 0, 0);
			break;
		case VK_XBUTTON1:
			mouse_event(MOUSEEVENTF_XUP, 0, 0, XBUTTON1, 0);
			break;
		case VK_XBUTTON2:
			mouse_event(MOUSEEVENTF_XUP, 0, 0, XBUTTON2, 0);
			break;
		default:
			keybd_event((BYTE)virtkey, (BYTE)MapVirtualKey(virtkey, 0), Extend | KEYEVENTF_KEYUP, 0);
			break;
		}

		//gݍ킹L[
		if(modifiers & MOD_WIN)
			keybd_event(VK_LWIN, (BYTE)MapVirtualKey(VK_LWIN, 0), KEYEVENTF_KEYUP, 0);
		if(modifiers & MOD_ALT)
			keybd_event(VK_MENU, (BYTE)MapVirtualKey(VK_MENU, 0), KEYEVENTF_KEYUP, 0);
		if(modifiers & MOD_CONTROL)
			keybd_event(VK_CONTROL, (BYTE)MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
		if(modifiers & MOD_SHIFT)
			keybd_event(VK_SHIFT, (BYTE)MapVirtualKey(VK_SHIFT, 0), KEYEVENTF_KEYUP, 0);
		Sleep(ClickWait);
	}
}

HWND GetDefViewWindowHandle()
{
	HWND hwnd = NULL;
	HWND hwndProgman;

	hwndProgman = FindWindowEx(NULL, NULL, TEXT("Progman"), TEXT("Program Manager"));
	if(hwndProgman)
	{
		HWND hwndDefView;

		hwndDefView = FindWindowEx(hwndProgman, NULL, TEXT("SHELLDLL_DefView"), NULL);
		if(hwndDefView)
		{
			hwnd = hwndDefView;
		}
		else
		{
			HWND hWorkerW = NULL;

			hWorkerW = FindWindowEx(NULL, NULL, TEXT("WorkerW"), NULL);
			while(hWorkerW!=NULL)
			{
				TCHAR szFileName[MAX_PATH];

				GetFileNameFromHwnd(hWorkerW, szFileName, MAX_PATH);
				if( !lstrcmpi(PathFindFileName(szFileName), TEXT("explorer.exe")) )
				{
					hwndDefView = FindWindowEx(hWorkerW, NULL, TEXT("SHELLDLL_DefView"), NULL);
					if(hwndDefView)
					{
						hwnd = hwndDefView;
						break;
					}
				}
				hWorkerW = FindWindowEx(NULL, hWorkerW, TEXT("WorkerW"), NULL);
			}
		}
	}
	return hwnd;
}

HWND GetDesktopWindowHandle()
{
	HWND hwnd = NULL;
	HWND hwndDefView;

	hwndDefView = GetDefViewWindowHandle();
	if(hwndDefView)
	{
		hwnd = FindWindowEx(hwndDefView, NULL, TEXT("SysListView32"), NULL);
		if(hwnd)
		{
			if( !(GetWindowLongPtr(hwnd, GWL_STYLE) & WS_VISIBLE) )
			{
				hwnd = FindWindowEx(hwndDefView, NULL, TEXT("Internet Explorer_Server"), NULL);
				if(hwnd==NULL)
				{
					hwnd = hwndDefView;
				}
			}
		}
	}
	return hwnd;
}

int SearchTarget(HWND hWnd, BOOL CornerMouse)
{
	int i = 0;
	LONG_PTR TargetID = 0;
	int FoundTargetNumber = -1;
	TCHAR ExePath[_MAX_PATH + 1];
	TCHAR FilePath[_MAX_PATH + 1];
	TCHAR FileName[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1], Tdrive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1], Tdir[_MAX_DIR + 1];
	TCHAR fname[_MAX_FNAME + 1], Tfname[_MAX_FNAME + 1];
	TCHAR fext[_MAX_EXT + 1], Tfext[_MAX_EXT + 1];
	TCHAR TClassName[_MAX_PATH + 1];
	BOOL FileNameFlag, ClassNameFlag, TargetIDFlag;

	GetModuleFileName(NULL, ExePath, _MAX_PATH);

	if(!GetFileNameFromHwnd(hWnd, FilePath, _MAX_PATH))
		return -1;
	if(lstrcmp(FilePath, ExePath) == 0)
		return -1;

	_tsplitpath_s( FilePath, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, fext, _MAX_EXT );
	_tmakepath_s( FileName, _MAX_PATH, NULL, NULL, fname, fext );

	while(i < (int)Target.size() && FoundTargetNumber == -1)
	{
		FileNameFlag = TRUE;
		ClassNameFlag = TRUE;
		TargetIDFlag = TRUE;

		if(Target[i].FileName[0])
		{
			if(lstrcmpi(Target[i].FileName, TEXT("Desktop")) == 0)
			{
				if( hWnd == NULL || hWnd != GetDesktopWindowHandle() )
				{
					FileNameFlag = FALSE;
				}
			}
			else
			{
				_tsplitpath_s( Target[i].FileName, Tdrive, _MAX_DRIVE, Tdir, _MAX_DIR, Tfname, _MAX_FNAME, Tfext, _MAX_EXT );
				if(!((lstrcmp(Tdrive, TEXT("")) == 0 || lstrcmpi(Tdrive, drive) == 0) &&
					(lstrcmp(Tdir, TEXT("")) == 0 || lstrcmpi(Tdir, dir) == 0) &&
					(lstrcmpi(Tfname, fname) == 0 && lstrcmpi(fext, Tfext) == 0)))
				{
					FileNameFlag = FALSE;
				}
			}
		}

		if(Target[i].ClassName[0] && CornerMouse == FALSE)
		{
			if(lstrcmpi(Target[i].ClassName, TEXT("HitTestCaptionBar")) == 0)
			{
				switch(GetTargetHitTestCode(1))
				{
				case HTCAPTION:
					break;
				default:
					ClassNameFlag = FALSE;
					break;
				}
			}
			else if(lstrcmpi(Target[i].ClassName, TEXT("HitTestScrollBar")) == 0)
			{
				switch(GetTargetHitTestCode(1))
				{
				case HTHSCROLL:
				case HTVSCROLL:
					break;
				default:
					ClassNameFlag = FALSE;
					break;
				}
			}
			else if(lstrcmpi(Target[i].ClassName, TEXT("HitTestBorder")) == 0)
			{
				switch(GetTargetHitTestCode(1))
				{
				case HTBORDER:
				case HTBOTTOM:
				case HTBOTTOMLEFT:
				case HTBOTTOMRIGHT:
				case HTLEFT:
				case HTRIGHT:
				case HTTOP:
				case HTTOPLEFT:
				case HTTOPRIGHT:
					break;
				default:
					ClassNameFlag = FALSE;
					break;
				}
			}
			else if(lstrcmpi(Target[i].ClassName, TEXT("HitTestMenu")) == 0)
			{
				switch(GetTargetHitTestCode(1))
				{
				case HTMENU:
					break;
				default:
					ClassNameFlag = FALSE;
					break;
				}
			}
			else if(lstrcmpi(Target[i].ClassName, TEXT("HitTestListViewIcon")) == 0)
			{
				switch(GetTargetHitTestCode(2))
				{
				case LVHT_ONITEMICON:
				case LVHT_ONITEMLABEL:
				case LVHT_ONITEMSTATEICON:
					break;
				default:
					ClassNameFlag = FALSE;
					break;
				}
			}
			else if(lstrcmpi(Target[i].ClassName, TEXT("HitTestTreeViewIcon")) == 0)
			{
				switch(GetTargetHitTestCode(3))
				{
				case TVHT_ONITEMICON:
				case TVHT_ONITEMLABEL:
				case TVHT_ONITEMSTATEICON:
					break;
				default:
					ClassNameFlag = FALSE;
					break;
				}
			}
			else
			{
				GetClassName(hWnd, TClassName, MAX_CLASSNAME);
				if(lstrcmpi(TClassName, Target[i].ClassName) != 0)
					ClassNameFlag = FALSE;
			}
		}
		else if(Target[i].ClassName[0] && CornerMouse == TRUE)
		{
			ClassNameFlag = FALSE;
		}

		if(Target[i].ControlID[0] && CornerMouse == FALSE)
		{
			SetLastError(0);
			TargetID = GetWindowLongPtr(hWnd, GWLP_ID);
			if(TargetID != _ttoi(Target[i].ControlID) || GetLastError())
				ClassNameFlag = FALSE;
		}
		else if(Target[i].ControlID[0] && CornerMouse == TRUE)
		{
			TargetIDFlag = FALSE;
		}

		if(FileNameFlag == TRUE && ClassNameFlag == TRUE && TargetIDFlag == TRUE)
			FoundTargetNumber = i;
		i ++;
	}

	if(FoundTargetNumber == -1)
		FoundTargetNumber = (int)Target.size();

	return FoundTargetNumber;
}

void SetThruNumber(int TargetLocate, int *TargetNumber)
{
	int i, j;

	TargetNumber[0] = TargetLocate;

	for(i=1;i<=MAX_TARGET_THRU;i++)
	{
		if(TargetNumber[i-1] < (int)Target.size() && TargetNumber[i-1] >= 0)
		{
			switch(Target[TargetNumber[i-1]].DefaultThru)
			{
			case -1:
				TargetNumber[i] = -1;
				break;
			case 0:
				TargetNumber[i] = (int)Target.size();
				break;
			default:
				for(j=0;j<(int)Target.size();j++)
				{
					if(Target[TargetNumber[i-1]].DefaultThru == Target[j].Number)
						TargetNumber[i] = j;
				}
				break;
			}
		}
		else
		{
			TargetNumber[i] = -1;
		}
	}
}

int SearchAction(int FoundTargetNumber, int SearchCode)
{
	int i, j, k, l;
	int FoundActionNumber = -1;
	int TargetNumber[MAX_TARGET_THRU + 1];

	if(FoundTargetNumber == -1)
		return -1;

	SetThruNumber(FoundTargetNumber, TargetNumber);

	switch(SearchCode)
	{
	case 0:
		for(i=0;i<=MAX_TARGET_THRU;i++)
		{
			if(TargetNumber[i] >= 0 && FoundActionNumber < 0)
			{
				j = 0;
				while(j <= (int)Action.size()-1 && FoundActionNumber < 0 && TargetNumber[i] >= 0)
				{
					if(((TargetNumber[i] < (int)Target.size() && Action[j].TargetNumber == Target[TargetNumber[i]].Number) ||
						(TargetNumber[i] == (int)Target.size() && Action[j].TargetNumber == 0)) &&
						Action[j].Button == Gesture.Button &&
						(Action[j].Modifier & MODIFIER_DISABLE || Action[j].Modifier == Gesture.Modifier) &&
						Action[j].Repeat > 0)
					{
						FoundActionNumber = j;
						for(k=i-1;k>=0;k--)
						{
							if(TargetNumber[k] >= 0 && FoundActionNumber >= 0)
							{
								for(l=0;l<(int)Action.size();l++)
								{
									if(Action[l].TargetNumber == Target[TargetNumber[k]].Number &&
										Action[l].Button == Action[j].Button &&
										Action[l].Modifier == Action[j].Modifier &&
										Action[l].Move[0] == Action[j].Move[0] &&
										Action[l].Move[1] == Action[j].Move[1] &&
										Action[l].Move[2] == Action[j].Move[2] &&
										Action[l].Move[3] == Action[j].Move[3] &&
										Action[l].Move[4] == Action[j].Move[4] &&
										Action[l].Move[5] == Action[j].Move[5] &&
										Action[l].Move[6] == Action[j].Move[6] &&
										Action[l].Move[7] == Action[j].Move[7] &&
										Action[l].Move[8] == Action[j].Move[8] &&
										Action[l].Move[9] == Action[j].Move[9] &&
										Action[l].Repeat == 0)
										FoundActionNumber = -1;
								}
							}
						}
					}
					j ++;
				}
			}
		}
		break;
	case 1:
		for(i=0;i<=MAX_TARGET_THRU;i++)
		{
			if(TargetNumber[i] >= 0 && FoundActionNumber < 0)
			{
				j = 0;
				while(j <= (int)Action.size()-1 && FoundActionNumber < 0 && TargetNumber[i] >= 0)
				{
					if(((TargetNumber[i] < (int)Target.size() && Action[j].TargetNumber == Target[TargetNumber[i]].Number) ||
						(TargetNumber[i] == (int)Target.size() && Action[j].TargetNumber == 0)))
						if(Action[j].Button == Gesture.Button &&
							(Action[j].Modifier & MODIFIER_DISABLE || Action[j].Modifier == Gesture.Modifier) &&
							Action[j].Move[0] == Gesture.Move[0] &&
							Action[j].Move[1] == Gesture.Move[1] &&
							Action[j].Move[2] == Gesture.Move[2] &&
							Action[j].Move[3] == Gesture.Move[3] &&
							Action[j].Move[4] == Gesture.Move[4] &&
							Action[j].Move[5] == Gesture.Move[5] &&
							Action[j].Move[6] == Gesture.Move[6] &&
							Action[j].Move[7] == Gesture.Move[7] &&
							Action[j].Move[8] == Gesture.Move[8] &&
							Action[j].Move[9] == Gesture.Move[9])
							FoundActionNumber = j;
					j ++;
				}
			}
		}
		break;
	case 2://{^NbN݈̂ȊÕANVȂ
		for(i=0;i<=MAX_TARGET_THRU;i++)
		{
			if(TargetNumber[i] >= 0 && FoundActionNumber < 0)
			{
				j = 0;
				while(j <= (int)Action.size()-1 && FoundActionNumber < 0 && TargetNumber[i] >= 0)
				{
					if(((TargetNumber[i] < (int)Target.size() && Action[j].TargetNumber == Target[TargetNumber[i]].Number) ||
						(TargetNumber[i] == (int)Target.size() && Action[j].TargetNumber == 0)) &&
						Action[j].Button == Gesture.Button && Action[j].Move[0] != 0 &&
						(Action[j].Modifier & MODIFIER_DISABLE || Action[j].Modifier == Gesture.Modifier) &&
						Action[j].Repeat > 0)
					{
						FoundActionNumber = j;
						for(k=i-1;k>=0;k--)
						{
							if(TargetNumber[k] >= 0 && FoundActionNumber >= 0)
							{
								for(l=0;l<(int)Action.size();l++)
								{
									if(Action[l].TargetNumber == Target[TargetNumber[k]].Number &&
										Action[l].Button == Action[j].Button &&
										Action[l].Modifier == Action[j].Modifier &&
										Action[l].Move[0] == Action[j].Move[0] &&
										Action[l].Move[1] == Action[j].Move[1] &&
										Action[l].Move[2] == Action[j].Move[2] &&
										Action[l].Move[3] == Action[j].Move[3] &&
										Action[l].Move[4] == Action[j].Move[4] &&
										Action[l].Move[5] == Action[j].Move[5] &&
										Action[l].Move[6] == Action[j].Move[6] &&
										Action[l].Move[7] == Action[j].Move[7] &&
										Action[l].Move[8] == Action[j].Move[8] &&
										Action[l].Move[9] == Action[j].Move[9] &&
										Action[l].Repeat == 0)
										FoundActionNumber = -1;
								}
							}
						}
					}
					j ++;
				}
			}
		}
		break;
	}
	return FoundActionNumber;
}

BYTE GetGestureMove(int PosDiffx, int PosDiffy)
{
	int RealMove;

	if(GestureDirection == -4 && Gesture.Level > 0)
	{
		switch(Gesture.Move[0])
		{
		case MOVE_UP:
		case MOVE_DOWN:
		case MOVE_LEFT:
		case MOVE_RIGHT:
			if(abs(PosDiffx) < abs(PosDiffy))
			{
				if(PosDiffy < 0)
					RealMove = MOVE_UP;
				else
					RealMove = MOVE_DOWN;
			}
			else
			{
				if(PosDiffx < 0)
					RealMove = MOVE_LEFT;
				else
					RealMove = MOVE_RIGHT;
			}
			break;
		case MOVE_UPLEFT:
		case MOVE_UPRIGHT:
		case MOVE_DOWNLEFT:
		case MOVE_DOWNRIGHT:
			if(PosDiffy < 0)
			{
				if(PosDiffx < 0)
					RealMove = MOVE_UPLEFT;
				else
					RealMove = MOVE_UPRIGHT;
			} 
			else
			{
				if(PosDiffx < 0)
					RealMove = MOVE_DOWNLEFT;
				else
					RealMove = MOVE_DOWNRIGHT;
			} 
			break;
		}
	}
	else
	{
		if(abs(PosDiffx) < abs(PosDiffy))
		{
			if(PosDiffy < 0)
			{
				if((GestureDirection == 8 || GestureDirection == -4 || (GestureDirection == -8 && Gesture.Level <= 1)) && abs(PosDiffx) > abs(PosDiffy) / 2)
				{
					if(PosDiffx < 0)
						RealMove = MOVE_UPLEFT;
					else
						RealMove = MOVE_UPRIGHT;
					if(GestureDirection == -8 && Gesture.Level == 1 && Gesture.Move[0] != RealMove)
						RealMove = MOVE_UP;
				}
				else
				{
					RealMove = MOVE_UP;
				}
			}
			else
			{
				if((GestureDirection == 8 || GestureDirection == -4 || (GestureDirection == -8 && Gesture.Level <= 1)) && abs(PosDiffx) > abs(PosDiffy) / 2)
				{
					if(PosDiffx < 0)
						RealMove = MOVE_DOWNLEFT;
					else
						RealMove = MOVE_DOWNRIGHT;
					if(GestureDirection == -8 && Gesture.Level == 1 && Gesture.Move[0] != RealMove)
						RealMove = MOVE_DOWN;
				}
				else
				{
					RealMove = MOVE_DOWN;
				}
			}
		}
		else
		{
			if(PosDiffx < 0)
			{
				if((GestureDirection == 8 || GestureDirection == -4 || (GestureDirection == -8 && Gesture.Level <= 1)) && abs(PosDiffx) / 2 < abs(PosDiffy))
				{
					if(PosDiffy < 0)
						RealMove = MOVE_UPLEFT;
					else
						RealMove = MOVE_DOWNLEFT;
					if(GestureDirection == -8 && Gesture.Level == 1 && Gesture.Move[0] != RealMove)
						RealMove = MOVE_LEFT;
				}
				else
				{
					RealMove = MOVE_LEFT;
				}
			}
			else
			{
				if((GestureDirection == 8 || GestureDirection == -4 || (GestureDirection == -8 && Gesture.Level <= 1)) && abs(PosDiffx) / 2 < abs(PosDiffy))
				{
					if(PosDiffy < 0)
						RealMove = MOVE_UPRIGHT;
					else
						RealMove = MOVE_DOWNRIGHT;
					if(GestureDirection == -8 && Gesture.Level == 1 && Gesture.Move[0] != RealMove)
						RealMove = MOVE_RIGHT;
				}
				else
				{
					RealMove = MOVE_RIGHT;
				}
			}
		}
	}
	return RealMove;
}

void MyTaskTray(HWND hWnd)
{
	static NOTIFYICONDATA ni = {0};
	static HICON hIcon = NULL;

	if(hIcon==NULL)
		hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON2));

	if(hWnd != NULL)
	{
		ni.cbSize = sizeof(NOTIFYICONDATA);
		ni.hWnd = hWnd;
		ni.uID = ID_MYTRAY;
		ni.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		ni.uCallbackMessage = MYMSG_TRAY;
		ni.hIcon = hIcon;
		lstrcpyn(ni.szTip, OPENMAUSUJI_VERSION, 64);

		//http://support.microsoft.com/kb/418138/ja
		while(1)
		{
			if(Shell_NotifyIcon(NIM_ADD, &ni))
				break;

			if(GetLastError()==ERROR_TIMEOUT)
			{
				Sleep(500);
				if(Shell_NotifyIcon(NIM_MODIFY, &ni))
					break;
			}
			else
			{
				break;
			}
		}
	}
	else
	{
		Shell_NotifyIcon(NIM_DELETE, &ni);
		if(hIcon)
		{
			DestroyIcon(hIcon);
			hIcon = NULL;
		}
	}
}

int GetNaviHeight()
{
	HDC hdc;
	HGDIOBJ obj;
	SIZE size;

	hdc = GetDC(NULL);
	obj = SelectObject(hdc, hFont);
	GetTextExtentPoint32(hdc, TEXT("/"), 1, &size);
	SelectObject(hdc, obj);
	ReleaseDC(NULL, hdc);

	return size.cy;
}

void NaviPaint(HWND hWnd)
{
	HDC hdc;
	PAINTSTRUCT ps;
	HGDIOBJ obj;
	SIZE size;
	TCHAR NaviString[50 + MAX_COMMENT + 1];

	hdc = BeginPaint(hWnd, &ps);
	SetBkMode(hdc, TRANSPARENT);
	obj = SelectObject(hdc, hFont);
	SetTextColor(hdc, MainColor);
	TextOut(hdc, 3, 1, GestureString, lstrlen(GestureString));
	if(lstrlen(CommentString) > 0)
		wsprintf(NaviString, TEXT(" %s"), CommentString);
	else
		lstrcpy(NaviString, TEXT(""));
	GetTextExtentPoint32(hdc, GestureString, lstrlen(GestureString), &size);
	if(Gesture.Level >= 0 && Gesture.Level <= MAX_GESTURE_LEVEL &&
		Gesture.Move[0] != BUTTON_L && Gesture.Move[0] != BUTTON_M && Gesture.Move[0] != BUTTON_R &&
		Gesture.Move[0] != BUTTON_X1 && Gesture.Move[0] != BUTTON_X2 && ClickOnlyFlag == FALSE &&
		Gesture.Move[0] != WHEEL_UP && Gesture.Move[0] != WHEEL_DOWN && Gesture.Move[0] != WHEEL_LEFT && Gesture.Move[0] != WHEEL_RIGHT)
		SetTextColor(hdc, SubColor);
	TextOut(hdc, 3 + size.cx, 1, NaviString, lstrlen(NaviString));
	SelectObject(hdc, obj);
	EndPaint(hWnd, &ps);
}

void NaviRefresh(HWND hWnd)
{
	HDC hdc;
	HGDIOBJ obj;
	SIZE size;
	RECT NaviRect;
	POINT apos;
	TCHAR NaviString[50 + MAX_COMMENT + 1];
	int TempWidth;

	if(NaviType == 2 && ShowParam == FALSE && Gesture.Level >= 0)
		ShowParam = TRUE;

	if(NaviType == 1 || (NaviType == 2 && ShowParam == TRUE))
	{
		KillTimer(hWnd, ID_NAVITIMER);
		NaviDrawFlag = TRUE;
		GetWindowRect(hWnd, &NaviRect);
		if(lstrlen(CommentString) > 0)
			wsprintf(NaviString, TEXT("%s %s"), GestureString, CommentString);
		else
			lstrcpy(NaviString, GestureString);
		hdc = GetDC(NULL);
		obj = SelectObject(hdc, hFont);
		GetTextExtentPoint32(hdc, NaviString, lstrlen(NaviString), &size);
		SelectObject(hdc, obj);
		ReleaseDC(NULL, hdc);
		if(NaviWidth == 0)
		{
			if(size.cx > 0)
				TempWidth = size.cx + 7;
			else
				TempWidth = 0;
		}
		else
		{
			TempWidth = NaviWidth;
		}
		if(NaviType == 2)
		{
			GetCursorPos(&apos);
			if(apos.x + TipLocate.x + TempWidth > GetSystemMetrics(SM_CXVIRTUALSCREEN))
				NaviRect.left = GetSystemMetrics(SM_CXVIRTUALSCREEN) - TempWidth;
			else
				NaviRect.left = apos.x + TipLocate.x;
			if(apos.y + TipLocate.y + NaviHeight > GetSystemMetrics(SM_CYVIRTUALSCREEN))
				NaviRect.top = GetSystemMetrics(SM_CYVIRTUALSCREEN) - NaviHeight;
			else
				NaviRect.top = apos.y + TipLocate.y;
		}
		MoveWindow(hWnd, NaviRect.left, NaviRect.top, TempWidth, NaviHeight, TRUE);
		ShowWindow(hWnd, SW_SHOWNA);
		InvalidateRect(hWnd, NULL, TRUE);
	}
}

void ShowMauSujiNavi(HWND hWnd, BOOL Param)
{
	if(Param)
	{
		NaviRefresh(hWnd);
	}
	else
	{
		if(NaviType == 1)
			GetWindowPosition(hWnd, &MauSujiNavi);
		ShowWindow(hWnd, SW_HIDE);
	}
}

BOOL CALLBACK ShadeCheckProc(HWND hWnd, LPARAM lParam)
{
	RECT TargetRect;
	struct ShadeCheck *ShadeEnumCheck;
	int i;

	GetWindowRect(hWnd, &TargetRect);

	if(TargetRect.bottom-TargetRect.top <= GetSystemMetrics(SM_CYCAPTION) + (GetSystemMetrics(SM_CYFRAME) * 2))
	{
		for(i=0;i<MaxShadeWindow;i++)
		{
			ShadeEnumCheck = (struct ShadeCheck *)(lParam + sizeof(struct ShadeCheck) * i);
			if(ShadeEnumCheck->hWnd == hWnd)
				ShadeEnumCheck->CheckFlag = TRUE;
		}
	}
	return TRUE;
}

void SetShadeWindow(HWND hwTarget)
{
	RECT TargetRect;
	static struct ShadeCheck ShadeEnumCheck[MAX_SHADEWINDOW] = {0};
	int i, j, k;

	for(i=0;i<MaxShadeWindow;i++)
		ShadeEnumCheck[i].CheckFlag = FALSE;

	EnumWindows(ShadeCheckProc, (LPARAM)&ShadeEnumCheck);

	j = 0;
	for(i=0;i<MaxShadeWindow;i++)
	{
		if(ShadeEnumCheck[j].CheckFlag == FALSE)
		{
			for(k=j+1;k<MaxShadeWindow;k++)
				ShadeEnumCheck[k-1] = ShadeEnumCheck[k];
		}
		else
		{
			j++;
		}
	}
	MaxShadeWindow = j;

	for(i=0;i<MaxShadeWindow;i++)
	{
		if(hwTarget == ShadeEnumCheck[i].hWnd)
		{
			//VF[hI
			GetWindowRect(hwTarget, &TargetRect);
			SetWindowPos(hwTarget, NULL, NULL, NULL, TargetRect.right-TargetRect.left, abs(ShadeEnumCheck[i].Height), SWP_SHOWWINDOW|SWP_NOMOVE|SWP_NOZORDER);
			if(ShadeEnumCheck[i].Height < 0)
				SendMessage(hwTarget, WM_SYSCOMMAND, SC_MAXIMIZE, 0);	//ő剻
			ShadeEnumCheck[i].hWnd = NULL;
			j --;
		}
	}

	if(MaxShadeWindow == j && MaxShadeWindow < MAX_SHADEWINDOW)
	{
		//VF[h
		if(GetWindowLongPtr(hwTarget, GWL_STYLE) & WS_MAXIMIZE)
		{
			//ő剻Ă猳̃TCYɖ߂
			SendMessage(hwTarget, WM_SYSCOMMAND, SC_RESTORE, 0);
			//VF[hO̍LĂ
			GetWindowRect(hwTarget, &TargetRect);
			ShadeEnumCheck[MaxShadeWindow].Height = TargetRect.top - TargetRect.bottom;
		}
		else
		{
			//VF[hO̍LĂ
			GetWindowRect(hwTarget, &TargetRect);
			ShadeEnumCheck[MaxShadeWindow].Height = TargetRect.bottom - TargetRect.top;
		}
		//VF[hJn
		SetWindowLongPtr(hwTarget, GWL_STYLE, GetWindowLongPtr(hwTarget, GWL_STYLE) & ~WS_MAXIMIZE);
		RedrawWindow(hwTarget, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
		SetWindowPos(hwTarget, NULL, NULL, NULL, TargetRect.right-TargetRect.left, GetSystemMetrics(SM_CYCAPTION) + (GetSystemMetrics(SM_CYFRAME) * 2), SWP_SHOWWINDOW|SWP_NOMOVE|SWP_NOZORDER);
		//VF[hEBhEnhLĂ
		ShadeEnumCheck[MaxShadeWindow].hWnd = hwTarget;
		MaxShadeWindow ++;
	}
}

BOOL CALLBACK SearchCommandTargetProc(HWND hWnd, LPARAM lParam)
{
	TCHAR ClassName[MAX_CLASSNAME + 1];
	struct SearchChildInfo *TargetInfo;
	TargetInfo = (struct SearchChildInfo *)lParam;
	int ClassFlag = 0x00000000;

	if(TargetInfo->ClassFlag & 0x00000001)
	{
		GetClassName(hWnd, ClassName, MAX_CLASSNAME);
		if(lstrcmpi(TargetInfo->ClassName, ClassName) == 0)
			ClassFlag = ClassFlag | 0x00000001;
	}
	if(TargetInfo->ClassFlag & 0x00000002)
	{
		SetLastError(0);
		if(GetWindowLongPtr(hWnd, GWLP_ID) == TargetInfo->ControlID && !GetLastError())
			ClassFlag = ClassFlag | 0x00000002;
	}
	if(TargetInfo->ClassFlag == ClassFlag)
	{
		TargetInfo->hwTarget = hWnd;
	}
	return !TargetInfo->hwTarget;
}

HWND SearchCommandTarget(int CommandTarget)
{
	int i;
	TCHAR FilePath[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1], Tdrive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1], Tdir[_MAX_DIR + 1];
	TCHAR fname[_MAX_FNAME + 1], Tfname[_MAX_FNAME + 1];
	TCHAR fext[_MAX_EXT + 1], Tfext[_MAX_EXT + 1];
	TCHAR TFileName[_MAX_PATH + 1];
	HWND hWnd;
	struct SearchChildInfo TargetInfo = {0, NULL, TEXT(""), 0};

	for ( i = 0; i < (int)Target.size(); i++ )
	{
		if(Target[i].Number == CommandTarget)
		{
			lstrcpy(TFileName, Target[i].FileName);
			_tsplitpath_s( TFileName, Tdrive, _MAX_DRIVE, Tdir, _MAX_DIR, Tfname, _MAX_FNAME, Tfext, _MAX_EXT );
			if(Target[i].ClassName[0])
			{
				lstrcpy(TargetInfo.ClassName, Target[i].ClassName);
				TargetInfo.ClassFlag = TargetInfo.ClassFlag | 0x00000001;
			}
			if(Target[i].ControlID[0])
			{
				TargetInfo.ControlID = _ttoi(Target[i].ControlID);
				TargetInfo.ClassFlag = TargetInfo.ClassFlag | 0x00000002;
			}
		}
	}

	if(TFileName[0])
	{
		if(lstrcmpi(TFileName, TEXT("Desktop")) == 0)
		{
			TargetInfo.hwTarget = GetDesktopWindowHandle();
		}
		else
		{
			hWnd = GetTopWindow(NULL);
			while(TargetInfo.hwTarget == NULL && hWnd != NULL)
			{
				GetFileNameFromHwnd(hWnd, FilePath, _MAX_PATH);
				_tsplitpath_s( FilePath, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, fext, _MAX_EXT );
				if((lstrcmp(Tdrive, TEXT("")) == 0 || lstrcmpi(Tdrive, drive) == 0) &&
					(lstrcmp(Tdir, TEXT("")) == 0 || lstrcmpi(Tdir, dir) == 0) &&
					(lstrcmpi(Tfname, fname) == 0 && lstrcmpi(fext, Tfext) == 0) &&
					GetParent(hWnd) == NULL)
				{
					if(TargetInfo.ClassFlag != 0)
						EnumChildWindows(hWnd, SearchCommandTargetProc, (LPARAM)&TargetInfo);
					else
						TargetInfo.hwTarget = hWnd;
				}
				hWnd = GetNextWindow(hWnd, GW_HWNDNEXT);
			}
		}
	}
	return TargetInfo.hwTarget;
}

void ImplementCommand(HWND hWnd, int FoundActionNumber, BOOL FinishAction)
{
	static int FinishCommandNumber = 0;
	HWND hwTarget;
	RECT TargetRect;
	int TargetSizeX, TargetSizeY;
	HGLOBAL hMem;
	TCHAR *p;
	TCHAR TargetDirectory[_MAX_PATH + 1], TargetFileName[_MAX_PATH + 1], TempMainText[_MAX_PATH + 1], TempSubText[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];
	UINT Message;
	TCHAR *HexEnd;
	WPARAM wParam;
	LPARAM lParam;
	int i, j;

	if(FinishAction == FALSE)
		i = Action[FoundActionNumber].BreakPoint;
	else
		i = FinishCommandNumber;
	Action[FoundActionNumber].BreakPoint = 0;
	FinishActionNumber = -1;
	FinishCommandNumber = 0;

	while(i < Action[FoundActionNumber].Repeat && Action[FoundActionNumber].BreakPoint == 0)
	{
		switch(Action[FoundActionNumber].CommandTarget[i])
		{
		case -1:
			hwTarget = GetRootWindow(GetTargetHandle());
			break;
		case 0:
			hwTarget = GetRootWindow(GetForegroundWindow());
			break;
		default:
			hwTarget = SearchCommandTarget(Action[FoundActionNumber].CommandTarget[i]);
			break;
		}
		switch ( Action[FoundActionNumber].Case[i] )
		{
		case 10:
		case 11:
		case 12:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			ExecuteSendKey( Action[FoundActionNumber].Case[i], Action[FoundActionNumber].Key[i] );
			break;
		case 20:
			if(FinishCommandNumber > 0 || hwTarget == NULL)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			PostMessage( hwTarget, WM_COMMAND, Action[FoundActionNumber].Key[i], 0 );
			break;
		case 25:
			hMem = GlobalAlloc(GHND, (lstrlen(CommandExt[Action[FoundActionNumber].Key[i]].MainText) + 1)*sizeof(TCHAR));
			p = (TCHAR*)GlobalLock(hMem);
			lstrcpy(p, CommandExt[Action[FoundActionNumber].Key[i]].MainText);
			GlobalUnlock(hMem);
			OpenClipboard(NULL);
			EmptyClipboard();
			SetClipboardData(CF_UNICODETEXT, hMem);
			CloseClipboard();
			break;
		case 30:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			_tsplitpath_s(CommandExt[Action[FoundActionNumber].Key[i]].MainText, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);
			_tmakepath_s(TargetDirectory, _MAX_PATH, drive, dir, NULL, NULL);
			if(ShellExecute(NULL, NULL, CommandExt[Action[FoundActionNumber].Key[i]].MainText, CommandExt[Action[FoundActionNumber].Key[i]].SubText, TargetDirectory ,SW_SHOWDEFAULT) <= (HINSTANCE)32)
			{
				GetCurrentDirectory(_MAX_PATH, TempSubText);//JgfBNgۑ
				GetModuleFileName(NULL, TempMainText, _MAX_PATH);
				_tsplitpath_s(TempMainText, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);
				wsprintf(TempMainText, TEXT("%s%s"), drive, dir, NULL);
				SetCurrentDirectory(TempMainText);
				_tfullpath(TargetFileName, CommandExt[Action[FoundActionNumber].Key[i]].MainText, _MAX_PATH); 
				SetCurrentDirectory(TempSubText);//JgfBNgɖ߂
				ShellExecute(NULL, NULL, TargetFileName, CommandExt[Action[FoundActionNumber].Key[i]].SubText, TargetDirectory, SW_SHOWDEFAULT);
			};
			break;
		case 35:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			PlaySound(CommandExt[Action[FoundActionNumber].Key[i]].MainText, NULL, SND_ASYNC);
			break;
		case 40:
			if(FinishCommandNumber > 0 || hwTarget == NULL)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			switch ( Action[FoundActionNumber].Key[i] )
			{
			case 0:
				SetWindowPos( hwTarget, HWND_TOP, NULL, NULL, NULL, NULL, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
				break;
			case 1:
				SetWindowPos( hwTarget, HWND_BOTTOM, NULL, NULL, NULL, NULL, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
				break;
			case 2:
				SetWindowPos( hwTarget, HWND_TOPMOST, NULL, NULL, NULL, NULL, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
				break;
			case 3:
				SetWindowPos( hwTarget, HWND_NOTOPMOST, NULL, NULL, NULL, NULL, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
				break;
			case 4:
				if(GetWindowLongPtr(hwTarget, GWL_EXSTYLE) & WS_EX_TOPMOST)
					SetWindowPos( hwTarget, HWND_NOTOPMOST, NULL, NULL, NULL, NULL, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
				else
					SetWindowPos( hwTarget, HWND_TOPMOST, NULL, NULL, NULL, NULL, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE );
				break;
			case 5:
				PostMessage( hwTarget, WM_SYSCOMMAND, SC_RESTORE, 0);
				break;
			case 6:
				PostMessage( hwTarget, WM_SYSCOMMAND, SC_MINIMIZE, 0);
				break;
			case 7:
				PostMessage( hwTarget, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
				break;
			case 8:
				PostMessage( hwTarget, WM_SYSCOMMAND, SC_CLOSE, 0);
				break;
			case 9:
				if(GetWindowLongPtr(hwTarget, GWL_STYLE) & WS_MINIMIZE)
					PostMessage( hwTarget, WM_SYSCOMMAND, SC_RESTORE, 0);
				else
					PostMessage( hwTarget, WM_SYSCOMMAND, SC_MINIMIZE, 0);
				break;
			case 10:
				if(GetWindowLongPtr(hwTarget, GWL_STYLE) & WS_MAXIMIZE)
					PostMessage( hwTarget, WM_SYSCOMMAND, SC_RESTORE, 0);
				else
					PostMessage( hwTarget, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
				break;
			case 11:
				if(GetWindowLongPtr(hwTarget, GWL_STYLE) & WS_MAXIMIZE)
					PostMessage( hwTarget, WM_SYSCOMMAND, SC_MINIMIZE, 0);
				else
					PostMessage( hwTarget, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
				break;
			case 12:
				SetShadeWindow(hwTarget);
				break;
			}
			break;
		case 41:
			if(FinishCommandNumber > 0 || hwTarget == NULL)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			SetWindowLongPtr(hwTarget, GWL_STYLE, GetWindowLongPtr(hwTarget, GWL_STYLE) & ~WS_MAXIMIZE);
			GetWindowRect(hwTarget, &TargetRect);
			TargetSizeX = (SHORT)HIWORD(Action[FoundActionNumber].Key[i]);
			if(TargetSizeX < 0)
				TargetSizeX = TargetRect.right - TargetRect.left;
			TargetSizeY = (SHORT)LOWORD(Action[FoundActionNumber].Key[i]);
			if(TargetSizeY < 0)
				TargetSizeY = TargetRect.bottom - TargetRect.top;
			SetWindowPos( hwTarget, NULL, NULL, NULL, TargetSizeX, TargetSizeY, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOZORDER );
			break;
		case 42:
			if(FinishCommandNumber > 0 || hwTarget == NULL)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			SetWindowLongPtr(hwTarget, GWL_STYLE, GetWindowLongPtr(hwTarget, GWL_STYLE) & ~WS_MAXIMIZE);
			SetWindowPos( hwTarget, NULL, (SHORT)HIWORD(Action[FoundActionNumber].Key[i]), (SHORT)LOWORD(Action[FoundActionNumber].Key[i]), NULL, NULL, SWP_SHOWWINDOW | SWP_NOSIZE | SWP_NOZORDER );
			break;
		case 50:
			if(FinishCommandNumber > 0 || hwTarget == NULL)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			if((Action[FoundActionNumber].Key[i] == 0 || GetWindowLongPtr(hwTarget, GWL_EXSTYLE) & WS_EX_LAYERED) &&
				!(Action[FoundActionNumber].Key[i] < 0))
			{
				SetWindowLongPtr(hwTarget, GWL_EXSTYLE, GetWindowLongPtr(hwTarget, GWL_EXSTYLE) & ~WS_EX_LAYERED);
				SetLayeredWindowAttributes(hwTarget, 0, 255, LWA_ALPHA);
				RedrawWindow(hwTarget, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
			}
			else
			{
				SetWindowLongPtr(hwTarget, GWL_EXSTYLE, GetWindowLongPtr(hwTarget, GWL_EXSTYLE) | WS_EX_LAYERED);
				SetLayeredWindowAttributes(hwTarget, 0, 255 - (249 * (BYTE)Action[FoundActionNumber].Key[i] / 100), LWA_ALPHA);
			}
			break;
		case 55:
			if(FinishCommandNumber > 0 || hwTarget == NULL)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			GetWindowRect(hwTarget, &TargetRect);
			SetCursorPos((SHORT)HIWORD(Action[FoundActionNumber].Key[i]) + TargetRect.left,
				(SHORT)LOWORD(Action[FoundActionNumber].Key[i]) + TargetRect.top);
			break;
		case 58:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			SetCursorPos((SHORT)HIWORD(Action[FoundActionNumber].Key[i]) + StartPos.x,
				(SHORT)LOWORD(Action[FoundActionNumber].Key[i]) + StartPos.y);
			break;
		case 59:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			SetCursorPos((SHORT)HIWORD(Action[FoundActionNumber].Key[i]) + FinishPos.x,
				(SHORT)LOWORD(Action[FoundActionNumber].Key[i]) + FinishPos.y);
			break;
		case 60:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			switch(abs((SHORT)HIWORD(Action[FoundActionNumber].Key[i])) - 1)
			{
			case SB_PAGELEFT:
			case SB_PAGERIGHT:
				if((SHORT)HIWORD(Action[FoundActionNumber].Key[i]) > 0)
					PostMessage(GetTargetHandle(), WM_VSCROLL, abs((SHORT)HIWORD(Action[FoundActionNumber].Key[i])) - 1, (LPARAM)SearchScrollBar(GetTargetHandle(), SBS_VERT));
				else
					PostMessage(GetTargetHandle(), WM_HSCROLL, abs((SHORT)HIWORD(Action[FoundActionNumber].Key[i])) - 1, (LPARAM)SearchScrollBar(GetTargetHandle(), SBS_HORZ));
				break;
			case SB_LINELEFT:
			case SB_LINERIGHT:
				for(j = 0; j < LOWORD(Action[FoundActionNumber].Key[i]); j++)
				{
					if((SHORT)HIWORD(Action[FoundActionNumber].Key[i]) > 0)
						PostMessage(GetTargetHandle(), WM_VSCROLL, abs((SHORT)HIWORD(Action[FoundActionNumber].Key[i])) - 1, (LPARAM)SearchScrollBar(GetTargetHandle(), SBS_VERT));
					else
						PostMessage(GetTargetHandle(), WM_HSCROLL, abs((SHORT)HIWORD(Action[FoundActionNumber].Key[i])) - 1, (LPARAM)SearchScrollBar(GetTargetHandle(), SBS_HORZ));
				}
				break;
			}
			break;
		case 65:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			SetMouseScroll((SHORT)HIWORD(Action[FoundActionNumber].Key[i]), (SHORT)LOWORD(Action[FoundActionNumber].Key[i]));
			break;
		case 70:
		case 71:
			if(FinishCommandNumber > 0)
				break;
			Sleep( Action[FoundActionNumber].Wait[i] );
			if(CommandExt[Action[FoundActionNumber].Key[i]].MainKey < 100)
			{
				switch(Action[FoundActionNumber].CommandTarget[i])
				{
				case -1:
					hwTarget = GetTargetHandle();
					break;
				case 0:
					hwTarget = GetWindowFocus(GetForegroundWindow());
					break;
				default:
					hwTarget = SearchCommandTarget(Action[FoundActionNumber].CommandTarget[i]);
					break;
				}
			}
			switch(CommandExt[Action[FoundActionNumber].Key[i]].MainKey)
			{
			case 0:
			case 100:
				Message = _ttoi(CommandExt[Action[FoundActionNumber].Key[i]].MainText);
				break;
			case 1:
			case 101:
				Message = _tcstoul(CommandExt[Action[FoundActionNumber].Key[i]].MainText, &HexEnd, 16);
				break;
			case 2:
			case 102:
				Message = RegisterWindowMessage(CommandExt[Action[FoundActionNumber].Key[i]].MainText);
				break;
			}
			switch(CommandExt[Action[FoundActionNumber].Key[i]].SubKey)
			{
			case 0:
				wParam = _ttoi(CommandExt[Action[FoundActionNumber].Key[i]].SubText);
				break;
			case 1:
				wParam = _tcstoul(CommandExt[Action[FoundActionNumber].Key[i]].SubText, &HexEnd, 16);
				break;
			case 2:
				wParam = (WPARAM)CommandExt[Action[FoundActionNumber].Key[i]].SubText;
				break;
			}
			switch(CommandExt[Action[FoundActionNumber].Key[i]].Sub2Key)
			{
			case 0:
				lParam = _ttoi(CommandExt[Action[FoundActionNumber].Key[i]].Sub2Text);
				break;
			case 1:
				lParam = _tcstoul(CommandExt[Action[FoundActionNumber].Key[i]].Sub2Text, &HexEnd, 16);
				break;
			case 2:
				lParam = (LPARAM)CommandExt[Action[FoundActionNumber].Key[i]].Sub2Text;
				break;
			}
			if(Action[FoundActionNumber].Case[i] == 70)
				SendMessage(hwTarget, Message, wParam, lParam);
			else
				PostMessage(hwTarget, Message, wParam, lParam);
			break;
		case 99:
			if(FinishCommandNumber > 0)
				break;
			PostMessage(hWnd, WM_COMMAND, IDM_SHOWDIALOG, 0);
			break;
		case 95:
			Action[FoundActionNumber].BreakPoint = i + 1;
			break;
		case 96:
			if(FinishAction == TRUE)
				break;
			FinishActionNumber = FoundActionNumber;
			FinishCommandNumber = i + 1;
			break;
		}
		i++;
	}
}

void InsertTargetItem(HWND hLVT, int intIndex, int Insert)
{
	TCHAR FileName[_MAX_PATH + 1], ClassName[_MAX_PATH + 1];
	TCHAR fname[_MAX_FNAME + 1];
	TCHAR fext[_MAX_EXT + 1];

	LV_ITEM item;

	item.mask = LVIF_TEXT;
	if(intIndex == (int)Target.size())
	{
		lstrcpy(FileName, TEXT("Default"));
	}
	else
	{
		_tsplitpath_s( Target[intIndex].FileName, NULL, 0, NULL, 0, fname, _MAX_FNAME, fext, _MAX_EXT );
		_tmakepath_s( FileName, _MAX_PATH, NULL, NULL, fname, fext );

		if(Target[intIndex].Comment[0])
		{
			lstrcpyn(FileName, Target[intIndex].Comment, 100);
		}
		else
		{
			lstrcpyn(FileName, FileName, 100);
			lstrcpyn(ClassName, Target[intIndex].ClassName, 100);
			if(Target[intIndex].FileName[0] == 0 && Target[intIndex].ClassName[0])
			{
				lstrcpy(FileName, TEXT("--- "));
				lstrcat(FileName, ClassName);
			}
			else
			{
				lstrcat(FileName, TEXT(" "));
				lstrcat(FileName, ClassName);
			}
		}
	}
	item.pszText = FileName;
	item.iItem = intIndex;
	item.iSubItem = 0;
	if(ListView_GetItemCount(hLVT) - 1 > intIndex && Insert == 0)
		ListView_SetItem(hLVT, &item);
	else
		ListView_InsertItem(hLVT, &item);
}

void InsertActionItem(HWND hLVA, int i, int intIndex)
{
	int j;
	TCHAR Code[70 + MAX_COMMENT + 1] = TEXT("No Modifier "), MoveS[12];
	LV_ITEM item;

	get_modifiername(Action[i].Modifier, Code, 70+MAX_COMMENT+1);
	GestureToString(Action[i].Button, MoveS, 12);
	lstrcat( Code, MoveS );
	for(j=0; j<MAX_GESTURE_LEVEL; j++)
	{
		if(Action[i].Move[j] != 0)
		{
			GestureToString(Action[i].Move[j], MoveS, 12);
			lstrcat( Code, MoveS );
		}
	}
	lstrcat( Code, TEXT("  ") );
	lstrcat( Code, Action[i].Comment );

	item.mask = LVIF_TEXT;
	item.pszText = Code;
	item.iItem = intIndex;
	item.iSubItem = 0;
	if(ListView_GetItemCount(hLVA) > intIndex)
		ListView_SetItem(hLVA, &item);
	else
		ListView_InsertItem(hLVA, &item);
}

void InsertCommandItem(HWND hLVC, int Case, LONG Key, int intIndex, int Insert)
{
	int FoundCaseNumber = 0, i;
	TCHAR CaseText[30],LVCommandText[_MAX_PATH + 1];
	TCHAR fname[_MAX_FNAME + 1], fext[_MAX_EXT + 1];

	for(i=0; i<MAX_ACTION_CASE; i++)
		if(CommandList[i].Number == Case)
			FoundCaseNumber = i;
	lstrcpy(CaseText, CommandList[FoundCaseNumber].Name);
	switch(Case)
	{
	case 10:
	case 11:
	case 12:
		get_keyname(Key, LVCommandText, _MAX_PATH+1);
		break;
	case 20:
		_itot_s(Key, LVCommandText, _MAX_PATH, 10);
		break;
	case 25:
		lstrcpy(LVCommandText, CommandExt[Key].MainText);
		break;
	case 30:
	case 35:
		_tsplitpath_s( CommandExt[Key].MainText, NULL, 0, NULL, 0, fname, _MAX_FNAME, fext, _MAX_EXT );
		_tmakepath_s( LVCommandText, _MAX_PATH, NULL, NULL, fname, fext );
		break;
	case 40:
		for(i=0; i<MAX_ZORDER; i++)
			if(ZorderList[i].Number == Key)
				lstrcpy(LVCommandText, ZorderList[i].Name);
		break;
	case 41:
	case 42:
	case 55:
	case 58:
	case 59:
		wsprintf(LVCommandText, TEXT("X : %d  Y : %d"), (SHORT)HIWORD(Key), (SHORT)LOWORD(Key));
		break;
	case 50:
		_itot_s(abs(Key), LVCommandText, _MAX_PATH, 10);
		break;
	case 60:
		if((SHORT)HIWORD(Key) > 0)
			lstrcpy(LVCommandText, TEXT("c"));
		else
			lstrcpy(LVCommandText, TEXT(""));
		switch(abs((SHORT)HIWORD(Key)) - 1)
		{
		case SB_PAGELEFT:
			lstrcat(LVCommandText, TEXT("  -1 Page"));
			break;
		case SB_PAGERIGHT:
			lstrcat(LVCommandText, TEXT("  1 Page"));
			break;
		case SB_LINELEFT:
			wsprintf(LVCommandText, TEXT("%s  -%d Line"), LVCommandText, LOWORD(Key));
			break;
		case SB_LINERIGHT:
			wsprintf(LVCommandText, TEXT("%s  %d Line"), LVCommandText, LOWORD(Key));
			break;
		}
		break;
	case 65:
		wsprintf(LVCommandText, TEXT("Line : %d  Page : %d"), (SHORT)HIWORD(Key), (SHORT)LOWORD(Key));
		break;
	case 70:
	case 71:
		lstrcpy(LVCommandText, CommandExt[Key].MainText);
		lstrcat(LVCommandText, TEXT(","));
		lstrcat(LVCommandText, CommandExt[Key].SubText);
		lstrcat(LVCommandText, TEXT(","));
		lstrcat(LVCommandText, CommandExt[Key].Sub2Text);
		break;
	default:
		lstrcpy(LVCommandText, TEXT(""));
		break;
	}

	LV_ITEM item;

	item.mask = LVIF_TEXT;
	item.pszText = CaseText;
	item.iItem = intIndex;
	item.iSubItem = 0;
	if(ListView_GetItemCount(hLVC) > intIndex && Insert == 0)
		ListView_SetItem(hLVC, &item);
	else
		ListView_InsertItem(hLVC, &item);

	item.pszText = LVCommandText;
	item.iItem = intIndex;
	item.iSubItem = 1;
	ListView_SetItem(hLVC, &item);
}

void InitializeLVT(HWND hLVT)
{
	RECT rc;
	LV_COLUMN lvcol;

	GetClientRect(hLVT, &rc);

	lvcol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcol.fmt = LVCFMT_LEFT;

	lvcol.cx = rc.right - GetSystemMetrics(SM_CXVSCROLL) - 2;
	lvcol.pszText = TEXT("Target");
	lvcol.iSubItem = 0;
	ListView_InsertColumn(hLVT, 0, &lvcol);
}

void InitializeLVA(HWND hLVA)
{
	RECT rc;
	LV_COLUMN lvcol;

	GetClientRect(hLVA, &rc);

	lvcol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcol.fmt = LVCFMT_LEFT;

	lvcol.cx = rc.right - GetSystemMetrics(SM_CXVSCROLL) - 2;
	lvcol.pszText = TEXT("Action");
	lvcol.iSubItem = 0;
	ListView_InsertColumn(hLVA, 0, &lvcol);
}

void InitializeLVC(HWND hLVC)
{
	RECT rc;
	LV_COLUMN lvcol;

	GetClientRect(hLVC, &rc);

	lvcol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcol.fmt = LVCFMT_LEFT;

	lvcol.cx = (rc.right - GetSystemMetrics(SM_CXVSCROLL) - 2) / 2;
	lvcol.pszText = TEXT("Case");
	lvcol.iSubItem = 0;
	ListView_InsertColumn(hLVC, 0, &lvcol);

	lvcol.cx = (rc.right - GetSystemMetrics(SM_CXVSCROLL) - 2) / 2;
	lvcol.pszText = TEXT("Value");
	lvcol.iSubItem = 1;
	ListView_InsertColumn(hLVC, 1, &lvcol);
}

UINT SendKeyCheck(UINT KeyCode)
{
	UINT modifiers = 0;

	if(KeyCode == VK_RWIN)
		KeyCode = VK_LWIN;
	if(GetKeyState( VK_SHIFT ) & 0x8000 && KeyCode != VK_SHIFT)
		modifiers |= HOTKEYF_SHIFT;
	if(GetKeyState( VK_CONTROL ) & 0x8000 && KeyCode != VK_CONTROL)
		modifiers |= HOTKEYF_CONTROL;
	if(GetKeyState( VK_MENU ) & 0x8000 && KeyCode != VK_MENU)
		modifiers |= HOTKEYF_ALT;
	if((GetKeyState( VK_LWIN ) & 0x8000 || GetKeyState( VK_RWIN ) & 0x8000) && KeyCode != VK_LWIN)
		modifiers |= HOTKEYF_WIN;

	return MAKEWORD(KeyCode, modifiers);
}

void EnableCommandEdit(HWND hDlg, int Case)
{
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_SENDKEY),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_SENDKEY),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BUTTONCODE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_BUTTONCODE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_BUTTONCAPTURE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COPY),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_COPY),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_FILEPATH),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FULLPATH),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_FILEPATH),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILESEARCH),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_CMDLINE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_CMDLINE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ZORDER),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_ZORDER),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POS),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POSX),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POSY),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_POSX),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_POSY),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_WINDOWCAPTURE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ALPHA1),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ALPHA2),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ALPHA3),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_ALPHA),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_SCROLLBAR_ALPHA),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_CHECK_ALPHA),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_SCROLL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_SCROLL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_SCROLLBAR_SCROLL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_SCROLL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_MESSAGE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_MESSAGE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_MESSAGE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_WPARAM),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_WPARAM),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_WPARAM),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LPARAM),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_LPARAM),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_LPARAM),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_CHECK_CONTROL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COMMANDTARGET),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO_COMMANDTARGET),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_S_SCROLL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_S_SCROLLLINE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_S_SCROLLLINE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STATIC_S_SCROLLPAGE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_S_SCROLLPAGE),FALSE);
	switch(Case)
	{
	case 10:
	case 11:
	case 12:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_SENDKEY),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_SENDKEY),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_COMBO_SENDKEY));
		break;
	case 20:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BUTTONCODE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_BUTTONCODE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_BUTTONCAPTURE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COMMANDTARGET),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_COMMANDTARGET),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_BUTTONCODE));
		break;
	case 25:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COPY),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_COPY),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_COPY));
		break;
	case 30:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_FILEPATH),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FULLPATH),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_FILEPATH),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILESEARCH),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_CMDLINE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_CMDLINE),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_FILEPATH));
		break;
	case 35:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_FILEPATH),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_FILEPATH),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILESEARCH),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_FILEPATH));
		break;
	case 40:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ZORDER),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_ZORDER),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COMMANDTARGET),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_COMMANDTARGET),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_COMBO_ZORDER));
		break;
	case 41:
	case 42:
	case 55:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POS),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POSX),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POSY),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_POSX),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_POSY),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_WINDOWCAPTURE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COMMANDTARGET),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_COMMANDTARGET),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_POSX));
		break;
	case 58:
	case 59:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POS),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POSX),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_POSY),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_POSX),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_POSY),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_POSX));
		break;
	case 50:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ALPHA1),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ALPHA2),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ALPHA3),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_ALPHA),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_SCROLLBAR_ALPHA),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_CHECK_ALPHA),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COMMANDTARGET),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_COMMANDTARGET),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_SCROLLBAR_ALPHA));
		break;
	case 60:
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_SCROLL),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_SCROLL),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_SCROLLBAR_SCROLL),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_SCROLL),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_SCROLLBAR_SCROLL));
		break;
	case 65:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_S_SCROLL),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_S_SCROLLLINE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_S_SCROLLLINE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_S_SCROLLPAGE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_S_SCROLLPAGE),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_STATIC_S_SCROLLLINE));
		break;
	case 70:
	case 71:
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_MESSAGE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_MESSAGE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_MESSAGE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_WPARAM),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_WPARAM),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_WPARAM),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LPARAM),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_LPARAM),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_LPARAM),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_STATIC_COMMANDTARGET),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_COMBO_COMMANDTARGET),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_CHECK_CONTROL),TRUE);
		SetFocus(GetDlgItem(hDlg,IDC_EDIT_MESSAGE));
		break;
	}
}

//R}hݒ_CAO
INT_PTR CALLBACK CommandDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static struct Command *CommandEdit;
	#define NG_KEY 94
	int NG_KeyCode[NG_KEY] = {0x07, 0x0A, 0x0B, 0x0C, 0x0E, 0x0F, 0x15, 0x16, 
		0x17, 0x18, 0x1A, 0x1E, 0x1F, 0x29, 0x2A, 0x2B, 0x2F, 0x3A, 0x3B, 0x3C,
		0x3D, 0x3E, 0x3F, 0x40, 0x5C, 0x5E, 0x7C, 0x7D, 0x7E, 0x7F, 0x80,
		0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D,
		0x8E, 0x8F, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9A, 0x9B, 0x9C,
		0x9D, 0x9E, 0x9F, 0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xB8, 0xB9,
		0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD,
		0xCE, 0xCF, 0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA};
	TCHAR FilePath[_MAX_PATH + 1];
	int i, j, FindCaseNumber, ComboKeyNumber = 0;
	BOOL KeyNG;
	static UINT SendKeyCode;
	static int AlphaScrPos, AlphaScrMax = 100, AlphaScrMin = 0;
	static int ScrollScrPos, ScrollScrMax = 21, ScrollScrMin = -21;
	TCHAR EditString[20], WaitString[10], KeyName[_MAX_PATH + 1];
	TCHAR TempMainText[_MAX_PATH + 1], TempSubText[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1], dir[_MAX_DIR + 1];
	struct CommandExtInfo c = {0};
	UINT ComboKeyTable[0xDD];

	switch (msg)
	{
	case WM_INITDIALOG:
		SetWindowPos( hDlg, NULL, CommandDialog.x, CommandDialog.y, NULL, NULL, SWP_NOSIZE | SWP_NOZORDER );
		SetSendKeyComboHook(hDlg, GetWindow(GetDlgItem(hDlg, IDC_COMBO_SENDKEY), GW_CHILD));
		CommandEdit = (struct Command *)lParam;
		SendKeyCode = NULL;
		FindCaseNumber = 0;
		for ( i = 0; i < MAX_ACTION_CASE; i++ )
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_INSERTSTRING, (WPARAM)i, (LPARAM)CommandList[i].Name);
			if(CommandEdit->Case[CommandEdit->Locate] == CommandList[i].Number)
				FindCaseNumber = i;
		}
		for ( i = 0; i <= 0xDD; i++ )
		{
			KeyNG = FALSE;
			for (j = 0; j < NG_KEY; j++ )
				if(i == NG_KeyCode[j])
					KeyNG = TRUE;
			if(KeyNG == FALSE)
			{
				get_keyname(i, KeyName, _MAX_PATH+1);
				SendDlgItemMessage(hDlg, IDC_COMBO_SENDKEY, CB_INSERTSTRING, (WPARAM)ComboKeyNumber, (LPARAM)KeyName);
				ComboKeyTable[ComboKeyNumber] = i;
				ComboKeyNumber++;
			}
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_SENDKEY, CB_SETCURSEL, 0L, 0L);
		SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_SETCURSEL, (WPARAM)FindCaseNumber, 0L);
		SetDlgItemInt(hDlg, IDC_EDIT_WAIT, CommandEdit->Wait[CommandEdit->Locate], TRUE);
		for ( i = 0; i < MAX_ZORDER; i++ )
			SendDlgItemMessage(hDlg, IDC_COMBO_ZORDER, CB_INSERTSTRING, (WPARAM)i, (LPARAM)ZorderList[i].Name);
		SendDlgItemMessage(hDlg, IDC_COMBO_ZORDER, CB_SETCURSEL, 0L, 0L);
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_ALPHA), SB_CTL, AlphaScrMin, AlphaScrMax, TRUE);
		AlphaScrPos = 50;
		SendDlgItemMessage(hDlg, IDC_COMBO_SCROLL, CB_INSERTSTRING, (WPARAM)0, (LPARAM)TEXT("c"));
		SendDlgItemMessage(hDlg, IDC_COMBO_SCROLL, CB_INSERTSTRING, (WPARAM)1, (LPARAM)TEXT(""));
		SendDlgItemMessage(hDlg, IDC_COMBO_SCROLL, CB_SETCURSEL, 0L, 0L);
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLL), SB_CTL, ScrollScrMin, ScrollScrMax, TRUE);
		ScrollScrPos = 0;
		SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_INSERTSTRING, (WPARAM)0, (LPARAM)TEXT("10i"));
		SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_INSERTSTRING, (WPARAM)1, (LPARAM)TEXT("16i"));
		SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_INSERTSTRING, (WPARAM)2, (LPARAM)TEXT("TEXT"));
		SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_SETCURSEL, 1, 0L);
		SendDlgItemMessage(hDlg, IDC_COMBO_WPARAM, CB_INSERTSTRING, (WPARAM)0, (LPARAM)TEXT("10i"));
		SendDlgItemMessage(hDlg, IDC_COMBO_WPARAM, CB_INSERTSTRING, (WPARAM)1, (LPARAM)TEXT("16i"));
		SendDlgItemMessage(hDlg, IDC_COMBO_WPARAM, CB_INSERTSTRING, (WPARAM)2, (LPARAM)TEXT("TEXT"));
		SendDlgItemMessage(hDlg, IDC_COMBO_WPARAM, CB_SETCURSEL, 1, 0L);
		SendDlgItemMessage(hDlg, IDC_COMBO_LPARAM, CB_INSERTSTRING, (WPARAM)0, (LPARAM)TEXT("10i"));
		SendDlgItemMessage(hDlg, IDC_COMBO_LPARAM, CB_INSERTSTRING, (WPARAM)1, (LPARAM)TEXT("16i"));
		SendDlgItemMessage(hDlg, IDC_COMBO_LPARAM, CB_INSERTSTRING, (WPARAM)2, (LPARAM)TEXT("TEXT"));
		SendDlgItemMessage(hDlg, IDC_COMBO_LPARAM, CB_SETCURSEL, 1, 0L);
		SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_INSERTSTRING, (WPARAM)0, (LPARAM)TEXT("ANeBuEBhE"));
		SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_INSERTSTRING, (WPARAM)1, (LPARAM)TEXT("ANVJnEBhE"));
		SetDlgItemInt(hDlg, IDC_EDIT_S_SCROLLLINE, 5, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_S_SCROLLPAGE, 10, TRUE);
		for ( i = 0; i < (int)Target.size(); i++ )
		{
			if(Target[i].Comment[0])
			{
				lstrcpyn(TempMainText, Target[i].Comment, 31);
			}
			else
			{
				lstrcpyn(TempMainText, Target[i].FileName, 31);
				if(TempMainText[0] == 0)
					lstrcpy(TempMainText, TEXT("---"));
				if(Target[i].ControlID[0])
				{
					if(Target[i].ClassName[0])
					{
						lstrcpyn(TempSubText, Target[i].ClassName, 17);
						wsprintf(TempSubText, TEXT("%s ID:%s"), TempSubText, Target[i].ControlID);
					}
					else
					{
						wsprintf(TempSubText, TEXT("ID:%s"), Target[i].ControlID);
					}
				}
				else
				{
					lstrcpyn(TempSubText, Target[i].ClassName, 31);
				}
				wsprintf(TempMainText, TEXT("%s %s"), TempMainText, TempSubText);
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_INSERTSTRING, (WPARAM)i + 2, (LPARAM)TempMainText);
		}
		switch(CommandEdit->CommandTarget[CommandEdit->Locate])
		{
		case -1:
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_SETCURSEL, 1, 0L);
			break;
		case 0:
			SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_SETCURSEL, 0L, 0L);
			break;
		default:
			for(i = 0; i < (int)Target.size(); i++)
			{
				if(CommandEdit->CommandTarget[CommandEdit->Locate] == Target[i].Number)
					SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_SETCURSEL, (WPARAM)i + 2, 0L);
			}
			break;
		}
		switch(CommandEdit->Case[CommandEdit->Locate])
		{
		case 10:
		case 11:
		case 12:
			SendKeyCode = CommandEdit->Key[CommandEdit->Locate];
			get_keyname(SendKeyCode, KeyName, _MAX_PATH+1);
			SendMessage(GetWindow(GetDlgItem(hDlg, IDC_COMBO_SENDKEY), GW_CHILD), WM_SETTEXT, 0L, (LPARAM)KeyName);
			SendMessage(GetWindow(GetDlgItem(hDlg, IDC_COMBO_SENDKEY), GW_CHILD), EM_SETSEL, lstrlen(KeyName), lstrlen(KeyName));
			break;
		case 20:
			SetDlgItemInt(hDlg, IDC_EDIT_BUTTONCODE, CommandEdit->Key[CommandEdit->Locate], TRUE);
			break;
		case 30:
			SetDlgItemText(hDlg, IDC_EDIT_FILEPATH, CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainText);
			SetDlgItemText(hDlg, IDC_EDIT_CMDLINE, CommandExt[CommandEdit->Key[CommandEdit->Locate]].SubText);
			break;
		case 25:
			SetDlgItemText(hDlg, IDC_EDIT_COPY, CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainText);
			break;
		case 35:
			SetDlgItemText(hDlg, IDC_EDIT_FILEPATH, CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainText);
			break;
		case 40:
			for ( i = 0; i < MAX_ZORDER; i++ )
				if(ZorderList[i].Number == CommandEdit->Key[CommandEdit->Locate])
					SendDlgItemMessage(hDlg, IDC_COMBO_ZORDER, CB_SETCURSEL, (WPARAM)i, 0L);
			break;
		case 41:
		case 42:
		case 55:
		case 58:
		case 59:
			SetDlgItemInt(hDlg, IDC_EDIT_POSX, (SHORT)HIWORD(CommandEdit->Key[CommandEdit->Locate]), TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT_POSY, (SHORT)LOWORD(CommandEdit->Key[CommandEdit->Locate]), TRUE);
			break;
		case 50:
			AlphaScrPos = abs(CommandEdit->Key[CommandEdit->Locate]);
			break;
		case 60:
			if((SHORT)HIWORD(CommandEdit->Key[CommandEdit->Locate]) < 0)
				SendDlgItemMessage(hDlg, IDC_COMBO_SCROLL, CB_SETCURSEL, 1, 0L);
			switch(abs((SHORT)HIWORD(CommandEdit->Key[CommandEdit->Locate])) - 1)
			{
			case SB_PAGELEFT:
				ScrollScrPos = ScrollScrMin;
				break;
			case SB_PAGERIGHT:
				ScrollScrPos = ScrollScrMax;
				break;
			case SB_LINELEFT:
				ScrollScrPos = LOWORD(CommandEdit->Key[CommandEdit->Locate]) * -1;
				break;
			case SB_LINERIGHT:
				ScrollScrPos = LOWORD(CommandEdit->Key[CommandEdit->Locate]);
				break;
			}
			break;
		case 65:
			SetDlgItemInt(hDlg, IDC_EDIT_S_SCROLLLINE, (SHORT)HIWORD(CommandEdit->Key[CommandEdit->Locate]), TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT_S_SCROLLPAGE, (SHORT)LOWORD(CommandEdit->Key[CommandEdit->Locate]), TRUE);
			break;
		case 70:
		case 71:
			if(CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainKey < 100)
			{
				SendDlgItemMessage(hDlg, IDC_CHECK_CONTROL, BM_SETCHECK, 1, 0);
				SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_SETCURSEL, CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainKey, 0L);
			}
			else
			{
				SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_SETCURSEL, CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainKey - 100, 0L);
			}
			SetDlgItemText(hDlg, IDC_EDIT_MESSAGE, CommandExt[CommandEdit->Key[CommandEdit->Locate]].MainText);
			SetDlgItemText(hDlg, IDC_EDIT_WPARAM, CommandExt[CommandEdit->Key[CommandEdit->Locate]].SubText);
			SendDlgItemMessage(hDlg, IDC_COMBO_WPARAM, CB_SETCURSEL, CommandExt[CommandEdit->Key[CommandEdit->Locate]].SubKey, 0L);
			SetDlgItemText(hDlg, IDC_EDIT_LPARAM, CommandExt[CommandEdit->Key[CommandEdit->Locate]].Sub2Text);
			SendDlgItemMessage(hDlg, IDC_COMBO_LPARAM, CB_SETCURSEL, CommandExt[CommandEdit->Key[CommandEdit->Locate]].Sub2Key, 0L);
			break;
		}
		if(CommandEdit->Case[CommandEdit->Locate] == 50 && CommandEdit->Key[CommandEdit->Locate] < 0)
			SendDlgItemMessage(hDlg, IDC_CHECK_ALPHA, BM_SETCHECK, 0, 0);
		else
			SendDlgItemMessage(hDlg, IDC_CHECK_ALPHA, BM_SETCHECK, 1, 0);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_ALPHA), SB_CTL, AlphaScrPos, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_ALPHA, AlphaScrPos, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLL), SB_CTL, ScrollScrPos, TRUE);
		if(ScrollScrPos == ScrollScrMin || ScrollScrPos == ScrollScrMax)
			wsprintf(EditString, TEXT("%d Page"), ScrollScrPos / abs(ScrollScrPos));
		else
			wsprintf(EditString, TEXT("%d Line"), ScrollScrPos);
		SetDlgItemText(hDlg, IDC_EDIT_SCROLL, EditString);
		EnableCommandEdit(hDlg, CommandList[SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_GETCURSEL, 0L, 0L)].Number);
		return FALSE;
	case WM_HSCROLL:
		if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_ALPHA))
		{
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				AlphaScrPos--;
				break;
			case SB_LINERIGHT:
				AlphaScrPos++;
				break;
			case SB_PAGELEFT:
				AlphaScrPos -= 10;
				break;
			case SB_PAGERIGHT:
				AlphaScrPos += 10;
				break;
			case SB_THUMBTRACK:
				AlphaScrPos =(int)(HIWORD(wParam));
				break;
			}
			if (AlphaScrPos < AlphaScrMin)
				AlphaScrPos = AlphaScrMin;
			if (AlphaScrPos > AlphaScrMax)
				AlphaScrPos = AlphaScrMax;
			SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_ALPHA), SB_CTL, AlphaScrPos, TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT_ALPHA, AlphaScrPos, TRUE);
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLL))
		{
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				ScrollScrPos--;
				break;
			case SB_LINERIGHT:
				ScrollScrPos++;
				break;
			case SB_PAGELEFT:
				ScrollScrPos -= 5;
				break;
			case SB_PAGERIGHT:
				ScrollScrPos += 5;
				break;
			case SB_THUMBTRACK:
				ScrollScrPos =(SHORT)(HIWORD(wParam));
				break;
			}
			if (ScrollScrPos < ScrollScrMin)
				ScrollScrPos = ScrollScrMin;
			if (ScrollScrPos > ScrollScrMax)
				ScrollScrPos = ScrollScrMax;
			SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLL), SB_CTL, ScrollScrPos, TRUE);
			if(ScrollScrPos == ScrollScrMin || ScrollScrPos == ScrollScrMax)
				wsprintf(EditString, TEXT("%d Page"), ScrollScrPos / abs(ScrollScrPos));
			else
				wsprintf(EditString, TEXT("%d Line"), ScrollScrPos);
			SetDlgItemText(hDlg, IDC_EDIT_SCROLL, EditString);
		}
		break;
	case WM_COMBO_REFRESH:
		get_keyname(SendKeyCode, KeyName, _MAX_PATH+1);
		SendMessage(GetWindow(GetDlgItem(hDlg, IDC_COMBO_SENDKEY), GW_CHILD), WM_SETTEXT, 0L, (LPARAM)KeyName);
		SendMessage(GetWindow(GetDlgItem(hDlg, IDC_COMBO_SENDKEY), GW_CHILD), EM_SETSEL, lstrlen(KeyName), lstrlen(KeyName));
		break;
	case WM_KEYBOARD_MSG:
		if(!(HIBYTE(SendKeyCode) & HOTKEYF_SHIFT && wParam == VK_SHIFT) &&
			!(HIBYTE(SendKeyCode) & HOTKEYF_CONTROL && wParam == VK_CONTROL) &&
			!(HIBYTE(SendKeyCode) & HOTKEYF_ALT && wParam == VK_MENU) &&
			!(HIBYTE(SendKeyCode) & HOTKEYF_WIN && (wParam == VK_LWIN || wParam == VK_RWIN)))
			SendKeyCode = SendKeyCheck((UINT)wParam);
		PostMessage(hDlg, WM_COMBO_REFRESH, 0, 0);
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_COMBO_COMMAND:
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				if(SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_GETCURSEL, 0L, 0L) >= 0)
					EnableCommandEdit(hDlg, CommandList[SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_GETCURSEL, 0L, 0L)].Number);
			}
			break;
		case IDC_COMBO_SENDKEY:
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				if(SendDlgItemMessage(hDlg, IDC_COMBO_SENDKEY, CB_GETCURSEL, 0L, 0L) > 0)
				{
					SendKeyCode = SendKeyCheck(ComboKeyTable[SendDlgItemMessage(hDlg, IDC_COMBO_SENDKEY, CB_GETCURSEL, 0L, 0L)]);
					PostMessage(hDlg, WM_COMBO_REFRESH, 0, 0);
				}
			}
			break;
		case IDC_BUTTON_BUTTONCAPTURE:
			SetDlgItemText(hDlg, IDC_EDIT_BUTTONCODE, TEXT("c[o[{^NbN"));
			SetButtonSearchHook(GetDlgItem(hDlg,IDC_EDIT_BUTTONCODE));
			break;
		case IDC_BUTTON_WINDOWCAPTURE:
			switch(CommandList[SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_GETCURSEL, 0L, 0L)].Number)
			{
			case 41:
				SetDlgItemText(hDlg, IDC_EDIT_POSX, TEXT("ް"));
				SetDlgItemText(hDlg, IDC_EDIT_POSY, TEXT("د"));
				SetWindowHook(GetDlgItem(hDlg,IDC_EDIT_POSX),GetDlgItem(hDlg,IDC_EDIT_POSY),2);
				break;
			case 42:
				SetDlgItemText(hDlg, IDC_EDIT_POSX, TEXT("ް"));
				SetDlgItemText(hDlg, IDC_EDIT_POSY, TEXT("د"));
				SetWindowHook(GetDlgItem(hDlg,IDC_EDIT_POSX),GetDlgItem(hDlg,IDC_EDIT_POSY),3);
				break;
			case 55:
				SetDlgItemText(hDlg, IDC_EDIT_POSX, TEXT("ܾ"));
				SetDlgItemText(hDlg, IDC_EDIT_POSY, TEXT("R د"));
				SetWindowHook(GetDlgItem(hDlg,IDC_EDIT_POSX),GetDlgItem(hDlg,IDC_EDIT_POSY),4);
				break;
			}
			break;
		case IDC_BUTTON_FULLPATH:
			GetDlgItemText(hDlg, IDC_EDIT_FILEPATH, FilePath, _MAX_PATH);
			if(PathIsRelative(FilePath))
			{
				GetCurrentDirectory(_MAX_PATH, TempSubText);//JgfBNgۑ
				GetModuleFileName(NULL, TempMainText, _MAX_PATH);
				_tsplitpath_s(TempMainText, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);
				wsprintf(TempMainText, TEXT("%s%s"), drive, dir, NULL);
				SetCurrentDirectory(TempMainText);
				_tfullpath(FilePath, FilePath, _MAX_PATH); 
				SetCurrentDirectory(TempSubText);//JgfBNgɖ߂
			}
			else
			{
				GetModuleFileName(NULL, TempMainText, _MAX_PATH);
				_tsplitpath_s(TempMainText, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);
				wsprintf(TempMainText, TEXT("%s%s"), drive, dir, NULL);
				PathRelativePathTo(TempSubText, TempMainText, FILE_ATTRIBUTE_DIRECTORY, FilePath, FILE_ATTRIBUTE_ARCHIVE);
				lstrcpy(FilePath, TempSubText);
			}
			SetDlgItemText(hDlg, IDC_EDIT_FILEPATH, FilePath);
			break;
		case IDC_BUTTON_FILESEARCH:
			GetDlgItemText(hDlg, IDC_EDIT_FILEPATH, FilePath, _MAX_PATH);
			OPENFILENAME ofn;
			memset(&ofn, 0, sizeof(OPENFILENAME));    
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner   = hDlg;
			ofn.lpstrFile   = FilePath; //Iꂽt@C󂯎(tpX)
			ofn.nMaxFile    = _MAX_PATH;
			ofn.lpstrFilter = TEXT("all(*.*)\0*.*\0\0"); //tB^
			ofn.lpstrTitle  = TEXT("st@CI"); //_CAO{bNX̃^Cg
			ofn.Flags       = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			GetOpenFileName(&ofn);
			SetDlgItemText(hDlg, IDC_EDIT_FILEPATH, FilePath);
			break;
		case IDOK:
			if(SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_GETCURSEL, 0L, 0L) < 0)
				break;
			GetDlgItemText(hDlg, IDC_EDIT_WAIT, WaitString, 10);
			CommandEdit->Wait[CommandEdit->Locate] = _ttoi(WaitString);
			CommandEdit->Case[CommandEdit->Locate] = CommandList[SendDlgItemMessage(hDlg, IDC_COMBO_COMMAND, CB_GETCURSEL, 0L, 0L)].Number;
			switch(CommandEdit->Case[CommandEdit->Locate])
			{
			case 10:
			case 11:
			case 12:
				CommandEdit->Key[CommandEdit->Locate] = SendKeyCode;
				break;
			case 20:
				GetDlgItemText(hDlg, IDC_EDIT_BUTTONCODE, EditString, 11);
				CommandEdit->Key[CommandEdit->Locate] = _ttoi(EditString);
				break;
			case 25:
				CommandEdit->Key[CommandEdit->Locate] = (LONG)CommandExt.size();
				GetDlgItemText(hDlg, IDC_EDIT_COPY, c.MainText, _MAX_PATH);
				CommandExt.push_back(c);
				break;
			case 30:
				CommandEdit->Key[CommandEdit->Locate] = (LONG)CommandExt.size();
				GetDlgItemText(hDlg, IDC_EDIT_FILEPATH, c.MainText, _MAX_PATH);
				GetDlgItemText(hDlg, IDC_EDIT_CMDLINE, c.SubText, _MAX_PATH);
				CommandExt.push_back(c);
				break;
			case 35:
				CommandEdit->Key[CommandEdit->Locate] = (LONG)CommandExt.size();
				GetDlgItemText(hDlg, IDC_EDIT_FILEPATH, c.MainText, _MAX_PATH);
				CommandExt.push_back(c);
				break;
			case 40:
				CommandEdit->Key[CommandEdit->Locate] = ZorderList[(LONG)SendDlgItemMessage(hDlg, IDC_COMBO_ZORDER, CB_GETCURSEL, 0L, 0L)].Number;
				break;
			case 41:
			case 42:
			case 55:
			case 58:
			case 59:
				GetDlgItemText(hDlg, IDC_EDIT_POSX, EditString, 6);
				GetDlgItemText(hDlg, IDC_EDIT_POSY, WaitString, 6);
				CommandEdit->Key[CommandEdit->Locate] = MAKELONG(_ttoi(WaitString),_ttoi(EditString));
				break;
			case 50:
				if(SendDlgItemMessage(hDlg, IDC_CHECK_ALPHA, BM_GETCHECK , 0L , 0L) == 0)
					CommandEdit->Key[CommandEdit->Locate] = AlphaScrPos * -1;
				else
					CommandEdit->Key[CommandEdit->Locate] = AlphaScrPos;
				break;
			case 60:
				if(ScrollScrPos == ScrollScrMin)
				{
					i = SB_PAGELEFT;
					ScrollScrPos = 0;
				}
				else if(ScrollScrPos == ScrollScrMax)
				{
					i = SB_PAGERIGHT;
					ScrollScrPos = 0;
				}
				else if(ScrollScrPos < 0)
				{
					i = SB_LINELEFT;
					ScrollScrPos = abs(ScrollScrPos);
				}
				else
				{
					i = SB_LINERIGHT;
					ScrollScrPos = abs(ScrollScrPos);
				}
				i++;
				if(SendDlgItemMessage(hDlg, IDC_COMBO_SCROLL, CB_GETCURSEL, 0L, 0L) > 0)
					i = i * -1;
				CommandEdit->Key[CommandEdit->Locate] = MAKELONG(ScrollScrPos, i);
				break;
			case 65:
				GetDlgItemText(hDlg, IDC_EDIT_S_SCROLLLINE, EditString, 6);
				GetDlgItemText(hDlg, IDC_EDIT_S_SCROLLPAGE, WaitString, 6);
				CommandEdit->Key[CommandEdit->Locate] = MAKELONG(_ttoi(WaitString),_ttoi(EditString));
				break;
			case 70:
			case 71:
				CommandEdit->Key[CommandEdit->Locate] = (LONG)CommandExt.size();
				GetDlgItemText(hDlg, IDC_EDIT_MESSAGE, c.MainText, _MAX_PATH);
				c.MainKey = (int)SendDlgItemMessage(hDlg, IDC_COMBO_MESSAGE, CB_GETCURSEL, 0L, 0L);
				GetDlgItemText(hDlg, IDC_EDIT_WPARAM, c.SubText, _MAX_PATH);
				c.SubKey = (int)SendDlgItemMessage(hDlg, IDC_COMBO_WPARAM, CB_GETCURSEL, 0L, 0L);
				GetDlgItemText(hDlg, IDC_EDIT_LPARAM, c.Sub2Text, _MAX_PATH);
				c.Sub2Key = (int)SendDlgItemMessage(hDlg, IDC_COMBO_LPARAM, CB_GETCURSEL, 0L, 0L);
				if(SendDlgItemMessage(hDlg, IDC_CHECK_CONTROL, BM_GETCHECK , 0L , 0L) == 0)
					c.MainKey += 100;
				CommandExt.push_back(c);
				break;
			}
			switch(SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_GETCURSEL, 0L, 0L))
			{
			case 0:
				CommandEdit->CommandTarget[CommandEdit->Locate] = 0;
				break;
			case 1:
				CommandEdit->CommandTarget[CommandEdit->Locate] = -1;
				break;
			default:
				CommandEdit->CommandTarget[CommandEdit->Locate] = Target[(int)SendDlgItemMessage(hDlg, IDC_COMBO_COMMANDTARGET, CB_GETCURSEL, 0L, 0L) - 2].Number;
				break;
			}
			if(CommandEdit->Locate == CommandEdit->Repeat)	//ǉ
				CommandEdit->Repeat ++;	//R}h̐𑝂₷
			GetWindowPosition(hDlg, &CommandDialog);
			EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	case WM_DESTROY:
		ButtonSearchUnHook();
		SetSendKeyComboUnHook();
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

//^[Qbgݒ_CAO
INT_PTR CALLBACK TargetDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static int nActiveIndex;
	int i, j;
	TCHAR FilePath[_MAX_PATH + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR dir[_MAX_DIR + 1];
	TCHAR fname[_MAX_FNAME + 1];
	TCHAR fext[_MAX_EXT + 1];
	TCHAR ClassName[MAX_CLASSNAME + 1];
	TCHAR ControlID[MAX_CLASSNAME + 1];
	static TCHAR TargetType[4][20] = {TEXT("t@C"), TEXT("tpX"), TEXT("[g̃pX"), TEXT("hCuƃt@C")};
	static struct HitTestValue {
		TCHAR Value[30];
		TCHAR Name[30];
	} EtcTarget[8] = {
		{TEXT(""),TEXT("̗̑̈")}, 
		{TEXT(""),TEXT("fXNgbv")}, 
		{TEXT("HitTestCaptionBar"),TEXT("^Cgo[")}, 
		{TEXT("HitTestScrollBar"),TEXT("XN[o[")},
		{TEXT("HitTestBorder"),TEXT("E")},
		{TEXT("HitTestMenu"),TEXT("j[")},
		{TEXT("HitTestListViewIcon"),TEXT("Xgr[ACR")},
		{TEXT("HitTestTreeViewIcon"),TEXT("c[r[ACR")}
	};
	struct TargetWindow t = {0};

	switch (msg)
	{
	case WM_INITDIALOG:
		SetWindowPos( hDlg, NULL, TargetDialog.x, TargetDialog.y, NULL, NULL, SWP_NOSIZE | SWP_NOZORDER );
		nActiveIndex = (int)lParam;
		SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_INSERTSTRING, (WPARAM)0, (LPARAM)TEXT("pȂ"));
		SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_INSERTSTRING, (WPARAM)1, (LPARAM)TEXT("Default"));
		for ( i = 0; i < (int)Target.size(); i++ )
		{
			if(Target[i].Comment[0])
			{
				lstrcpyn(FilePath, Target[i].Comment, 15);
			}
			else
			{
				lstrcpyn(FilePath, Target[i].FileName, 15);
				if(FilePath[0] == 0)
					lstrcpy(FilePath, TEXT("---"));
				if(Target[i].ControlID[0])
				{
					if(Target[i].ClassName[0])
					{
						lstrcpyn(ClassName, Target[i].ClassName, 13);
						wsprintf(ClassName, TEXT("%s ID:%s"), ClassName, Target[i].ControlID);
					}
					else
					{
						wsprintf(ClassName, TEXT("ID:%s"), Target[i].ControlID);
					}
				}
				else
				{
					lstrcpyn(ClassName, Target[i].ClassName, 21);
				}
				wsprintf(FilePath, TEXT("%s %s"), FilePath, ClassName);
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_INSERTSTRING, (WPARAM)i + 2, (LPARAM)FilePath);
		}
		if(nActiveIndex != -1)
		{
			SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, Target[nActiveIndex].FileName);
			switch(Target[nActiveIndex].DefaultThru)
			{
			case -1:
				SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_SETCURSEL, 0, 0L);
				break;
			case 0:
				SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_SETCURSEL, 1, 0L);
				break;
			default:
				for ( j = 0; j < (int)Target.size(); j++ )
				{
					if(Target[nActiveIndex].DefaultThru == Target[j].Number)
						SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_SETCURSEL, j + 2, 0L);
				}
				break;
			}
			if(Target[nActiveIndex].FileName[0])
				SendDlgItemMessage(hDlg, IDC_CHECK_GETFILE, BM_SETCHECK, 1, 0);
			if(Target[nActiveIndex].ClassName[0])
				SendDlgItemMessage(hDlg, IDC_CHECK_GETCLASS, BM_SETCHECK, 1, 0);
			if(Target[nActiveIndex].ControlID[0])
				SendDlgItemMessage(hDlg, IDC_CHECK_GETID, BM_SETCHECK, 1, 0);
			SendDlgItemMessage(hDlg, IDC_CHECK_HOOKTYPE, BM_SETCHECK, Target[nActiveIndex].HookType, 0);
			SendDlgItemMessage(hDlg, IDC_CHECK_WHEELREDIRECT, BM_SETCHECK, Target[nActiveIndex].WheelRedirect, 0);
			SendDlgItemMessage(hDlg, IDC_CHECK_FREESCROLL, BM_SETCHECK, Target[nActiveIndex].FreeScroll, 0);
			SetDlgItemText(hDlg, IDC_EDIT_TARGETCLASS, Target[nActiveIndex].ClassName);
			SetDlgItemText(hDlg, IDC_EDIT_TARGETID, Target[nActiveIndex].ControlID);
			SetDlgItemText(hDlg, IDC_EDIT_TARGETCOMMENT, Target[nActiveIndex].Comment);
		}
		else
		{
			SendDlgItemMessage(hDlg, IDC_CHECK_GETFILE, BM_SETCHECK, 1, 0);
			SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_SETCURSEL, 1, 0L);
			SendDlgItemMessage(hDlg, IDC_CHECK_HOOKTYPE, BM_SETCHECK, Default.HookType, 0);
			SendDlgItemMessage(hDlg, IDC_CHECK_WHEELREDIRECT, BM_SETCHECK, Default.WheelRedirect, 0);
			SendDlgItemMessage(hDlg, IDC_CHECK_FREESCROLL, BM_SETCHECK, Default.FreeScroll, 0);
			nActiveIndex = (int)Target.size();
		}
		for ( i = 0; i <= 3; i++ )
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_INSERTSTRING, (WPARAM)i, (LPARAM)TargetType[i]);
		if(nActiveIndex == (int)Target.size())
			_tsplitpath_s( TEXT(""), drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0 );
		else
			_tsplitpath_s( Target[nActiveIndex].FileName, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0 );
		if(lstrcmp( drive, TEXT("")) != 0 && lstrcmp( dir, TEXT("")) != 0)
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_SETCURSEL, 1, 0L);
		else if(lstrcmp( drive, TEXT("")) == 0 && lstrcmp( dir, TEXT("")) != 0)
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_SETCURSEL, 2, 0L);
		else if(lstrcmp( drive, TEXT("")) != 0 && lstrcmp( dir, TEXT("")) == 0)
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_SETCURSEL, 3, 0L);
		else
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_SETCURSEL, 0, 0L);
		for ( i = 0; i < 8; i++ )
			SendDlgItemMessage(hDlg, IDC_COMBO_ETCTARGET, CB_INSERTSTRING, (WPARAM)i, (LPARAM)EtcTarget[i].Name);
		SendDlgItemMessage(hDlg, IDC_COMBO_ETCTARGET, CB_SETCURSEL, 0, 0L);
		break;
	case MAUHOOK_MSG:
		GetFileName( FilePath, ClassName, ControlID );
		_tsplitpath_s( FilePath, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, fext, _MAX_EXT );
		switch(SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_GETCURSEL, 0L, 0L))
		{
		case 0:
			_tmakepath_s( FilePath, _MAX_PATH, NULL, NULL, fname, fext );
			break;
		case 1:
			_tmakepath_s( FilePath, _MAX_PATH, drive, dir, fname, fext );
			break;
		case 2:
			_tmakepath_s( FilePath, _MAX_PATH, NULL, dir, fname, fext );
			break;
		case 3:
			_tmakepath_s( FilePath, _MAX_PATH, drive, NULL, fname, fext );
			break;
		}
		if(SendDlgItemMessage(hDlg, IDC_CHECK_GETFILE, BM_GETCHECK , 0L , 0L) == 1)
			SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, FilePath);
		else
			SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, TEXT(""));
		if(SendDlgItemMessage(hDlg, IDC_CHECK_GETCLASS, BM_GETCHECK , 0L , 0L) == 1)
			SetDlgItemText(hDlg, IDC_EDIT_TARGETCLASS, ClassName);
		if(SendDlgItemMessage(hDlg, IDC_CHECK_GETID, BM_GETCHECK , 0L , 0L) == 1)
			SetDlgItemText(hDlg, IDC_EDIT_TARGETID, ControlID);
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_COMBO_ETCTARGET:
			if(HIWORD(wParam)==CBN_SELCHANGE)
			{
				switch(SendDlgItemMessage(hDlg, IDC_COMBO_ETCTARGET, CB_GETCURSEL, 0L, 0L))
				{
				case 0:
					break;
				case 1:
					SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, TEXT("Desktop"));
					SetDlgItemText(hDlg, IDC_EDIT_TARGETCLASS, TEXT(""));
					break;
				default:
					GetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, FilePath, _MAX_PATH);
					if(lstrcmpi(FilePath, TEXT("Desktop")) == 0)
						SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, TEXT(""));
					SetDlgItemText(hDlg, IDC_EDIT_TARGETCLASS, EtcTarget[SendDlgItemMessage(hDlg, IDC_COMBO_ETCTARGET, CB_GETCURSEL, 0L, 0L)].Value);
					break;
				}
				SendDlgItemMessage(hDlg, IDC_COMBO_ETCTARGET, CB_SETCURSEL, 0, 0L);
			}
			break;
		case IDC_BUTTON_SETFILENAME:
			SetWindowHook(hDlg,NULL,1);
			if(SendDlgItemMessage(hDlg, IDC_CHECK_GETFILE, BM_GETCHECK , 0L , 0L) == 1)
				SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, TEXT("EBhENbN"));
			if(SendDlgItemMessage(hDlg, IDC_CHECK_GETCLASS, BM_GETCHECK , 0L , 0L) == 1)
				SetDlgItemText(hDlg, IDC_EDIT_TARGETCLASS, TEXT("EBhENbN"));
			if(SendDlgItemMessage(hDlg, IDC_CHECK_GETID, BM_GETCHECK , 0L , 0L) == 1)
				SetDlgItemText(hDlg, IDC_EDIT_TARGETID, TEXT("NbN"));
			break;
		case IDC_BUTTON_TARGETSEARCH:
			GetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, FilePath, _MAX_PATH);
			OPENFILENAME ofn;
			memset(&ofn, 0, sizeof(OPENFILENAME));    
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner   = hDlg;
			ofn.lpstrFile   = FilePath; //Iꂽt@C󂯎(tpX)
			ofn.nMaxFile    = _MAX_PATH;
			ofn.lpstrFilter = TEXT("all(*.*)\0*.*\0\0"); //tB^
			ofn.lpstrTitle  = TEXT("Ώۃt@CI"); //_CAO{bNX̃^Cg
			ofn.Flags       = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			GetOpenFileName(&ofn);
			_tsplitpath_s( FilePath, drive, _MAX_DRIVE, dir, _MAX_DIR, fname, _MAX_FNAME, fext, _MAX_EXT );
			switch(SendDlgItemMessage(hDlg, IDC_COMBO_TARGETTYPE, CB_GETCURSEL, 0L, 0L))
			{
			case 0:
				_tmakepath_s( FilePath, _MAX_PATH, NULL, NULL, fname, fext );
				break;
			case 1:
				_tmakepath_s( FilePath, _MAX_PATH, drive, dir, fname, fext );
				break;
			case 2:
				_tmakepath_s( FilePath, _MAX_PATH, NULL, dir, fname, fext );
				break;
			case 3:
				_tmakepath_s( FilePath, _MAX_PATH, drive, NULL, fname, fext );
				break;
			}
			SetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, FilePath);
			break;
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDIT_TARGETFILE, t.FileName, _MAX_PATH);
			GetDlgItemText(hDlg, IDC_EDIT_TARGETCLASS, t.ClassName, MAX_CLASSNAME);
			GetDlgItemText(hDlg, IDC_EDIT_TARGETID, t.ControlID, 19);
			GetDlgItemText(hDlg, IDC_EDIT_TARGETCOMMENT, t.Comment, MAX_COMMENT);
			switch(SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_GETCURSEL, 0L, 0L))
			{
			case 0:
				t.DefaultThru = -1;
				break;
			case 1:
				t.DefaultThru = 0;
				break;
			default:
				t.DefaultThru = Target[(int)SendDlgItemMessage(hDlg, IDC_COMBO_DEFAULTTHRU, CB_GETCURSEL, 0L, 0L) - 2].Number;
				break;
			}
			t.HookType = (BOOL)SendDlgItemMessage(hDlg, IDC_CHECK_HOOKTYPE, BM_GETCHECK , 0L , 0L);
			t.WheelRedirect = (BOOL)SendDlgItemMessage(hDlg, IDC_CHECK_WHEELREDIRECT, BM_GETCHECK , 0L , 0L);
			t.FreeScroll = (BOOL)SendDlgItemMessage(hDlg, IDC_CHECK_FREESCROLL, BM_GETCHECK , 0L , 0L);
			if(nActiveIndex == (int)Target.size())
			{
				//ǉ
				t.Number = MinTargetNumber();
				Target.push_back(t);
			}
			else
			{
				//ҏW
				t.Number = Target[nActiveIndex].Number;
				Target[nActiveIndex] = t;
			}

			GetWindowPosition(hDlg, &TargetDialog);
			IniChange = TRUE;
			WindowUnHook();
			EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:
			WindowUnHook();
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

void CommandDelete(struct Command *CommandEdit)
{
	int i;
	for ( i = CommandEdit->Locate; i < (CommandEdit->Repeat - 1); i++ )
	{
		CommandEdit->Case[i] = CommandEdit->Case[i + 1];
		CommandEdit->CommandTarget[i] = CommandEdit->CommandTarget[i + 1];
		CommandEdit->Wait[i] = CommandEdit->Wait[i + 1];
		CommandEdit->Key[i] = CommandEdit->Key[i + 1];
	}
	CommandEdit->Case[CommandEdit->Repeat - 1] = 0;
	CommandEdit->CommandTarget[CommandEdit->Repeat - 1] = 0;
	CommandEdit->Wait[CommandEdit->Repeat - 1] = 0;
	CommandEdit->Repeat --;
}

void EnableCommandItem(HWND hDlg, int nActiveIndexC, int MaxCommand)
{
	if(MaxCommand >= MAX_ACTION_REPEAT)
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDADD), FALSE);
	else
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDADD), TRUE);
	if(nActiveIndexC == -1)
	{
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDEDIT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDDELETE), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDUP), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDDOWN), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDEDIT), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDDELETE), TRUE);
		if(nActiveIndexC <= 0 || nActiveIndexC == MaxCommand)
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDUP), FALSE);
		else
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDUP), TRUE);
		if(nActiveIndexC == -1 || nActiveIndexC >= MaxCommand - 1)
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDDOWN), FALSE);
		else
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_COMMANDDOWN), TRUE);
	}
}

//ANVݒ_CAO
INT_PTR CALLBACK ActionDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static int Locate;
	static struct Command CommandEdit;
	static HWND hLVC;
	static int GestureButton, EditGestureLevel, EditMove[MAX_GESTURE_LEVEL];
	NMHDR *lpnmhdr;
	int nActiveIndexC;
	TCHAR Code[30], MoveS[12];
	int i, Move;
	struct ExecuteCommand a = {0};

	switch (msg)
	{
	case WM_INITDIALOG:
		SetWindowPos( hDlg, NULL, ActionDialog.x, ActionDialog.y, NULL, NULL, SWP_NOSIZE | SWP_NOZORDER );
		Locate = LOWORD(lParam);	//LV_ActionLocate
		SetDlgItemText(hDlg, IDC_BUTTON_UP, MoveUp);
		SetDlgItemText(hDlg, IDC_BUTTON_DOWN, MoveDown);
		SetDlgItemText(hDlg, IDC_BUTTON_LEFT, MoveLeft);
		SetDlgItemText(hDlg, IDC_BUTTON_RIGHT, MoveRight);
		SetDlgItemText(hDlg, IDC_BUTTON_UPLEFT, MoveUpLeft);
		SetDlgItemText(hDlg, IDC_BUTTON_UPRIGHT, MoveUpRight);
		SetDlgItemText(hDlg, IDC_BUTTON_DOWNLEFT, MoveDownLeft);
		SetDlgItemText(hDlg, IDC_BUTTON_DOWNRIGHT, MoveDownRight);
		lstrcpy(MoveS, TEXT("` W"));
		lstrcat(MoveS, MoveUp);
		SetDlgItemText(hDlg, IDC_BUTTON_TOWHEELUP, MoveS);
		lstrcpy(MoveS, TEXT("` W"));
		lstrcat(MoveS, MoveDown);
		SetDlgItemText(hDlg, IDC_BUTTON_TOWHEELDOWN, MoveS);
		lstrcpy(MoveS, TEXT("` W"));
		lstrcat(MoveS, MoveLeft);
		SetDlgItemText(hDlg, IDC_BUTTON_TOWHEELLEFT, MoveS);
		lstrcpy(MoveS, TEXT("` W"));
		lstrcat(MoveS, MoveRight);
		SetDlgItemText(hDlg, IDC_BUTTON_TOWHEELRIGHT, MoveS);
		lstrcpy(MoveS, MoveUp);
		SetDlgItemText(hDlg, IDC_RADIO_WHEELUP, MoveS);
		lstrcpy(MoveS, MoveDown);
		SetDlgItemText(hDlg, IDC_RADIO_WHEELDOWN, MoveS);
		lstrcpy(MoveS, MoveLeft);
		SetDlgItemText(hDlg, IDC_RADIO_WHEELLEFT, MoveS);
		lstrcpy(MoveS, MoveRight);
		SetDlgItemText(hDlg, IDC_RADIO_WHEELRIGHT, MoveS);
		for ( i = 0; i < (int)Target.size(); i++ )
		{
			TCHAR TempMainText[_MAX_PATH + 1], TempSubText[_MAX_PATH + 1];

			if(Target[i].Comment[0])
			{
				lstrcpyn(TempMainText, Target[i].Comment, 15);
			}
			else
			{
				lstrcpyn(TempMainText, Target[i].FileName, 15);
				if(TempMainText[0] == 0)
					lstrcpy(TempMainText, TEXT("---"));
				if(Target[i].ControlID[0])
				{
					if(Target[i].ClassName[0])
					{
						lstrcpyn(TempSubText, Target[i].ClassName, 13);
						wsprintf(TempSubText, TEXT("%s ID:%s"), TempSubText, Target[i].ControlID);
					}
					else
					{
						wsprintf(TempSubText, TEXT("ID:%s"), Target[i].ControlID);
					}
				}
				else
				{
					lstrcpyn(TempSubText, Target[i].ClassName, 21);
				}
				wsprintf(TempMainText, TEXT("%s %s"), TempMainText, TempSubText);
			}
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGET, CB_INSERTSTRING, (WPARAM)i, (LPARAM)TempMainText);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_TARGET, CB_INSERTSTRING, (WPARAM)(int)Target.size(), (LPARAM)TEXT("Default"));
		for ( i = 0; i < MAX_ACTION_REPEAT; i++ )
		{
			CommandEdit.Case[i] = 0;
			CommandEdit.CommandTarget[i] = 0;
			CommandEdit.Wait[i] = 0;
			CommandEdit.Key[i] = 0;
		}
		if(HIWORD(lParam) == 0)	//SelectedTargetNumber
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_TARGET, CB_SETCURSEL, (WPARAM)(int)Target.size(), 0L);
		}
		else
		{
			for(i = 0; i < (int)Target.size(); i++)
			{
				if(HIWORD(lParam) == Target[i].Number)
					SendDlgItemMessage(hDlg, IDC_COMBO_TARGET, CB_SETCURSEL, (WPARAM)i, 0L);
			}
		}
		SendDlgItemMessage(hDlg, IDC_LIST_COMMAND, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT |
			SendDlgItemMessage(hDlg, IDC_LIST_COMMAND, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));
		hLVC = GetDlgItem(hDlg,IDC_LIST_COMMAND);
		InitializeLVC(hLVC);
		EditGestureLevel = 0;
		if(Locate < (int)Action.size())
		{
			GestureButton = Action[Locate].Button;
			for(i=0; i<MAX_GESTURE_LEVEL; i++)
			{
				if(Action[Locate].Move[i] != 0)
					EditGestureLevel = i + 1;
				EditMove[i] = Action[Locate].Move[i];
			}
			if(Action[Locate].Modifier & MODIFIER_DISABLE)
			{
				EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CONTROL), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_CHECK_SHIFT), FALSE);
			}
			else
			{
				SendDlgItemMessage(hDlg, IDC_CHECK_MODIFIERKEY, BM_SETCHECK, 1, 0);
				if(Action[Locate].Modifier & MODIFIER_CONTROL)
					SendDlgItemMessage(hDlg, IDC_CHECK_CONTROL, BM_SETCHECK, 1, 0);
				if(Action[Locate].Modifier & MODIFIER_SHIFT)
					SendDlgItemMessage(hDlg, IDC_CHECK_SHIFT, BM_SETCHECK, 1, 0);
			}
			for ( i = 0; i < Action[Locate].Repeat; i++ )
			{
				CommandEdit.Case[i] = Action[Locate].Case[i];
				CommandEdit.CommandTarget[i] = Action[Locate].CommandTarget[i];
				CommandEdit.Wait[i] = Action[Locate].Wait[i];
				CommandEdit.Key[i] = Action[Locate].Key[i];
			}
			CommandEdit.Repeat = Action[Locate].Repeat;
			for(i=0; i<CommandEdit.Repeat; i++)
				InsertCommandItem(hLVC, CommandEdit.Case[i], CommandEdit.Key[i], i, 0);
			SetDlgItemText(hDlg, IDC_EDIT_COMMENT, Action[Locate].Comment);
		}
		else
		{
			GestureButton = 3;
			for(i=0; i<MAX_GESTURE_LEVEL; i++)
				EditMove[i] = 0;
			CommandEdit.Repeat = 0;
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CONTROL), FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_SHIFT), FALSE);

		}
		switch(GestureButton)
		{
		case BUTTON_L:
			SendDlgItemMessage(hDlg, IDC_RADIO_L, BM_SETCHECK, 1, 0);
			break;
		case BUTTON_M:
			SendDlgItemMessage(hDlg, IDC_RADIO_M, BM_SETCHECK, 1, 0);
			break;
		case BUTTON_R:
			SendDlgItemMessage(hDlg, IDC_RADIO_R, BM_SETCHECK, 1, 0);
			break;
		case BUTTON_X1:
			SendDlgItemMessage(hDlg, IDC_RADIO_X1, BM_SETCHECK, 1, 0);
			break;
		case BUTTON_X2:
			SendDlgItemMessage(hDlg, IDC_RADIO_X2, BM_SETCHECK, 1, 0);
			break;
		case WHEEL_UP:
			SendDlgItemMessage(hDlg, IDC_RADIO_WHEELUP, BM_SETCHECK, 1, 0);
			break;
		case WHEEL_DOWN:
			SendDlgItemMessage(hDlg, IDC_RADIO_WHEELDOWN, BM_SETCHECK, 1, 0);
			break;
		case WHEEL_LEFT:
			SendDlgItemMessage(hDlg, IDC_RADIO_WHEELLEFT, BM_SETCHECK, 1, 0);
			break;
		case WHEEL_RIGHT:
			SendDlgItemMessage(hDlg, IDC_RADIO_WHEELRIGHT, BM_SETCHECK, 1, 0);
			break;
		case CORNER_TOP_A:
			SendDlgItemMessage(hDlg, IDC_RADIO_TOP_A, BM_SETCHECK, 1, 0);
			break;
		case CORNER_BOTTOM_A:
			SendDlgItemMessage(hDlg, IDC_RADIO_BOTTOM_A, BM_SETCHECK, 1, 0);
			break;
		case CORNER_LEFT_A:
			SendDlgItemMessage(hDlg, IDC_RADIO_LEFT_A, BM_SETCHECK, 1, 0);
			break;
		case CORNER_RIGHT_A:
			SendDlgItemMessage(hDlg, IDC_RADIO_RIGHT_A, BM_SETCHECK, 1, 0);
			break;
		case CORNER_TOPLEFT:
			SendDlgItemMessage(hDlg, IDC_RADIO_TOPLEFT, BM_SETCHECK, 1, 0);
			break;
		case CORNER_TOPRIGHT:
			SendDlgItemMessage(hDlg, IDC_RADIO_TOPRIGHT, BM_SETCHECK, 1, 0);
			break;
		case CORNER_BOTTOMLEFT:
			SendDlgItemMessage(hDlg, IDC_RADIO_BOTTOMLEFT, BM_SETCHECK, 1, 0);
			break;
		case CORNER_BOTTOMRIGHT:
			SendDlgItemMessage(hDlg, IDC_RADIO_BOTTOMRIGHT, BM_SETCHECK, 1, 0);
			break;
		case CORNER_TOP_B:
			SendDlgItemMessage(hDlg, IDC_RADIO_TOP_B, BM_SETCHECK, 1, 0);
			break;
		case CORNER_BOTTOM_B:
			SendDlgItemMessage(hDlg, IDC_RADIO_BOTTOM_B, BM_SETCHECK, 1, 0);
			break;
		case CORNER_LEFT_B:
			SendDlgItemMessage(hDlg, IDC_RADIO_LEFT_B, BM_SETCHECK, 1, 0);
			break;
		case CORNER_RIGHT_B:
			SendDlgItemMessage(hDlg, IDC_RADIO_RIGHT_B, BM_SETCHECK, 1, 0);
			break;
		case CORNER_TOP_C:
			SendDlgItemMessage(hDlg, IDC_RADIO_TOP_C, BM_SETCHECK, 1, 0);
			break;
		case CORNER_BOTTOM_C:
			SendDlgItemMessage(hDlg, IDC_RADIO_BOTTOM_C, BM_SETCHECK, 1, 0);
			break;
		case CORNER_LEFT_C:
			SendDlgItemMessage(hDlg, IDC_RADIO_LEFT_C, BM_SETCHECK, 1, 0);
			break;
		case CORNER_RIGHT_C:
			SendDlgItemMessage(hDlg, IDC_RADIO_RIGHT_C, BM_SETCHECK, 1, 0);
			break;
		}
		GestureToString(GestureButton, Code, 30);
		for(i=0; i<EditGestureLevel; i++)
		{
			GestureToString(EditMove[i], MoveS, 12);
			lstrcat( Code, MoveS );
		}
		SetDlgItemText(hDlg, IDC_EDIT_CODE, Code);
		nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
		EnableCommandItem(hDlg, nActiveIndexC, CommandEdit.Repeat);
		ListView_SetImageList(hLVC, ImageList_Create(1, GetSystemMetrics(SM_CYSMICON), ILC_COLOR, 0, 0), LVSIL_SMALL);
		break;
	case WM_DESTROY:
		ImageList_Destroy(ListView_GetImageList(hLVC, LVSIL_SMALL));
		break;
	case WM_NOTIFY:
		lpnmhdr = (NMHDR *)lParam;
		switch (lpnmhdr->code)
		{
		case NM_DBLCLK:
			if (lpnmhdr->hwndFrom == hLVC)
			{
				if(ListView_GetNextItem(hLVC, -1, LVNI_SELECTED) == -1)
					PostMessage(hDlg, WM_COMMAND, IDC_BUTTON_COMMANDADD, 0);
				else
					PostMessage(hDlg, WM_COMMAND, IDC_BUTTON_COMMANDEDIT, 0);
			}
			break;
		case NM_RCLICK:
			if(lpnmhdr->hwndFrom == hLVC)
			{
				int iItem;
				HMENU hMenu;
				POINT pt;
				iItem = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
				hMenu = CreatePopupMenu();
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_COMMANDADD, TEXT("R}hǉ..."));
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_COMMANDEDIT, TEXT("R}hҏW..."));
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_COMMANDDELETE, TEXT("R}h폜..."));
				if(CommandEdit.Repeat >= MAX_ACTION_REPEAT)
					EnableMenuItem(hMenu, IDC_BUTTON_COMMANDADD, MF_GRAYED|MF_BYCOMMAND);
				if(iItem==-1)	//IȂ
				{
					EnableMenuItem(hMenu, IDC_BUTTON_COMMANDEDIT, MF_GRAYED|MF_BYCOMMAND);
					EnableMenuItem(hMenu, IDC_BUTTON_COMMANDDELETE, MF_GRAYED|MF_BYCOMMAND);
				}
				GetCursorPos(&pt);
				TrackPopupMenuEx(hMenu, TPM_RIGHTBUTTON, pt.x, pt.y, hDlg, NULL);
				DestroyMenu(hMenu);
			}
			break;
		case LVN_ITEMCHANGED:
			if(lpnmhdr->hwndFrom == hLVC)
			{
				nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
				EnableCommandItem(hDlg, nActiveIndexC, CommandEdit.Repeat);
			}
			break;
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_RADIO_WHEELUP:
		case IDC_RADIO_WHEELDOWN:
		case IDC_RADIO_WHEELLEFT:
		case IDC_RADIO_WHEELRIGHT:
		case IDC_RADIO_TOP_A:
		case IDC_RADIO_TOP_B:
		case IDC_RADIO_TOP_C:
		case IDC_RADIO_BOTTOM_A:
		case IDC_RADIO_BOTTOM_B:
		case IDC_RADIO_BOTTOM_C:
		case IDC_RADIO_LEFT_A:
		case IDC_RADIO_LEFT_B:
		case IDC_RADIO_LEFT_C:
		case IDC_RADIO_RIGHT_A:
		case IDC_RADIO_RIGHT_B:
		case IDC_RADIO_RIGHT_C:
		case IDC_RADIO_TOPLEFT:
		case IDC_RADIO_TOPRIGHT:
		case IDC_RADIO_BOTTOMLEFT:
		case IDC_RADIO_BOTTOMRIGHT:
			if(GestureButton == BUTTON_L || GestureButton == BUTTON_M || GestureButton == BUTTON_R ||
				GestureButton == BUTTON_X1 || GestureButton == BUTTON_X2)
			{
				for(i=0; i<MAX_GESTURE_LEVEL; i++)
					EditMove[i] = 0;
				EditGestureLevel = 0;
			}
		case IDC_RADIO_L:
		case IDC_RADIO_M:
		case IDC_RADIO_R:
		case IDC_RADIO_X1:
		case IDC_RADIO_X2:
			switch (LOWORD(wParam))
			{
			case IDC_RADIO_L:
				GestureButton = BUTTON_L;
				break;
			case IDC_RADIO_M:
				GestureButton = BUTTON_M;
				break;
			case IDC_RADIO_R:
				GestureButton = BUTTON_R;
				break;
			case IDC_RADIO_X1:
				GestureButton = BUTTON_X1;
				break;
			case IDC_RADIO_X2:
				GestureButton = BUTTON_X2;
				break;
			case IDC_RADIO_WHEELUP:
				GestureButton = WHEEL_UP;
				break;
			case IDC_RADIO_WHEELDOWN:
				GestureButton = WHEEL_DOWN;
				break;
			case IDC_RADIO_WHEELLEFT:
				GestureButton = WHEEL_LEFT;
				break;
			case IDC_RADIO_WHEELRIGHT:
				GestureButton = WHEEL_RIGHT;
				break;
			case IDC_RADIO_TOP_A:
				GestureButton = CORNER_TOP_A;
				break;
			case IDC_RADIO_TOP_B:
				GestureButton = CORNER_TOP_B;
				break;
			case IDC_RADIO_TOP_C:
				GestureButton = CORNER_TOP_C;
				break;
			case IDC_RADIO_BOTTOM_A:
				GestureButton = CORNER_BOTTOM_A;
				break;
			case IDC_RADIO_BOTTOM_B:
				GestureButton = CORNER_BOTTOM_B;
				break;
			case IDC_RADIO_BOTTOM_C:
				GestureButton = CORNER_BOTTOM_C;
				break;
			case IDC_RADIO_LEFT_A:
				GestureButton = CORNER_LEFT_A;
				break;
			case IDC_RADIO_LEFT_B:
				GestureButton = CORNER_LEFT_B;
				break;
			case IDC_RADIO_LEFT_C:
				GestureButton = CORNER_LEFT_C;
				break;
			case IDC_RADIO_RIGHT_A:
				GestureButton = CORNER_RIGHT_A;
				break;
			case IDC_RADIO_RIGHT_B:
				GestureButton = CORNER_RIGHT_B;
				break;
			case IDC_RADIO_RIGHT_C:
				GestureButton = CORNER_RIGHT_C;
				break;
			case IDC_RADIO_TOPLEFT:
				GestureButton = CORNER_TOPLEFT;
				break;
			case IDC_RADIO_TOPRIGHT:
				GestureButton = CORNER_TOPRIGHT;
				break;
			case IDC_RADIO_BOTTOMLEFT:
				GestureButton = CORNER_BOTTOMLEFT;
				break;
			case IDC_RADIO_BOTTOMRIGHT:
				GestureButton = CORNER_BOTTOMRIGHT;
				break;
			}
			GestureToString(GestureButton, Code, 30);
			for(i=0; i<EditGestureLevel; i++)
			{
				GestureToString(EditMove[i], MoveS, 12);
				lstrcat( Code, MoveS );
			}
			SetDlgItemText(hDlg, IDC_EDIT_CODE, Code);
			break;
		case IDC_BUTTON_CLEAR:
			for(i=0; i<MAX_GESTURE_LEVEL; i++)
				EditMove[i] = 0;
			EditGestureLevel = 0;
			GestureToString(GestureButton, MoveS, 12);
			SetDlgItemText(hDlg, IDC_EDIT_CODE, MoveS);
			break;
		case IDC_BUTTON_UP:
		case IDC_BUTTON_DOWN:
		case IDC_BUTTON_LEFT:
		case IDC_BUTTON_RIGHT:
		case IDC_BUTTON_UPLEFT:
		case IDC_BUTTON_UPRIGHT:
		case IDC_BUTTON_DOWNLEFT:
		case IDC_BUTTON_DOWNRIGHT:
			if(GestureButton != BUTTON_L && GestureButton != BUTTON_M && GestureButton != BUTTON_R &&
				GestureButton != BUTTON_X1 && GestureButton != BUTTON_X2)
				break;
			if(EditMove[0] != MOVE_UP && EditMove[0] != MOVE_DOWN && EditMove[0] != MOVE_LEFT && EditMove[0] != MOVE_RIGHT &&
				EditMove[0] != MOVE_UPLEFT && EditMove[0] != MOVE_UPRIGHT && EditMove[0] != MOVE_DOWNLEFT && EditMove[0] != MOVE_DOWNRIGHT)
				EditGestureLevel = 0;
			switch (LOWORD(wParam))
			{
			case IDC_BUTTON_UP:
				Move = MOVE_UP;
				break;
			case IDC_BUTTON_DOWN:
				Move = MOVE_DOWN;
				break;
			case IDC_BUTTON_LEFT:
				Move = MOVE_LEFT;
				break;
			case IDC_BUTTON_RIGHT:
				Move = MOVE_RIGHT;
				break;
			case IDC_BUTTON_UPLEFT:
				Move = MOVE_UPLEFT;
				break;
			case IDC_BUTTON_UPRIGHT:
				Move = MOVE_UPRIGHT;
				break;
			case IDC_BUTTON_DOWNLEFT:
				Move = MOVE_DOWNLEFT;
				break;
			case IDC_BUTTON_DOWNRIGHT:
				Move = MOVE_DOWNRIGHT;
				break;
			}
			if(EditGestureLevel < MAX_GESTURE_LEVEL &&
				(EditMove[EditGestureLevel - 1] != Move ||
				EditGestureLevel == 0))
			{
				EditMove[EditGestureLevel] = Move;
				EditGestureLevel ++;
				GestureToString(GestureButton, Code, 30);
				for(i=0; i<EditGestureLevel; i++)
				{
					GestureToString(EditMove[i], MoveS, 12);
					lstrcat( Code, MoveS );
				}
				SetDlgItemText(hDlg, IDC_EDIT_CODE, Code);
			}
			break;
		case IDC_BUTTON_TOL:
		case IDC_BUTTON_TOM:
		case IDC_BUTTON_TOR:
		case IDC_BUTTON_TOX1:
		case IDC_BUTTON_TOX2:
		case IDC_BUTTON_TOWHEELUP:
		case IDC_BUTTON_TOWHEELDOWN:
		case IDC_BUTTON_TOWHEELLEFT:
		case IDC_BUTTON_TOWHEELRIGHT:
			if(GestureButton != BUTTON_L && GestureButton != BUTTON_M && GestureButton != BUTTON_R &&
				GestureButton != BUTTON_X1 && GestureButton != BUTTON_X2)
				break;
			for(i=1; i<MAX_GESTURE_LEVEL; i++)
				EditMove[i] = 0;
			EditGestureLevel = 0;
			switch (LOWORD(wParam))
			{
			case IDC_BUTTON_TOL:
				EditMove[0] = BUTTON_L;
				break;
			case IDC_BUTTON_TOM:
				EditMove[0] = BUTTON_M;
				break;
			case IDC_BUTTON_TOR:
				EditMove[0] = BUTTON_R;
				break;
			case IDC_BUTTON_TOX1:
				EditMove[0] = BUTTON_X1;
				break;
			case IDC_BUTTON_TOX2:
				EditMove[0] = BUTTON_X2;
				break;
			case IDC_BUTTON_TOWHEELUP:
				EditMove[0] = WHEEL_UP;
				break;
			case IDC_BUTTON_TOWHEELDOWN:
				EditMove[0] = WHEEL_DOWN;
				break;
			case IDC_BUTTON_TOWHEELLEFT:
				EditMove[0] = WHEEL_LEFT;
				break;
			case IDC_BUTTON_TOWHEELRIGHT:
				EditMove[0] = WHEEL_RIGHT;
				break;
			}
			GestureToString(GestureButton, Code, 30);
			GestureToString(EditMove[0], MoveS, 12);
			lstrcat( Code, MoveS );
			SetDlgItemText(hDlg, IDC_EDIT_CODE, Code);
			break;
		case IDC_CHECK_MODIFIERKEY:
			if(SendDlgItemMessage(hDlg, IDC_CHECK_MODIFIERKEY, BM_GETCHECK , 0L , 0L))
			{
				EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CONTROL), TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_CHECK_SHIFT), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg, IDC_CHECK_CONTROL), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_CHECK_SHIFT), FALSE);
			}
			break;
		case IDC_BUTTON_COMMANDADD:	//R}hǉ
		case IDC_BUTTON_COMMANDEDIT:	//R}hҏW
			if(LOWORD(wParam)==IDC_BUTTON_COMMANDADD)	//R}hǉ
			{
				if(CommandEdit.Repeat >= MAX_ACTION_REPEAT)
					break;	//ǉłȂ
				CommandEdit.Locate = CommandEdit.Repeat;
			}
			if(LOWORD(wParam)==IDC_BUTTON_COMMANDEDIT)	//R}hҏW
			{
				CommandEdit.Locate = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
				if(CommandEdit.Locate == -1)
					break;	//ҏWłȂ
			}

			if(DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_COMMAND), hDlg, CommandDialogProc, (LPARAM)&CommandEdit))
			{
				if(CommandEdit.Case[CommandEdit.Locate] != 0)
				{
					InsertCommandItem(hLVC, CommandEdit.Case[CommandEdit.Locate], CommandEdit.Key[CommandEdit.Locate], CommandEdit.Locate, 0);
					if(LOWORD(wParam)==IDC_BUTTON_COMMANDADD)
						ListView_SetItemState(hLVC, ListView_GetItemCount(hLVC)-1, LVIS_FOCUSED|LVIS_SELECTED, LVIS_FOCUSED|LVIS_SELECTED);	//ǉR}hI
					nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
					EnableCommandItem(hDlg, nActiveIndexC, CommandEdit.Repeat);
				}
			}
			break;
		case IDC_BUTTON_COMMANDDELETE:
			if(MessageBox(hDlg, TEXT("̃R}h폜Ă낵łH"), TEXT("R}h̍폜"), MB_YESNO) != IDYES)
				break;
			CommandEdit.Locate = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
			if(CommandEdit.Locate == -1)
				break;
			CommandDelete(&CommandEdit);
			ListView_DeleteItem(hLVC, CommandEdit.Locate);
			if(ListView_GetItemCount(hLVC)>0)
			{
				int iItem = CommandEdit.Locate;
				if(iItem==ListView_GetItemCount(hLVC))
					iItem--;
				ListView_SetItemState(hLVC, iItem, LVIS_FOCUSED|LVIS_SELECTED, LVIS_FOCUSED|LVIS_SELECTED);
			}
			nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
			EnableCommandItem(hDlg, nActiveIndexC, CommandEdit.Repeat);
			break;
		case IDC_BUTTON_COMMANDUP:
			nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
			if(nActiveIndexC <= 0 || nActiveIndexC == CommandEdit.Repeat)
				break;
			std::swap(CommandEdit.Case[nActiveIndexC - 1], CommandEdit.Case[nActiveIndexC]);
			std::swap(CommandEdit.CommandTarget[nActiveIndexC - 1], CommandEdit.CommandTarget[nActiveIndexC]);
			std::swap(CommandEdit.Wait[nActiveIndexC - 1], CommandEdit.Wait[nActiveIndexC]);
			std::swap(CommandEdit.Key[nActiveIndexC - 1], CommandEdit.Key[nActiveIndexC]);
			ListView_DeleteItem(hLVC, nActiveIndexC - 1);
			InsertCommandItem(hLVC, CommandEdit.Case[nActiveIndexC], CommandEdit.Key[nActiveIndexC], nActiveIndexC, 1);
			IniChange = TRUE;
			nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
			EnableCommandItem(hDlg, nActiveIndexC, CommandEdit.Repeat);
			break;
		case IDC_BUTTON_COMMANDDOWN:
			nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
			if(nActiveIndexC == -1 || nActiveIndexC >= CommandEdit.Repeat - 1)
				break;
			std::swap(CommandEdit.Case[nActiveIndexC], CommandEdit.Case[nActiveIndexC + 1]);
			std::swap(CommandEdit.CommandTarget[nActiveIndexC], CommandEdit.CommandTarget[nActiveIndexC + 1]);
			std::swap(CommandEdit.Wait[nActiveIndexC], CommandEdit.Wait[nActiveIndexC + 1]);
			std::swap(CommandEdit.Key[nActiveIndexC], CommandEdit.Key[nActiveIndexC + 1]);
			ListView_DeleteItem(hLVC, nActiveIndexC + 1);
			InsertCommandItem(hLVC, CommandEdit.Case[nActiveIndexC], CommandEdit.Key[nActiveIndexC], nActiveIndexC, 1);
			IniChange = TRUE;
			nActiveIndexC = ListView_GetNextItem(hLVC, -1, LVNI_SELECTED);
			EnableCommandItem(hDlg, nActiveIndexC, CommandEdit.Repeat);
			break;
		case IDOK:
			if(SendDlgItemMessage(hDlg, IDC_COMBO_TARGET, CB_GETCURSEL, 0L, 0L) < (int)Target.size())
				a.TargetNumber = Target[(int)SendDlgItemMessage(hDlg, IDC_COMBO_TARGET, CB_GETCURSEL, 0L, 0L)].Number;
			else
				a.TargetNumber = 0;
			a.Button = GestureButton;
			for(i=0; i<MAX_GESTURE_LEVEL; i++)
				a.Move[i] = EditMove[i];
			if(SendDlgItemMessage(hDlg, IDC_CHECK_MODIFIERKEY, BM_GETCHECK, 0L, 0L))
			{
				a.Modifier = 0;
				if(SendDlgItemMessage(hDlg, IDC_CHECK_CONTROL, BM_GETCHECK, 0L, 0L))
					a.Modifier |= MODIFIER_CONTROL;
				if(SendDlgItemMessage(hDlg, IDC_CHECK_SHIFT, BM_GETCHECK, 0L, 0L))
					a.Modifier |= MODIFIER_SHIFT;
			}
			else
			{
				a.Modifier = MODIFIER_DISABLE;
			}
			a.Repeat = CommandEdit.Repeat;
			for(i=0; i<CommandEdit.Repeat; i++)
			{
				a.Case[i] = CommandEdit.Case[i];
				a.CommandTarget[i] = CommandEdit.CommandTarget[i];
				a.Wait[i] = CommandEdit.Wait[i];
				a.Key[i] = CommandEdit.Key[i];
			}
			a.BreakPoint = 0;
			GetDlgItemText(hDlg, IDC_EDIT_COMMENT, a.Comment, MAX_COMMENT);
			if(Locate == (int)Action.size())
				Action.push_back(a);
			else
				Action[Locate] = a;

			GetWindowPosition(hDlg, &ActionDialog);
			IniChange = TRUE;
			EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

void ActionDelete(int Locate)
{
	std::vector<struct ExecuteCommand>::iterator it = Action.begin();
	it+=Locate;
	Action.erase(it);
}

void TargetDelete(int Locate)
{
	int i, j;

	for(i=0;i<(int)Target.size();i++)
	{
		if(Target[i].DefaultThru == Target[Locate].Number)
			Target[i].DefaultThru = -1;
	}

	for(i=(int)Action.size()-1;i>=0;i--)
	{
		if(Target[Locate].Number == Action[i].TargetNumber)
		{
			ActionDelete(i);
		}
		else
		{
			for(j=0;j<Action[i].Repeat;j++)
			{
				if(Action[i].CommandTarget[j] == Target[Locate].Number)
					Action[i].CommandTarget[j] = 0;
			}
		}
	}

	std::vector<struct TargetWindow>::iterator it = Target.begin();
	it+=Locate;
	Target.erase(it);
}

void EnableActionItem(HWND hDlg, int nActiveIndexA)
{
	if((int)Action.size() >= MAX_ACTION_DATA)
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_ACTIONADD), FALSE);
	else
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_ACTIONADD), TRUE);
	if(nActiveIndexA == -1)
	{
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_ACTIONEDIT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_ACTIONDELETE), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_ACTIONEDIT), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_ACTIONDELETE), TRUE);
	}
}

void EnableTargetItem(HWND hDlg, int nActiveIndexT)
{
	if((int)Target.size() >= MAX_TARGET_DATA)
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETADD), FALSE);
	else
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETADD), TRUE);
	if(nActiveIndexT == -1)
	{
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETEDIT), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETDELETE), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETUP), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETDOWN), FALSE);
	}
	else
	{
		if(nActiveIndexT < (int)Target.size())
		{
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETEDIT), TRUE);
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETDELETE), TRUE);
		}
		else
		{
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETEDIT), FALSE);
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETDELETE), FALSE);
		}
		if(nActiveIndexT <= 0 || nActiveIndexT == (int)Target.size())
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETUP), FALSE);
		else
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETUP), TRUE);
		if(nActiveIndexT == -1 || nActiveIndexT >= (int)Target.size() - 1)
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETDOWN), FALSE);
		else
			EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_TARGETDOWN), TRUE);
	}
}

void CALLBACK NaviDeleteProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	lstrcpy(GestureString, NaviTitle);
	lstrcpy(CommentString, TEXT(""));
	if(PopupFlag == FALSE)
	{
		switch(NaviType)
		{
		case 1:
			NaviRefresh(hwnd);
			break;
		case 2:
			ShowParam = FALSE;
			ShowMauSujiNavi(hwnd, ShowParam);
			break;
		}
	}
	KillTimer(hwnd, ID_NAVITIMER);
	NaviDrawFlag = FALSE;
}

void NaviEditRefresh(HWND hWnd)
{
	switch(NaviType)
	{
	case 1:
		lstrcpy(GestureString, NaviTitle);
		lstrcpy(CommentString, TEXT(""));
		NaviRefresh(hWnd);
		break;
	case 2:
		ShowParam = FALSE;
		NaviRefresh(hWnd);
		SetTimer(hWnd, ID_NAVITIMER, NaviDeleteTime, NaviDeleteProc);
		break;
	}
}

//}E؃irݒ_CAO
INT_PTR CALLBACK NaviEditDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hWnd;
	CHOOSEFONT cf;
	CHOOSECOLOR cc;
	static int NaviWidthMax = GetSystemMetrics(SM_CXSCREEN);
	#define NaviWidthMin 0
	#define NaviDeleteTimeMax 3000
	#define NaviDeleteTimeMin 0
	#define TipLocateXMax 100
	#define TipLocateXMin -100
	#define TipLocateYMax 100
	#define TipLocateYMin -100
	static int TempNaviType, TempNaviDeleteTime, TempNaviWidth;
	static long TempHeight, TempWeight; 
	static BYTE TempItalic, TempCharSet;
	static TCHAR TempFaceName[70];
	int i, TempScroll;
	static TCHAR NaviTypeString[3][40] = {TEXT("\Ȃ"), TEXT("Œ\"), TEXT("c[`bv\")};
	static TCHAR TempNaviTitle[MAX_PATH + 1];
	static COLORREF CustColors[16], TempMainColor, TempSubColor, TempBackColor;
	static POINT TempTipLocate;
	static HFONT hFont12px = NULL;	//vr[p12sNZ̃tHg
	static HBRUSH hBrushMain, hBrushSub, hBrushBack;
	HBRUSH hBrushOld;

	switch (msg)
	{
	case WM_INITDIALOG:
		hWnd = (HWND)lParam;
		SetWindowPos( hDlg, NULL, NaviEditDialog.x, NaviEditDialog.y, NULL, NULL, SWP_NOSIZE | SWP_NOZORDER );
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIDELETETIME), SB_CTL, NaviDeleteTimeMin, NaviDeleteTimeMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIDELETETIME), SB_CTL, NaviDeleteTime, TRUE);
		if(NaviDeleteTime == NaviDeleteTimeMin)
			SetDlgItemText(hDlg, IDC_EDIT_NAVIDELETETIME, TEXT(""));
		else
			SetDlgItemInt(hDlg, IDC_EDIT_NAVIDELETETIME, NaviDeleteTime, TRUE);
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIWIDTH), SB_CTL, NaviWidthMin, NaviWidthMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIWIDTH), SB_CTL, NaviWidth, TRUE);
		if(NaviWidth == NaviWidthMin)
			SetDlgItemText(hDlg, IDC_EDIT_NAVIWIDTH, TEXT(""));
		else
			SetDlgItemInt(hDlg, IDC_EDIT_NAVIWIDTH, NaviWidth, TRUE);
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEX), SB_CTL, TipLocateXMin, TipLocateXMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEX), SB_CTL, TipLocate.x, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_TIPLOCATEX, TipLocate.x, TRUE);
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEY), SB_CTL, TipLocateYMin, TipLocateYMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEY), SB_CTL, TipLocate.y, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_TIPLOCATEY, TipLocate.y, TRUE);
		TempNaviDeleteTime = NaviDeleteTime;
		TempNaviType = NaviType;
		TempNaviWidth = NaviWidth;
		TempHeight = lf.lfHeight;
		lstrcpy(TempFaceName, lf.lfFaceName);
		TempWeight = lf.lfWeight;
		TempItalic = lf.lfItalic;
		TempCharSet = lf.lfCharSet;
		TempMainColor = MainColor;
		TempSubColor = SubColor;
		TempBackColor = BackColor;
		lstrcpy(TempNaviTitle, NaviTitle);
		TempTipLocate = TipLocate;
		for ( i = 0; i <= 2; i++ )
			SendDlgItemMessage(hDlg, IDC_COMBO_NAVITYPE, CB_INSERTSTRING, (WPARAM)i, (LPARAM)NaviTypeString[i]);
		SendDlgItemMessage(hDlg, IDC_COMBO_NAVITYPE, CB_SETCURSEL, NaviType, 0L);
		SetDlgItemText(hDlg, IDC_EDIT_NAVITITLE, NaviTitle);
		hFont12px = CreateFont(12, 0, 0, 0, lf.lfWeight, lf.lfItalic, 0, 0, lf.lfCharSet, 0, 0, 0, 0, lf.lfFaceName);
		SendMessage(GetDlgItem(hDlg, IDC_STATIC_FONT), WM_SETFONT, (WPARAM)hFont12px, MAKELPARAM(TRUE, 0));
		hBrushMain = CreateSolidBrush(MainColor);
		hBrushSub = CreateSolidBrush(SubColor);
		hBrushBack = CreateSolidBrush(BackColor);
		break;
	case WM_DESTROY:
		if(hFont12px)
			DeleteObject(hFont12px);
		DeleteObject(hBrushMain);
		DeleteObject(hBrushSub);
		DeleteObject(hBrushBack);
		break;
	case WM_HSCROLL:
		if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIDELETETIME))
		{
			TempScroll = NaviDeleteTime;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				NaviDeleteTime--;
				break;
			case SB_LINERIGHT:
				NaviDeleteTime++;
				break;
			case SB_PAGELEFT:
				NaviDeleteTime -= 50;
				break;
			case SB_PAGERIGHT:
				NaviDeleteTime += 50;
				break;
			case SB_THUMBTRACK:
				NaviDeleteTime = (int)(HIWORD(wParam));
				break;
			}
			if (NaviDeleteTime < NaviDeleteTimeMin)
				NaviDeleteTime = NaviDeleteTimeMin;
			if (NaviDeleteTime > NaviDeleteTimeMax)
				NaviDeleteTime = NaviDeleteTimeMax;
			if(TempScroll != NaviDeleteTime)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIDELETETIME), SB_CTL, NaviDeleteTime, TRUE);
				if(NaviDeleteTime == NaviDeleteTimeMin)
					SetDlgItemText(hDlg, IDC_EDIT_NAVIDELETETIME, TEXT(""));
				else
					SetDlgItemInt(hDlg, IDC_EDIT_NAVIDELETETIME, NaviDeleteTime, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIWIDTH))
		{
			TempScroll = NaviWidth;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				NaviWidth--;
				break;
			case SB_LINERIGHT:
				NaviWidth++;
				break;
			case SB_PAGELEFT:
				NaviWidth -= 10;
				break;
			case SB_PAGERIGHT:
				NaviWidth += 10;
				break;
			case SB_THUMBTRACK:
				NaviWidth = (int)(HIWORD(wParam));
				break;
			}
			if (NaviWidth < NaviWidthMin)
				NaviWidth = NaviWidthMin;
			if (NaviWidth > NaviWidthMax)
				NaviWidth = NaviWidthMax;
			if(TempScroll != NaviWidth)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_NAVIWIDTH), SB_CTL, NaviWidth, TRUE);
				if(NaviWidth == NaviWidthMin)
					SetDlgItemText(hDlg, IDC_EDIT_NAVIWIDTH, TEXT(""));
				else
					SetDlgItemInt(hDlg, IDC_EDIT_NAVIWIDTH, NaviWidth, TRUE);
				NaviEditRefresh(hWnd);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEX))
		{
			TempScroll = TipLocate.x;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				TipLocate.x--;
				break;
			case SB_LINERIGHT:
				TipLocate.x++;
				break;
			case SB_PAGELEFT:
				TipLocate.x -= 10;
				break;
			case SB_PAGERIGHT:
				TipLocate.x += 10;
				break;
			case SB_THUMBTRACK:
				TipLocate.x =(SHORT)(HIWORD(wParam));
				break;
			}
			if (TipLocate.x < TipLocateXMin)
				TipLocate.x = TipLocateXMin;
			if (TipLocate.x > TipLocateXMax)
				TipLocate.x = TipLocateXMax;
			if(TempScroll != TipLocate.x)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEX), SB_CTL, TipLocate.x, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_TIPLOCATEX, TipLocate.x, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEY))
		{
			TempScroll = TipLocate.y;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				TipLocate.y--;
				break;
			case SB_LINERIGHT:
				TipLocate.y++;
				break;
			case SB_PAGELEFT:
				TipLocate.y -= 10;
				break;
			case SB_PAGERIGHT:
				TipLocate.y += 10;
				break;
			case SB_THUMBTRACK:
				TipLocate.y =(SHORT)(HIWORD(wParam));
				break;
			}
			if (TipLocate.y < TipLocateYMin)
				TipLocate.y = TipLocateYMin;
			if (TipLocate.y > TipLocateYMax)
				TipLocate.y = TipLocateYMax;
			if(TempScroll != TipLocate.y)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_TIPLOCATEY), SB_CTL, TipLocate.y, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_TIPLOCATEY, TipLocate.y, TRUE);
			}
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_COMBO_NAVITYPE:
			if(HIWORD(wParam)==CBN_SELCHANGE)
			{
				if(SendDlgItemMessage(hDlg, IDC_COMBO_NAVITYPE, CB_GETCURSEL, 0L, 0L) >= 0)
					NaviType = (int)SendDlgItemMessage(hDlg, IDC_COMBO_NAVITYPE, CB_GETCURSEL, 0L, 0L);
				NaviEditRefresh(hWnd);
				if(NaviType < 2)
					ShowMauSujiNavi(hWnd, NaviType);
			}
			break;
		case IDC_EDIT_NAVITITLE:
			if (HIWORD(wParam) == EN_UPDATE)
			{
				GetDlgItemText(hDlg, IDC_EDIT_NAVITITLE, NaviTitle, _MAX_PATH);
				NaviEditRefresh(hWnd);
			}
			break;
		case IDC_BUTTON_CHOOSEFONT:
			memset(&cf, 0, sizeof(CHOOSEFONT));    
			cf.lStructSize = sizeof(CHOOSEFONT);
			cf.hwndOwner   = hDlg;
			cf.lpLogFont   = &lf;
			cf.Flags       = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT | CF_FORCEFONTEXIST | CF_NOVERTFONTS;
			if(ChooseFont(&cf))
			{
				if(hFont)
					DeleteObject(hFont);
				hFont = CreateFontIndirect(&lf);
				NaviHeight = GetNaviHeight() + 4;
				if(hFont12px)
					DeleteObject(hFont12px);
				hFont12px = CreateFont(12, 0, 0, 0, lf.lfWeight, lf.lfItalic, 0, 0, lf.lfCharSet, 0, 0, 0, 0, lf.lfFaceName);
				SendMessage(GetDlgItem(hDlg, IDC_STATIC_FONT), WM_SETFONT, (WPARAM)hFont12px, MAKELPARAM(TRUE, 0));
				NaviEditRefresh(hWnd);
			}
			break;
		case IDC_BUTTON_CHOOSEMAINCOLOR:
			memset(&cc, 0, sizeof(CHOOSECOLOR));    
			cc.lStructSize  = sizeof (CHOOSECOLOR);
			cc.hwndOwner    = hDlg;
			cc.rgbResult    = MainColor;
			cc.lpCustColors	= CustColors;
			cc.Flags        = CC_RGBINIT;
			if(ChooseColor(&cc))
			{
				MainColor = cc.rgbResult;
				DeleteObject(hBrushMain);
				hBrushMain = CreateSolidBrush(MainColor);
				InvalidateRect(hDlg, NULL, TRUE);
				NaviEditRefresh(hWnd);
			}
			break;
		case IDC_BUTTON_CHOOSESUBCOLOR:
			memset(&cc, 0, sizeof(CHOOSECOLOR));    
			cc.lStructSize  = sizeof (CHOOSECOLOR);
			cc.hwndOwner    = hDlg;
			cc.rgbResult    = SubColor;
			cc.lpCustColors	= CustColors;
			cc.Flags        = CC_RGBINIT;
			if(ChooseColor(&cc))
			{
				SubColor = cc.rgbResult;
				DeleteObject(hBrushSub);
				hBrushSub = CreateSolidBrush(SubColor);
				InvalidateRect(hDlg, NULL, TRUE);
				NaviEditRefresh(hWnd);
			}
			break;
		case IDC_BUTTON_CHOOSEBACKCOLOR:
			memset(&cc, 0, sizeof(CHOOSECOLOR));    
			cc.lStructSize  = sizeof (CHOOSECOLOR);
			cc.hwndOwner    = hDlg;
			cc.rgbResult    = BackColor;
			cc.lpCustColors	= CustColors;
			cc.Flags        = CC_RGBINIT;
			if(ChooseColor(&cc))
			{
				BackColor = cc.rgbResult;
				DeleteObject(hBrushBack);
				hBrushBack = CreateSolidBrush(BackColor);
				hBrushOld = (HBRUSH)SetClassLongPtr(hWnd, GCLP_HBRBACKGROUND, (LONG_PTR)CreateSolidBrush(BackColor));
				DeleteObject(hBrushOld);
				InvalidateRect(hDlg, NULL, TRUE);
				NaviEditRefresh(hWnd);
			}
			break;
		case IDOK:
			GetWindowPosition(hDlg, &NaviEditDialog);
			IniChange = TRUE;
			EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:
			NaviDeleteTime = TempNaviDeleteTime;
			NaviType = TempNaviType;
			NaviWidth = TempNaviWidth;
			lf.lfHeight = TempHeight;
			lstrcpy(lf.lfFaceName, TempFaceName);
			lf.lfWeight = TempWeight;
			lf.lfItalic = TempItalic;
			lf.lfCharSet = TempCharSet;
			MainColor = TempMainColor;
			SubColor = TempSubColor;
			BackColor = TempBackColor;
			hBrushOld = (HBRUSH)SetClassLongPtr(hWnd, GCLP_HBRBACKGROUND, (LONG_PTR)CreateSolidBrush(BackColor));
			DeleteObject(hBrushOld);
			lstrcpy(NaviTitle, TempNaviTitle);
			TipLocate = TempTipLocate;
			if(hFont)
				DeleteObject(hFont);
			hFont = CreateFontIndirect(&lf);
			NaviHeight = GetNaviHeight() + 4;
			if(NaviType < 2)
				ShowMauSujiNavi(hWnd, NaviType);
			NaviEditRefresh(hWnd);
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	case WM_CTLCOLORSTATIC:
		switch(GetDlgCtrlID((HWND)lParam))
		{
		case IDC_STATIC_MAINCOLOR:
			return (INT_PTR)hBrushMain;
		case IDC_STATIC_SUBCOLOR:
			return (INT_PTR)hBrushSub;
		case IDC_STATIC_BACKCOLOR:
			return (INT_PTR)hBrushBack;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

void ToggleMouseHook(HWND hDlg)
{
	static HWND hDialog;

	if(hDlg == NULL)
		//ݒ_CAOJĂAA^XNgC̃j[ݒύXƂAݒ_CAOɃbZ[W|Xg
		PostMessage(hDialog, WM_COMMAND, IDM_MOUSEHOOK, 0);
	else
		hDialog = hDlg;
}

void ToggleWheelRedirect(HWND hDlg)
{
	static HWND hDialog;

	if(hDlg == NULL)
		//ݒ_CAOJĂAA^XNgC̃j[ݒύXƂAݒ_CAOɃbZ[W|Xg
		PostMessage(hDialog, WM_COMMAND, IDM_WHEELREDIRECT, 0);
	else
		hDialog = hDlg;
}

int SearchActionList(int *TargetNumber, int *ActionLocate)
{
	int i, j, k, l, m, n;

	m = 0;
	for ( i = 0; i <= MAX_TARGET_THRU; i++ )
	{
		if(TargetNumber[i] >= 0)
		{
			for(j = 0; j < (int)Action.size(); j++)
			{
				if((TargetNumber[i] < (int)Target.size() && Action[j].TargetNumber == Target[TargetNumber[i]].Number) ||
					(TargetNumber[i] == (int)Target.size() && Action[j].TargetNumber == 0))
				{
					n = 0;
					for ( k = i - 1; k >= 0; k--)
					{
						if(TargetNumber[k] >= 0 && n == 0)
						{
							for ( l = 0; l < (int)Action.size(); l++ )
							{
								if(Action[l].TargetNumber == Target[TargetNumber[k]].Number &&
									Action[l].Button == Action[j].Button &&
									Action[l].Move[0] == Action[j].Move[0] &&
									Action[l].Move[1] == Action[j].Move[1] &&
									Action[l].Move[2] == Action[j].Move[2] &&
									Action[l].Move[3] == Action[j].Move[3] &&
									Action[l].Move[4] == Action[j].Move[4] &&
									Action[l].Move[5] == Action[j].Move[5] &&
									Action[l].Move[6] == Action[j].Move[6] &&
									Action[l].Move[7] == Action[j].Move[7] &&
									Action[l].Move[8] == Action[j].Move[8] &&
									Action[l].Move[9] == Action[j].Move[9])
									n = 1;
							}
						}
					}
					if(n == 0)
					{
						ActionLocate[m] = j;
						m ++;
					}
				}
			}
		}
	}
	return m;
}

//xݒ_CAO
INT_PTR CALLBACK QuantityDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	#define CheckIntervalMax 50
	#define CheckIntervalMin 1
	#define MoveQuantityMax 100
	#define MoveQuantityMin 1
	#define GestureTimeOutMax 1000
	#define GestureTimeOutMin 0
	static int GestureStartQuantityMax;
	#define GestureStartQuantityMin 1
	#define CornerTimeMax 1000
	#define CornerTimeMin 0
	#define CornerPosXMax 500
	#define CornerPosXMin 0
	#define CornerPosYMax 500
	#define CornerPosYMin 0
	#define ClickWaitMax 100
	#define ClickWaitMin 0
	#define ScrollSensitivityMax 200
	#define ScrollSensitivityMin 5
	#define CircleRateMax 100
	#define CircleRateMin 1
	#define KuruKuruTimeOutMax 3000
	#define KuruKuruTimeOutMin 20
	static int TempCheckInterval;
	static int TempMoveQuantity;
	static int TempGestureTimeOut;
	static int TempGestureStartQuantity;
	static int TempCornerTime;
	static int TempCornerPosX;
	static int TempCornerPosY;
	static int TempClickWait;
	static int TempScrollSensitivity;
	static int TempCircleRate;
	static int TempKuruKuruTimeOut;

	int TempScroll;

	switch (msg)
	{
	case WM_INITDIALOG:
		SetWindowPos( hDlg, HWND_TOPMOST, QuantityDialog.x, QuantityDialog.y, NULL, NULL, SWP_NOSIZE );
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_CHECKINTERVAL), SB_CTL, CheckIntervalMin, CheckIntervalMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CHECKINTERVAL), SB_CTL, CheckInterval, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_CHECKINTERVAL, CheckInterval, TRUE);
		TempCheckInterval = CheckInterval;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_MOVEQUANTITY), SB_CTL, MoveQuantityMin, MoveQuantityMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_MOVEQUANTITY), SB_CTL, MoveQuantity, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_MOVEQUANTITY, MoveQuantity, TRUE);
		TempMoveQuantity = MoveQuantity;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_GESTURETIMEOUT), SB_CTL, GestureTimeOutMin, GestureTimeOutMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_GESTURETIMEOUT), SB_CTL, GestureTimeOut, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_GESTURETIMEOUT, GestureTimeOut, TRUE);
		TempGestureTimeOut = GestureTimeOut;
		GestureStartQuantityMax = MoveQuantity;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_STARTQUANTITY), SB_CTL, GestureStartQuantityMin, GestureStartQuantityMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_STARTQUANTITY), SB_CTL, GestureStartQuantity, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_STARTQUANTITY, GestureStartQuantity, TRUE);
		TempGestureStartQuantity = GestureStartQuantity;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERTIME), SB_CTL, CornerTimeMin, CornerTimeMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERTIME), SB_CTL, CornerTime, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_CORNERTIME, CornerTime, TRUE);
		TempCornerTime = CornerTime;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSX), SB_CTL, CornerPosXMin, CornerPosXMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSX), SB_CTL, CornerPosX, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_CORNERPOSX, CornerPosX, TRUE);
		TempCornerPosX = CornerPosX;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSY), SB_CTL, CornerPosYMin, CornerPosYMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSY), SB_CTL, CornerPosY, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_CORNERPOSY, CornerPosY, TRUE);
		TempCornerPosY = CornerPosY;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_CLICKWAIT), SB_CTL, ClickWaitMin, ClickWaitMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CLICKWAIT), SB_CTL, ClickWait, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_CLICKWAIT, ClickWait, TRUE);
		TempClickWait = ClickWait;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLLSENSITIVITY), SB_CTL, ScrollSensitivityMin, ScrollSensitivityMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLLSENSITIVITY), SB_CTL, ScrollSensitivity, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_SCROLLSENSITIVITY, ScrollSensitivity, TRUE);
		TempScrollSensitivity = ScrollSensitivity;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_KURUKURUTIMEOUT), SB_CTL, KuruKuruTimeOutMin, KuruKuruTimeOutMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_KURUKURUTIMEOUT), SB_CTL, KuruKuruTimeOut, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_KURUKURUTIMEOUT, KuruKuruTimeOut, TRUE);
		TempKuruKuruTimeOut = KuruKuruTimeOut;
		SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_CIRCLERATE), SB_CTL, CircleRateMin, CircleRateMax, TRUE);
		SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CIRCLERATE), SB_CTL, CircleRate, TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_CIRCLERATE, CircleRate, TRUE);
		TempCircleRate = CircleRate;
		break;
	case WM_HSCROLL:
		if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_CHECKINTERVAL))
		{
			TempScroll = CheckInterval;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				CheckInterval--;
				break;
			case SB_LINERIGHT:
				CheckInterval++;
				break;
			case SB_PAGELEFT:
				CheckInterval -= 10;
				break;
			case SB_PAGERIGHT:
				CheckInterval += 10;
				break;
			case SB_THUMBTRACK:
				CheckInterval = (int)(HIWORD(wParam));
				break;
			}
			if (CheckInterval < CheckIntervalMin)
				CheckInterval = CheckIntervalMin;
			if (CheckInterval > CheckIntervalMax)
				CheckInterval = CheckIntervalMax;
			if(TempScroll != CheckInterval)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CHECKINTERVAL), SB_CTL, CheckInterval, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_CHECKINTERVAL, CheckInterval, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_MOVEQUANTITY))
		{
			TempScroll = MoveQuantity;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				MoveQuantity--;
				break;
			case SB_LINERIGHT:
				MoveQuantity++;
				break;
			case SB_PAGELEFT:
				MoveQuantity -= 10;
				break;
			case SB_PAGERIGHT:
				MoveQuantity += 10;
				break;
			case SB_THUMBTRACK:
				MoveQuantity = (int)(HIWORD(wParam));
				break;
			}
			if (MoveQuantity < MoveQuantityMin)
				MoveQuantity = MoveQuantityMin;
			if (MoveQuantity > MoveQuantityMax)
				MoveQuantity = MoveQuantityMax;
			if(TempScroll != MoveQuantity)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_MOVEQUANTITY), SB_CTL, MoveQuantity, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_MOVEQUANTITY, MoveQuantity, TRUE);
				GestureStartQuantityMax = MoveQuantity;
				if(GestureStartQuantity > GestureStartQuantityMax)
					GestureStartQuantity = GestureStartQuantityMax;
				SetScrollRange(GetDlgItem(hDlg, IDC_SCROLLBAR_STARTQUANTITY), SB_CTL, GestureStartQuantityMin, GestureStartQuantityMax, TRUE);
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_STARTQUANTITY), SB_CTL, GestureStartQuantity, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_STARTQUANTITY, GestureStartQuantity, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_GESTURETIMEOUT))
		{
			TempScroll = GestureTimeOut;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				GestureTimeOut--;
				break;
			case SB_LINERIGHT:
				GestureTimeOut++;
				break;
			case SB_PAGELEFT:
				GestureTimeOut -= 10;
				break;
			case SB_PAGERIGHT:
				GestureTimeOut += 10;
				break;
			case SB_THUMBTRACK:
				GestureTimeOut = (int)(HIWORD(wParam));
				break;
			}
			if (GestureTimeOut < GestureTimeOutMin)
				GestureTimeOut = GestureTimeOutMin;
			if (GestureTimeOut > GestureTimeOutMax)
				GestureTimeOut = GestureTimeOutMax;
			if(TempScroll != GestureTimeOut)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_GESTURETIMEOUT), SB_CTL, GestureTimeOut, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_GESTURETIMEOUT, GestureTimeOut, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_STARTQUANTITY))
		{
			TempScroll = GestureStartQuantity;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				GestureStartQuantity--;
				break;
			case SB_LINERIGHT:
				GestureStartQuantity++;
				break;
			case SB_PAGELEFT:
				GestureStartQuantity -= 10;
				break;
			case SB_PAGERIGHT:
				GestureStartQuantity += 10;
				break;
			case SB_THUMBTRACK:
				GestureStartQuantity = (int)(HIWORD(wParam));
				break;
			}
			if (GestureStartQuantity < GestureStartQuantityMin)
				GestureStartQuantity = GestureStartQuantityMin;
			if (GestureStartQuantity > GestureStartQuantityMax)
				GestureStartQuantity = GestureStartQuantityMax;
			if(TempScroll != GestureStartQuantity)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_STARTQUANTITY), SB_CTL, GestureStartQuantity, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_STARTQUANTITY, GestureStartQuantity, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERTIME))
		{
			TempScroll = CornerTime;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				CornerTime--;
				break;
			case SB_LINERIGHT:
				CornerTime++;
				break;
			case SB_PAGELEFT:
				CornerTime -= 10;
				break;
			case SB_PAGERIGHT:
				CornerTime += 10;
				break;
			case SB_THUMBTRACK:
				CornerTime = (int)(HIWORD(wParam));
				break;
			}
			if (CornerTime < CornerTimeMin)
				CornerTime = CornerTimeMin;
			if (CornerTime > CornerTimeMax)
				CornerTime = CornerTimeMax;
			if(TempScroll != CornerTime)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERTIME), SB_CTL, CornerTime, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_CORNERTIME, CornerTime, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSX))
		{
			TempScroll = CornerPosX;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				CornerPosX--;
				break;
			case SB_LINERIGHT:
				CornerPosX++;
				break;
			case SB_PAGELEFT:
				CornerPosX -= 10;
				break;
			case SB_PAGERIGHT:
				CornerPosX += 10;
				break;
			case SB_THUMBTRACK:
				CornerPosX = (int)(HIWORD(wParam));
				break;
			}
			if (CornerPosX < CornerPosXMin)
				CornerPosX = CornerPosXMin;
			if (CornerPosX > CornerPosXMax)
				CornerPosX = CornerPosXMax;
			if(TempScroll != CornerPosX)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSX), SB_CTL, CornerPosX, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_CORNERPOSX, CornerPosX, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSY))
		{
			TempScroll = CornerPosY;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				CornerPosY--;
				break;
			case SB_LINERIGHT:
				CornerPosY++;
				break;
			case SB_PAGELEFT:
				CornerPosY -= 10;
				break;
			case SB_PAGERIGHT:
				CornerPosY += 10;
				break;
			case SB_THUMBTRACK:
				CornerPosY = (int)(HIWORD(wParam));
				break;
			}
			if (CornerPosY < CornerPosYMin)
				CornerPosY = CornerPosYMin;
			if (CornerPosY > CornerPosYMax)
				CornerPosY = CornerPosYMax;
			if(TempScroll != CornerPosY)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CORNERPOSY), SB_CTL, CornerPosY, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_CORNERPOSY, CornerPosY, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_CLICKWAIT))
		{
			TempScroll = ClickWait;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				ClickWait--;
				break;
			case SB_LINERIGHT:
				ClickWait++;
				break;
			case SB_PAGELEFT:
				ClickWait -= 10;
				break;
			case SB_PAGERIGHT:
				ClickWait += 10;
				break;
			case SB_THUMBTRACK:
				ClickWait = (int)(HIWORD(wParam));
				break;
			}
			if (ClickWait < ClickWaitMin)
				ClickWait = ClickWaitMin;
			if (ClickWait > ClickWaitMax)
				ClickWait = ClickWaitMax;
			if(TempScroll != ClickWait)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CLICKWAIT), SB_CTL, ClickWait, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_CLICKWAIT, ClickWait, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLLSENSITIVITY))
		{
			TempScroll = ScrollSensitivity;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				ScrollSensitivity--;
				break;
			case SB_LINERIGHT:
				ScrollSensitivity++;
				break;
			case SB_PAGELEFT:
				ScrollSensitivity -= 10;
				break;
			case SB_PAGERIGHT:
				ScrollSensitivity += 10;
				break;
			case SB_THUMBTRACK:
				ScrollSensitivity = (int)(HIWORD(wParam));
				break;
			}
			if (ScrollSensitivity < ScrollSensitivityMin)
				ScrollSensitivity = ScrollSensitivityMin;
			if (ScrollSensitivity > ScrollSensitivityMax)
				ScrollSensitivity = ScrollSensitivityMax;
			if(TempScroll != ScrollSensitivity)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_SCROLLSENSITIVITY), SB_CTL, ScrollSensitivity, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_SCROLLSENSITIVITY, ScrollSensitivity, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_KURUKURUTIMEOUT))
		{
			TempScroll = KuruKuruTimeOut;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				KuruKuruTimeOut--;
				break;
			case SB_LINERIGHT:
				KuruKuruTimeOut++;
				break;
			case SB_PAGELEFT:
				KuruKuruTimeOut -= 10;
				break;
			case SB_PAGERIGHT:
				KuruKuruTimeOut += 10;
				break;
			case SB_THUMBTRACK:
				KuruKuruTimeOut = (int)(HIWORD(wParam));
				break;
			}
			if (KuruKuruTimeOut < KuruKuruTimeOutMin)
				KuruKuruTimeOut = KuruKuruTimeOutMin;
			if (KuruKuruTimeOut > KuruKuruTimeOutMax)
				KuruKuruTimeOut = KuruKuruTimeOutMax;
			if(TempScroll != KuruKuruTimeOut)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_KURUKURUTIMEOUT), SB_CTL, KuruKuruTimeOut, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_KURUKURUTIMEOUT, KuruKuruTimeOut, TRUE);
			}
		}
		else if((HWND)lParam == GetDlgItem(hDlg, IDC_SCROLLBAR_CIRCLERATE))
		{
			TempScroll = CircleRate;
			switch(LOWORD(wParam))
			{
			case SB_LINELEFT:
				CircleRate--;
				break;
			case SB_LINERIGHT:
				CircleRate++;
				break;
			case SB_PAGELEFT:
				CircleRate -= 10;
				break;
			case SB_PAGERIGHT:
				CircleRate += 10;
				break;
			case SB_THUMBTRACK:
				CircleRate = (int)(HIWORD(wParam));
				break;
			}
			if (CircleRate < CircleRateMin)
				CircleRate = CircleRateMin;
			if (CircleRate > CircleRateMax)
				CircleRate = CircleRateMax;
			if(TempScroll != CircleRate)
			{
				SetScrollPos(GetDlgItem(hDlg, IDC_SCROLLBAR_CIRCLERATE), SB_CTL, CircleRate, TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_CIRCLERATE, CircleRate, TRUE);
			}
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			GetWindowPosition(hDlg, &QuantityDialog);
			IniChange = TRUE;
			EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:
			CheckInterval = TempCheckInterval;
			MoveQuantity = TempMoveQuantity;
			GestureTimeOut = TempGestureTimeOut;
			GestureStartQuantity = TempGestureStartQuantity;
			CornerTime = TempCornerTime;
			CornerPosX = TempCornerPosX;
			CornerPosY = TempCornerPosY;
			ClickWait = TempClickWait;
			ScrollSensitivity = TempScrollSensitivity;
			CircleRate = TempCircleRate;
			KuruKuruTimeOut = TempKuruKuruTimeOut;
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	default:
		return FALSE;
	}

	return TRUE;
}

//}Eؐݒ_CAO
INT_PTR CALLBACK IniEditDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hWnd;
	static HMENU hMenu;
	static HWND hLVT, hLVA;
	static int ActionLocate[MAX_ACTION_DATA], TargetNumber[MAX_TARGET_THRU + 1];
	NMHDR *lpnmhdr;
	OPENFILENAME ofn;
	int nActiveIndexT, nActiveIndexA, LV_TargetLocate, LV_ActionLocate;
	int i, j;
	BOOL IniChangeTemp;
	int SelectedTargetNumber;
	int iItem;

	switch(msg)
	{
	case WM_INITDIALOG:
		hWnd = (HWND)lParam;
		hMenu = GetMenu(hDlg);
		IniChangeTemp = IniChange;
		SendMessage(hDlg, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1)));
		SetWindowPos(hDlg, HWND_TOPMOST, IniEditDialog.x, IniEditDialog.y, NULL, NULL, SWP_NOSIZE);
		hLVT = GetDlgItem(hDlg, IDC_LIST_TARGET);
		InitializeLVT(hLVT);
		for(i=0; i<=(int)Target.size(); i++)
			InsertTargetItem(hLVT, i, 0);
		hLVA = GetDlgItem(hDlg, IDC_LIST_ACTION);
		InitializeLVA(hLVA);
		if(Default.HookType)
			CheckMenuItem( hMenu, IDM_DEFAULTHOOKTYPE, MF_BYCOMMAND | MF_CHECKED );
		if(Default.WheelRedirect)
			CheckMenuItem( hMenu, IDM_DEFAULTWHEELREDIRECT, MF_BYCOMMAND | MF_CHECKED );
		if(Priority == 0x0080)
			CheckMenuItem( hMenu, IDM_HIGH_PRIORITY, MF_BYCOMMAND | MF_CHECKED );
		if(CursorChange)
			CheckMenuItem( hMenu, IDM_CURSORCHANGE, MF_BYCOMMAND | MF_CHECKED );
		if(ShowTaskTray)
			CheckMenuItem( hMenu, IDM_SHOWTASKTRAY, MF_BYCOMMAND | MF_CHECKED );
		if(GestureDirection == 4)
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_4, MF_BYCOMMAND);
		if(GestureDirection == 8)
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_8, MF_BYCOMMAND);
		if(GestureDirection == -8)
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_84, MF_BYCOMMAND);
		if(GestureDirection == -4)
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_44, MF_BYCOMMAND);
		if(TimeOutType)
			CheckMenuItem( hMenu, IDM_TIMEOUTTYPE, MF_BYCOMMAND | MF_CHECKED );
		if(WheelActive)
			CheckMenuItem( hMenu, IDM_WHEELACTIVE, MF_BYCOMMAND | MF_CHECKED );
		if(KuruKuruFlag)
			CheckMenuItem( hMenu, IDM_KURUKURU, MF_BYCOMMAND | MF_CHECKED );
		if(Default.FreeScroll)
			CheckMenuItem( hMenu, IDM_FREESCROLLMODE, MF_BYCOMMAND | MF_CHECKED );
		if(WheelRedirect)
			CheckMenuItem( hMenu, IDM_WHEELREDIRECT, MF_BYCOMMAND | MF_CHECKED );
		ToggleMouseHook(hDlg);	//_CAÕEBhEnhZbg
		ToggleWheelRedirect(hDlg);	//_CAÕEBhEnhZbg
		if(MouseHookFlag == TRUE)
			CheckMenuItem( hMenu, IDM_MOUSEHOOK, MF_BYCOMMAND | MF_CHECKED );
		if(ListViewHitTestFlag)
			CheckMenuItem( hMenu, IDM_TARGET_LISTVIEW, MF_BYCOMMAND | MF_CHECKED );
		else
			CheckMenuItem( hMenu, IDM_TARGET_LISTVIEW, MF_BYCOMMAND | MF_UNCHECKED );
		if(TreeViewHitTestFlag)
			CheckMenuItem( hMenu, IDM_TARGET_TREEVIEW, MF_BYCOMMAND | MF_CHECKED );
		else
			CheckMenuItem( hMenu, IDM_TARGET_TREEVIEW, MF_BYCOMMAND | MF_UNCHECKED );
		SetDlgItemText(hDlg, IDC_EDIT_GESTURECURSOR, GestureCursor);
		SetDlgItemText(hDlg, IDC_EDIT_WAITCURSOR, WaitCursor);
		IniChange = IniChangeTemp;
		nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
		EnableTargetItem(hDlg, nActiveIndexT);
		nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
		EnableActionItem(hDlg, nActiveIndexA);
		ListView_SetImageList(hLVT, ImageList_Create(1, GetSystemMetrics(SM_CYSMICON), ILC_COLOR, 0, 0), LVSIL_SMALL);
		ListView_SetImageList(hLVA, ImageList_Create(1, GetSystemMetrics(SM_CYSMICON), ILC_COLOR, 0, 0), LVSIL_SMALL);
		ListView_SetExtendedListViewStyle(hLVT, ListView_GetExtendedListViewStyle(hLVT)|LVS_EX_INFOTIP);
		SetWindowPos(ListView_GetToolTips(hLVT), HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE);
		_SetForegroundWindow(hDlg);
		break;
	case WM_DESTROY:
		ImageList_Destroy(ListView_GetImageList(hLVT, LVSIL_SMALL));
		ImageList_Destroy(ListView_GetImageList(hLVA, LVSIL_SMALL));
		break;
	case WM_NOTIFY:
		lpnmhdr = (NMHDR *)lParam;
		switch(lpnmhdr->code)
		{
		case NM_DBLCLK:
			if(lpnmhdr->hwndFrom == hLVT)
			{
				if(ListView_GetNextItem(hLVT, -1, LVNI_SELECTED)==-1)
					PostMessage(hDlg, WM_COMMAND, IDC_BUTTON_TARGETADD, 0);
				else
					PostMessage(hDlg, WM_COMMAND, IDC_BUTTON_TARGETEDIT,0);
			}
			if(lpnmhdr->hwndFrom == hLVA)
			{
				if(ListView_GetNextItem(hLVA, -1, LVNI_SELECTED)==-1)
					PostMessage(hDlg, WM_COMMAND, IDC_BUTTON_ACTIONADD, 0);
				else
					PostMessage(hDlg, WM_COMMAND, IDC_BUTTON_ACTIONEDIT,0);
			}
			break;
		case NM_RCLICK:
			if(lpnmhdr->hwndFrom == hLVT)
			{
				int iItem;
				HMENU hMenu;
				POINT pt;
				iItem = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				hMenu = CreatePopupMenu();
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_TARGETADD, TEXT("^[Qbgǉ..."));
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_TARGETEDIT, TEXT("^[QbgҏW..."));
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_TARGETDELETE, TEXT("^[Qbg폜..."));
				if((int)Target.size() >= MAX_TARGET_DATA)
					EnableMenuItem(hMenu, IDC_BUTTON_TARGETADD, MF_GRAYED|MF_BYCOMMAND);
				if(iItem==-1 || iItem==(int)Target.size())	//IȂDefault
				{
					EnableMenuItem(hMenu, IDC_BUTTON_TARGETEDIT, MF_GRAYED|MF_BYCOMMAND);
					EnableMenuItem(hMenu, IDC_BUTTON_TARGETDELETE, MF_GRAYED|MF_BYCOMMAND);
				}
				GetCursorPos(&pt);
				TrackPopupMenuEx(hMenu, TPM_RIGHTBUTTON, pt.x, pt.y, hDlg, NULL);
				DestroyMenu(hMenu);
			}
			if(lpnmhdr->hwndFrom == hLVA)
			{
				int iItem;
				HMENU hMenu;
				POINT pt;
				iItem = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
				hMenu = CreatePopupMenu();
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_ACTIONADD, TEXT("ANVǉ..."));
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_ACTIONEDIT, TEXT("ANVҏW..."));
				AppendMenu(hMenu, MF_STRING, IDC_BUTTON_ACTIONDELETE, TEXT("ANV폜..."));
				if((int)Action.size() >= MAX_ACTION_DATA)
					EnableMenuItem(hMenu, IDC_BUTTON_ACTIONADD, MF_GRAYED|MF_BYCOMMAND);
				if(iItem==-1)	//IȂ
				{
					EnableMenuItem(hMenu, IDC_BUTTON_ACTIONEDIT, MF_GRAYED|MF_BYCOMMAND);
					EnableMenuItem(hMenu, IDC_BUTTON_ACTIONDELETE, MF_GRAYED|MF_BYCOMMAND);
				}
				GetCursorPos(&pt);
				TrackPopupMenuEx(hMenu, TPM_RIGHTBUTTON, pt.x, pt.y, hDlg, NULL);
				DestroyMenu(hMenu);
			}
			break;
		case NM_SETFOCUS:
			if(lpnmhdr->hwndFrom == hLVA)
			{
				nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
				EnableActionItem(hDlg, nActiveIndexA);
			}
			break;
		case NM_CUSTOMDRAW:
			if(lpnmhdr->hwndFrom == hLVA)
			{
				LPNMLVCUSTOMDRAW lplvcd;
				lplvcd = (NMLVCUSTOMDRAW *)lParam;
				switch(lplvcd->nmcd.dwDrawStage)
				{
				case CDDS_PREPAINT:
					SetWindowLongPtr(hDlg, DWLP_MSGRESULT, (LONG_PTR)CDRF_NOTIFYITEMDRAW);
					break;
				case CDDS_ITEMPREPAINT:
					nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
					if(nActiveIndexT < (int)Target.size() &&
						Action[ActionLocate[lplvcd->nmcd.dwItemSpec]].TargetNumber != Target[nActiveIndexT].Number)
					{
						lplvcd->clrText = GetSysColor(COLOR_GRAYTEXT);
						SetWindowLongPtr(hDlg, DWLP_MSGRESULT, (LONG_PTR)CDRF_NEWFONT);
					}
					break;
				}
			}
			break;
		case LVN_ITEMCHANGED:
			if(lpnmhdr->hwndFrom == hLVT)
			{
				nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				EnableTargetItem(hDlg, nActiveIndexT);
				ListView_DeleteAllItems(hLVA);
				if(nActiveIndexT > -1)
				{
					SortAction();
					SetThruNumber(nActiveIndexT, TargetNumber);
					i = SearchActionList(TargetNumber, ActionLocate);
					for(j = 0; j < i; j++)
						InsertActionItem(hLVA, ActionLocate[j], j);
				}
				nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
				EnableActionItem(hDlg, nActiveIndexA);
			}
			if(lpnmhdr->hwndFrom == hLVA)
			{
				if(nActiveIndexA != ListView_GetNextItem(hLVA, -1, LVNI_SELECTED))
				{
					nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
					EnableActionItem(hDlg, nActiveIndexA);
				}
			}
			break;
		case LVN_GETINFOTIP:
			if(lpnmhdr->hwndFrom == hLVT)
			{
				LPNMLVGETINFOTIP pGetInfoTip = (LPNMLVGETINFOTIP)lParam;
				TCHAR szText[1024];

				if(pGetInfoTip->iItem==(int)Target.size())
				{
					wsprintf(szText, TEXT("}EXbZ[W肷: %s\nANeBułXN[: %s\nt[XN[: %s"),
						Default.HookType ? TEXT("L") : TEXT(""),
						Default.WheelRedirect ? TEXT("L") : TEXT(""),
						Default.FreeScroll ? TEXT("L") : TEXT(""));
				}
				else
				{
					TCHAR szBaseTargetName[1024];

					if(Target[pGetInfoTip->iItem].DefaultThru<0)
					{
						lstrcpy(szBaseTargetName, TEXT("pȂ"));
					}
					else if(Target[pGetInfoTip->iItem].DefaultThru==0)
					{
						lstrcpy(szBaseTargetName, TEXT("Default"));
					}
					else
					{
						int i;

						for(i=0;i<(int)Target.size();i++)
						{
							if(Target[i].Number==Target[pGetInfoTip->iItem].DefaultThru)
							{
								if(Target[i].Comment[0])
									lstrcpy(szBaseTargetName, Target[i].Comment);
								else
									wsprintf(szBaseTargetName, TEXT("%s %s"), Target[i].FileName[0] ? Target[i].FileName : TEXT("---"), Target[i].ClassName);
							}
						}
					}

					wsprintf(szText, TEXT("t@C: %s\nNX: %s\nID: %s\np: %s\n}EXbZ[W肷: %s\nANeBułXN[: %s\nt[XN[: %s\nRg: %s"),
						Target[pGetInfoTip->iItem].FileName,
						Target[pGetInfoTip->iItem].ClassName,
						Target[pGetInfoTip->iItem].ControlID,
						szBaseTargetName,
						Target[pGetInfoTip->iItem].HookType ? TEXT("L") : TEXT(""),
						Target[pGetInfoTip->iItem].WheelRedirect ? TEXT("L") : TEXT(""),
						Target[pGetInfoTip->iItem].FreeScroll ? TEXT("L") : TEXT(""),
						Target[pGetInfoTip->iItem].Comment);
				}
				lstrcpyn(pGetInfoTip->pszText, szText, pGetInfoTip->cchTextMax);
			}
			break;
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_EDIT_GESTURECURSOR:
			if (HIWORD(wParam) == EN_UPDATE)
			{
				GetDlgItemText(hDlg, IDC_EDIT_GESTURECURSOR, GestureCursor, _MAX_PATH);
				SetCursorHandle(GestureCursor, WaitCursor, CursorChange);
				IniChange = TRUE;
			}
			break;
		case IDC_EDIT_WAITCURSOR:
			if (HIWORD(wParam) == EN_UPDATE)
			{
				GetDlgItemText(hDlg, IDC_EDIT_WAITCURSOR, WaitCursor, _MAX_PATH);
				SetCursorHandle(GestureCursor, WaitCursor, CursorChange);
				IniChange = TRUE;
			}
			break;
		case IDC_BUTTON_GESTURECURSOR:
			memset(&ofn, 0, sizeof(OPENFILENAME));    
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFilter = TEXT("|C^ (*.ani, *.cur)\0*.ani;*.cur\0Aj[V |C^ (*.ani)\0*.ani\0ÓI|C^ (*.cur)\0*.cur\0ׂẴt@C\0*.*\0"); //tB^
			ofn.lpstrFile = GestureCursor; //Iꂽt@C󂯎(tpX)
			ofn.nMaxFile = _MAX_PATH;
			ofn.lpstrTitle = TEXT("WFX`[J[\̑I"); //_CAO{bNX̃^Cg
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			if(GetOpenFileName(&ofn))
				SetDlgItemText(hDlg, IDC_EDIT_GESTURECURSOR, GestureCursor);
			break;
		case IDC_BUTTON_WAITCURSOR:
			memset(&ofn, 0, sizeof(OPENFILENAME));    
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFilter = TEXT("|C^ (*.ani, *.cur)\0*.ani;*.cur\0Aj[V |C^ (*.ani)\0*.ani\0ÓI|C^ (*.cur)\0*.cur\0ׂẴt@C\0*.*\0"); //tB^
			ofn.lpstrFile = WaitCursor; //Iꂽt@C󂯎(tpX)
			ofn.nMaxFile = _MAX_PATH;
			ofn.lpstrTitle = TEXT("WFX`[Jn҂J[\̑I"); //_CAO{bNX̃^Cg
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			if(GetOpenFileName(&ofn))
				SetDlgItemText(hDlg, IDC_EDIT_WAITCURSOR, WaitCursor);
			break;
		case IDC_BUTTON_TARGETADD:	//^[Qbgǉ
			if((int)Target.size() >= MAX_TARGET_DATA)
				break;
			LV_TargetLocate = (int)Target.size();
			if(DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_TARGET), hDlg, TargetDialogProc, (LPARAM)-1))
			{
				InsertTargetItem(hLVT, LV_TargetLocate, 0);
				ListView_SetItemState(hLVT, ListView_GetItemCount(hLVT)-2, LVIS_FOCUSED|LVIS_SELECTED, LVIS_FOCUSED|LVIS_SELECTED);	//ǉ^[QbgI
				nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				EnableTargetItem(hDlg, nActiveIndexT);
				//ANVACeXgXV
				ListView_DeleteAllItems(hLVA);
			}
			break;
		case IDC_BUTTON_TARGETEDIT:	//^[QbgҏW
			LV_TargetLocate = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			if(LV_TargetLocate == -1 || LV_TargetLocate == (int)Target.size())//Target:Default͕ҏWȂ
				break;
			if(DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_TARGET), hDlg, TargetDialogProc, (LPARAM)LV_TargetLocate))
			{
				InsertTargetItem(hLVT, LV_TargetLocate, 0);
				nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				EnableTargetItem(hDlg, nActiveIndexT);
				//ANVACeXgXV
				ListView_DeleteAllItems(hLVA);
				SetThruNumber(nActiveIndexT, TargetNumber);
				i = SearchActionList(TargetNumber, ActionLocate);
				for(j = 0; j < i; j++)
					InsertActionItem(hLVA, ActionLocate[j], j);
				nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
				EnableActionItem(hDlg, nActiveIndexA);
			}
			break;
		case IDC_BUTTON_ACTIONADD:	//ANVǉ
		case IDC_BUTTON_ACTIONEDIT:	//ANVҏW
			if(LOWORD(wParam)==IDC_BUTTON_ACTIONADD)	//ANVǉ
			{
				if((int)Action.size() >= MAX_ACTION_DATA)
					break;

				LV_TargetLocate = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				if(LV_TargetLocate == -1)
				{
					ListView_SetItemState(hLVT, ListView_GetItemCount(hLVT)-1, LVIS_FOCUSED|LVIS_SELECTED, LVIS_FOCUSED|LVIS_SELECTED);
					LV_TargetLocate = (int)Target.size();
				}

				LV_ActionLocate = (int)Action.size();
				if(LV_TargetLocate < (int)Target.size())
					SelectedTargetNumber = Target[LV_TargetLocate].Number;
				else
					SelectedTargetNumber = 0;
			}
			if(LOWORD(wParam)==IDC_BUTTON_ACTIONEDIT)	//ANVҏW
			{
				nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
				if(nActiveIndexA == -1)
					break;

				LV_TargetLocate = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				if(LV_TargetLocate == -1)
					LV_TargetLocate = (int)Target.size();

				if(LV_TargetLocate < (int)Target.size() &&
					nActiveIndexA >= 0 && Action[ActionLocate[nActiveIndexA]].TargetNumber != Target[TargetNumber[0]].Number)
				{
					if(MessageBox(hDlg, TEXT("̃ANVҏWƁA\n̐ݒɂe^\܂낵łH"), TEXT("pĂANVҏW悤ƂĂ܂"), MB_YESNO) != IDYES)
						break;
				}

				LV_ActionLocate = ActionLocate[nActiveIndexA];
				SelectedTargetNumber = Action[LV_ActionLocate].TargetNumber;
			}

			if(DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_ACTION), hDlg, ActionDialogProc, MAKELPARAM(LV_ActionLocate, SelectedTargetNumber)))
			{
				nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
				EnableTargetItem(hDlg, nActiveIndexT);
				//ANVACeXgXV
				ListView_DeleteAllItems(hLVA);
				if(nActiveIndexT > -1)
				{
					SortAction();
					SetThruNumber(nActiveIndexT, TargetNumber);
					i = SearchActionList(TargetNumber, ActionLocate);
					for(j = 0; j < i; j++)
						InsertActionItem(hLVA, ActionLocate[j], j);
				}
				//todo
				//ANVǉ/ҏWAIԂɂ
				//Ƃ肠AIȂԂɂĂ
				nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
				EnableActionItem(hDlg, nActiveIndexA);
			}
			break;
		case IDC_BUTTON_TARGETDELETE:
			if(MessageBox(hDlg, TEXT("̃^[Qbg̓o^𖕏Ă낵łH\ñ^[Qbgɑ΂ANV͑Sč폜܂B"), TEXT("^[Qbg̍폜"), MB_YESNO) != IDYES)
				break;
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			if(nActiveIndexT == -1)
				break;
			iItem = nActiveIndexT;	//폜ACëʒu
			TargetDelete(nActiveIndexT);
			ListView_DeleteItem(hLVT, nActiveIndexT);
			if(ListView_GetItemCount(hLVT)>0)
			{
				if(iItem==ListView_GetItemCount(hLVT))
					iItem--;
				ListView_SetItemState(hLVT, iItem, LVIS_FOCUSED|LVIS_SELECTED, LVIS_FOCUSED|LVIS_SELECTED);
			}
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			EnableTargetItem(hDlg, nActiveIndexT);
			IniChange = TRUE;
			break;
		case IDC_BUTTON_ACTIONDELETE:
			nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
			if(nActiveIndexA == -1)
				break;
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			if(nActiveIndexT == -1)
				break;
			if(nActiveIndexT < (int)Target.size() &&
				Action[ActionLocate[nActiveIndexA]].TargetNumber != Target[TargetNumber[0]].Number)
			{
				if(MessageBox(hDlg, TEXT("̃ANV폜ƁA\n̐ݒɂe^\܂낵łH"), TEXT("pĂANV폜悤ƂĂ܂"), MB_YESNO) != IDYES)
					break;
			}
			else
			{
				if(MessageBox(hDlg, TEXT("̃ANV폜Ă낵łH"), TEXT("ANV̍폜"), MB_YESNO) != IDYES)
					break;
			}
			iItem = nActiveIndexA;	//폜ACëʒu
			ActionDelete(ActionLocate[nActiveIndexA]);
			ListView_DeleteAllItems(hLVA);
			i = SearchActionList(TargetNumber, ActionLocate);
			for(j = 0; j < i; j++)
				InsertActionItem(hLVA, ActionLocate[j], j);
			if(ListView_GetItemCount(hLVA)>0)
			{
				if(iItem==ListView_GetItemCount(hLVA))
					iItem--;
				ListView_SetItemState(hLVA, iItem, LVIS_FOCUSED|LVIS_SELECTED, LVIS_FOCUSED|LVIS_SELECTED);
			}
			IniChange = TRUE;
			nActiveIndexA = ListView_GetNextItem(hLVA, -1, LVNI_SELECTED);
			EnableActionItem(hDlg, nActiveIndexA);
			break;
		case IDC_BUTTON_TARGETUP:
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			if(nActiveIndexT <= 0 || nActiveIndexT == (int)Target.size())
				break;
			std::swap(Target[nActiveIndexT - 1], Target[nActiveIndexT]);
			ListView_DeleteItem(hLVT, nActiveIndexT - 1);
			InsertTargetItem(hLVT, nActiveIndexT, 1);
			IniChange = TRUE;
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			EnableTargetItem(hDlg, nActiveIndexT);
			break;
		case IDC_BUTTON_TARGETDOWN:
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			if(nActiveIndexT == -1 || nActiveIndexT >= (int)Target.size() - 1)
				break;
			std::swap(Target[nActiveIndexT], Target[nActiveIndexT + 1]);
			ListView_DeleteItem(hLVT, nActiveIndexT + 1);
			InsertTargetItem(hLVT, nActiveIndexT, 1);
			IniChange = TRUE;
			nActiveIndexT = ListView_GetNextItem(hLVT, -1, LVNI_SELECTED);
			EnableTargetItem(hDlg,nActiveIndexT);
			break;
		case IDM_OPENHELP:
			OpenHelp();
			break;
		case IDM_VERSIONINFO:
			ShowVersionInfo(hDlg);
			break;
		case IDM_SHOWTASKTRAY:
			ShowTaskTray = !ShowTaskTray;
			if(ShowTaskTray)
			{
				MyTaskTray(hWnd);
				CheckMenuItem( hMenu, IDM_SHOWTASKTRAY, MF_BYCOMMAND | MF_CHECKED );
			}
			else
			{
				MyTaskTray(NULL);
				CheckMenuItem( hMenu, IDM_SHOWTASKTRAY, MF_BYCOMMAND | MF_UNCHECKED );
			}
			IniChange = TRUE;
			break;
		case IDM_CURSORCHANGE:
			CursorChange = !CursorChange;
			if(CursorChange)
				CheckMenuItem( hMenu, IDM_CURSORCHANGE, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_CURSORCHANGE, MF_BYCOMMAND | MF_UNCHECKED );
			SetCursorHandle(GestureCursor, WaitCursor, CursorChange);
			IniChange = TRUE;
			break;
		case IDM_GESTUREDIRECTION_4:
			GestureDirection = 4;
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_4, MF_BYCOMMAND);
			IniChange = TRUE;
			break;
		case IDM_GESTUREDIRECTION_8:
			GestureDirection = 8;
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_8, MF_BYCOMMAND);
			IniChange = TRUE;
			break;
		case IDM_GESTUREDIRECTION_84:
			GestureDirection = -8;
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_84, MF_BYCOMMAND);
			IniChange = TRUE;
			break;
		case IDM_GESTUREDIRECTION_44:
			GestureDirection = -4;
			CheckMenuRadioItem(hMenu, IDM_GESTUREDIRECTION_8, IDM_GESTUREDIRECTION_44, IDM_GESTUREDIRECTION_44, MF_BYCOMMAND);
			IniChange = TRUE;
			break;
		case IDM_TIMEOUTTYPE:
			TimeOutType = !TimeOutType;
			if(TimeOutType)
				CheckMenuItem( hMenu, IDM_TIMEOUTTYPE, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_TIMEOUTTYPE, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_DEFAULTHOOKTYPE:
			Default.HookType = !Default.HookType;
			if(Default.HookType)
				CheckMenuItem( hMenu, IDM_DEFAULTHOOKTYPE, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_DEFAULTHOOKTYPE, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_HIGH_PRIORITY:
			if(Priority != 0x0080)
			{
				Priority = 0x0080;
				CheckMenuItem( hMenu, IDM_HIGH_PRIORITY, MF_BYCOMMAND | MF_CHECKED );
			}
			else
			{
				Priority = 0x0020;
				CheckMenuItem( hMenu, IDM_HIGH_PRIORITY, MF_BYCOMMAND | MF_UNCHECKED );
			}
			SetPriorityClass(GetCurrentProcess(), Priority);
			IniChange = TRUE;
			break;
		case IDM_DEFAULTWHEELREDIRECT:
			Default.WheelRedirect = !Default.WheelRedirect;
			if(Default.WheelRedirect)
				CheckMenuItem( hMenu, IDM_DEFAULTWHEELREDIRECT, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_DEFAULTWHEELREDIRECT, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_WHEELREDIRECT:
			WheelRedirect = !WheelRedirect;
			SetWheelRedirectFlag(WheelRedirect);
			if(WheelRedirect)
				CheckMenuItem( hMenu, IDM_WHEELREDIRECT, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_WHEELREDIRECT, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_WHEELACTIVE:
			WheelActive = !WheelActive;
			SetWheelActiveFlag(WheelActive);
			if(WheelActive)
				CheckMenuItem( hMenu, IDM_WHEELACTIVE, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_WHEELACTIVE, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_KURUKURU:
			KuruKuruFlag = !KuruKuruFlag;
			if(KuruKuruFlag)
				CheckMenuItem( hMenu, IDM_KURUKURU, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_KURUKURU, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_FREESCROLLMODE:
			Default.FreeScroll = !Default.FreeScroll;
			if(Default.FreeScroll)
				CheckMenuItem( hMenu, IDM_FREESCROLLMODE, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_FREESCROLLMODE, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_NAVIEDIT:
			DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_NAVIEDIT), hDlg, NaviEditDialogProc, (LPARAM)hWnd);
			break;
		case IDM_QUANTITY:
			DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_QUANTITY), hDlg, QuantityDialogProc, (LPARAM)hWnd);
			break;
		case IDM_ENDMAUSUJI:	//}E؂I
			if(IniChange == TRUE)
			{
				switch(MessageBox(hDlg, TEXT("ύXꂽݒۑ܂H"), TEXT("}E؂I"), MB_YESNOCANCEL))
				{
				case IDYES:
					PostMessage(hDlg, WM_COMMAND, IDOK, 0);
					break;
				case IDNO:
					PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
					break;
				case IDCANCEL:
					return TRUE;
				}
			}
			else
			{
				EndDialog(hDlg, FALSE);
			}
			PostMessage(hWnd, WM_COMMAND, IDM_ENDMAUSUJI, 0);	//CEBhEIDM_ENDMAUSUJI|Xg
			break;
		case IDM_MOUSEHOOK:
			MouseHookFlag = !MouseHookFlag;
			if(MouseHookFlag)
			{
				SetMouseHook(hWnd);
				CheckMenuItem( hMenu, IDM_MOUSEHOOK, MF_BYCOMMAND | MF_CHECKED );
			}
			else
			{
				MouseUnHook();
				CheckMenuItem( hMenu, IDM_MOUSEHOOK, MF_BYCOMMAND | MF_UNCHECKED );
			}
			break;
		case IDM_TARGET_LISTVIEW:
			ListViewHitTestFlag = !ListViewHitTestFlag;
			SetListViewHitTestFlag(ListViewHitTestFlag);
			if(ListViewHitTestFlag)
				CheckMenuItem( hMenu, IDM_TARGET_LISTVIEW, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_TARGET_LISTVIEW, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDM_TARGET_TREEVIEW:
			TreeViewHitTestFlag = !TreeViewHitTestFlag;
			SetTreeViewHitTestFlag(TreeViewHitTestFlag);
			if(TreeViewHitTestFlag)
				CheckMenuItem( hMenu, IDM_TARGET_TREEVIEW, MF_BYCOMMAND | MF_CHECKED );
			else
				CheckMenuItem( hMenu, IDM_TARGET_TREEVIEW, MF_BYCOMMAND | MF_UNCHECKED );
			IniChange = TRUE;
			break;
		case IDOK:	//OK{^ƃG^[L[
			GetWindowPosition(hDlg, &IniEditDialog);
			IniWrite();
			IniChange = FALSE;
			EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:	//LZ{^ƃGXP[vL[
			IniRead();
			IniChange = FALSE;
			SetCursorHandle(GestureCursor, WaitCursor, CursorChange);
			SetWheelRedirectFlag(WheelRedirect);
			SetWheelActiveFlag(WheelActive);
			SetPriorityClass(GetCurrentProcess(), Priority);
			if(ShowTaskTray)
				MyTaskTray(hWnd);
			else
				MyTaskTray(NULL);
			if(hFont)
				DeleteObject(hFont);
			hFont = CreateFontIndirect(&lf);
			NaviHeight = GetNaviHeight() + 4;
			if(NaviType > 0)
				ShowParam = TRUE;
			else
				ShowParam = FALSE;
			ShowMauSujiNavi(hWnd, ShowParam);
			SetListViewHitTestFlag(ListViewHitTestFlag);
			SetTreeViewHitTestFlag(TreeViewHitTestFlag);
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	case WM_CLOSE:	//{^
		if(IniChange == TRUE) 
		{
			switch(MessageBox(hDlg, TEXT("ύXꂽݒKp܂H"), TEXT("ݒI"), MB_YESNOCANCEL))
			{
			case IDYES:				
				PostMessage(hDlg, WM_COMMAND, IDOK, 0);
				break;
			case IDNO:				
				PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
				break;
			}
		}
		else
		{
			EndDialog(hDlg, FALSE);
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

void MakeTrayMenu(HWND hWnd)
{
	HMENU hMenu, hSubMenu;
	POINT pt;

	PopupFlag = TRUE;
	hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_TRAYMENU));
	hSubMenu = GetSubMenu(hMenu, 0);
	if(NaviType==0)
		CheckMenuRadioItem(hMenu, IDM_SHOWMAUSUJINAVI, IDM_TIPMAUSUJINAVI, IDM_HIDEMAUSUJINAVI, MF_BYCOMMAND);
	else if(NaviType==1)
		CheckMenuRadioItem(hMenu, IDM_SHOWMAUSUJINAVI, IDM_TIPMAUSUJINAVI, IDM_SHOWMAUSUJINAVI, MF_BYCOMMAND);
	else if(NaviType==2)
		CheckMenuRadioItem(hMenu, IDM_SHOWMAUSUJINAVI, IDM_TIPMAUSUJINAVI, IDM_TIPMAUSUJINAVI, MF_BYCOMMAND);
	if(MouseHookFlag == TRUE)
		CheckMenuItem( hMenu, IDM_MOUSEHOOK, MF_BYCOMMAND | MF_CHECKED );
	else
		EnableMenuItem( hMenu, IDM_WHEELREDIRECT, MF_BYCOMMAND | MF_GRAYED );
	if(WheelRedirect)
		CheckMenuItem( hMenu, IDM_WHEELREDIRECT, MF_BYCOMMAND | MF_CHECKED );
	GetCursorPos(&pt);
	_SetForegroundWindow(hWnd);
	TrackPopupMenuEx(hSubMenu, TPM_RIGHTBUTTON|TPM_BOTTOMALIGN, pt.x, pt.y, hWnd, NULL);
	DestroyMenu(hMenu);
	PostMessage(hWnd, WM_NULL, 0, 0);
	PopupFlag = FALSE;
	SetTimer(hWnd, ID_NAVITIMER, NaviDeleteTime, NaviDeleteProc);
}

BOOL CheckButtonUp(int ButtonCode)
{
	BOOL ButtonUpFlag = FALSE;

	switch(ButtonCode)
	{
	case BUTTON_L:
		if(!(GetSystemMetrics(SM_SWAPBUTTON)) && !(GetKeyState( VK_LBUTTON ) & 0x8000) ||
			(GetSystemMetrics(SM_SWAPBUTTON) && !(GetKeyState( VK_RBUTTON ) & 0x8000)))
			ButtonUpFlag = TRUE;
		break;
	case BUTTON_M:
		if(!(GetKeyState( VK_MBUTTON ) & 0x8000))
			ButtonUpFlag = TRUE;
		break;
	case BUTTON_R:
		if(!(GetSystemMetrics(SM_SWAPBUTTON)) && !(GetKeyState( VK_RBUTTON ) & 0x8000) ||
			(GetSystemMetrics(SM_SWAPBUTTON) && !(GetKeyState( VK_LBUTTON ) & 0x8000)))
			ButtonUpFlag = TRUE;
		break;
	case BUTTON_X1:
		if(!(GetKeyState( VK_XBUTTON1 ) & 0x8000))
			ButtonUpFlag = TRUE;
		break;
	case BUTTON_X2:
		if(!(GetKeyState( VK_XBUTTON2 ) & 0x8000))
			ButtonUpFlag = TRUE;
		break;
	}
	return ButtonUpFlag;
}

void CALLBACK DoubleClickProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	DoubleClickFlag = -1;
	KillTimer(hwnd, ID_DBLCLKTIMER);
}

void CALLBACK HookCheckProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	static POINT LastPos = {0,0};
	POINT TempPos;

	if(MouseHookFlag == TRUE && ImplementFlag == FALSE)
	{
		GetCursorPos(&TempPos);
		if((TempPos.x != LastPos.x || TempPos.y != LastPos.y) && HookCheckFlag == FALSE)
		{
			MouseUnHook();
			SetMouseHook(hwnd);
		}
		LastPos = TempPos;
		HookCheckFlag = FALSE;
	}
}

void CALLBACK KuruKuruTimerProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	KuruKuruTimeoutFlag = TRUE;
	SetKuruKuruFlag(FALSE);
	KillTimer(hwnd, ID_KURUKURUTIMER);
}

void KuruKuruScroll(HWND hWnd, int CursorPosx, int CursorPosy)
{
	static POINT LastPos;
	static int LastScrollCourse = 0;
	static int StartCourse = -1;
	static int LastMove = -1;
	static int PosDiffx = 0, PosDiffy = 0;
	static BOOL ScrollFlag = FALSE;
	static int RealScrollSensitivity = 0;	
	static int MoveValuex[4] = {0,0,0,0};
	static int MoveValuey[4] = {0,0,0,0};
	int TotalMoveValuex, TotalMoveValuey, DiffMoveValuex, DiffMoveValuey;
	int ScrollCount;
	int RealMove = -1;
	static int LastPosx = 0, LastPosy = 0;
	DOUBLE TempCircleRate = CircleRate;

	if(KuruKuruTimeoutFlag == TRUE)
	{
		KuruKuruTimeoutFlag = FALSE;
		StartCourse = 0;
		ScrollFlag = FALSE;
		LastMove = -1;
		RealScrollSensitivity = 0;
		MoveValuex[S_MOVE_UP] = 0;
		MoveValuex[S_MOVE_RIGHT] = 0;
		MoveValuex[S_MOVE_DOWN] = 0;
		MoveValuex[S_MOVE_LEFT] = 0;
		MoveValuey[S_MOVE_UP] = 0;
		MoveValuey[S_MOVE_RIGHT] = 0;
		MoveValuey[S_MOVE_DOWN] = 0;
		MoveValuey[S_MOVE_LEFT] = 0;
		PosDiffx = 0;
		PosDiffy = 0;
		GetCursorPos(&LastPos);
	}
	if(LastPosx == CursorPosx && LastPosy == CursorPosy)
		return;
	LastPosx = CursorPosx;
	LastPosy = CursorPosy;
	PosDiffx += CursorPosx - LastPos.x;
	PosDiffy += CursorPosy - LastPos.y;
	if((PosDiffx * PosDiffx) + (PosDiffy * PosDiffy) > ((MoveQuantity < 5 ? MoveQuantity : 5) * (MoveQuantity < 5 ? MoveQuantity : 5))) 
	{
		if(abs(PosDiffx) < abs(PosDiffy))
		{
			if(PosDiffy < 0)
				RealMove = S_MOVE_UP;
			else
				RealMove = S_MOVE_DOWN;
		}
		else
		{
			if(PosDiffx < 0)
				RealMove = S_MOVE_LEFT;
			else
				RealMove = S_MOVE_RIGHT;
		}
		MoveValuex[RealMove] += PosDiffx;
		MoveValuey[RealMove] += PosDiffy;
		if(LastMove == -1)
		{
			StartCourse = RealMove;
			LastMove = RealMove;
		}
		else if(LastMove != RealMove)
		{
			if(RealMove == (LastMove + 1) % 4)//E
			{
				if(ScrollFlag == FALSE)
				{
					if(LastScrollCourse == -1)//OƓ]ł
					{
						if(StartCourse != -1 && (StartCourse + 1) % 4 == RealMove)
						{
							TotalMoveValuex = abs(MoveValuex[0]) + abs(MoveValuex[1]) + abs(MoveValuex[2]) + abs(MoveValuex[3]);
							TotalMoveValuey = abs(MoveValuey[0]) + abs(MoveValuey[1]) + abs(MoveValuey[2]) + abs(MoveValuey[3]);
							DiffMoveValuex = abs(MoveValuex[0] + MoveValuex[1] + MoveValuex[2] + MoveValuex[3]);
							DiffMoveValuey = abs(MoveValuey[0] + MoveValuey[1] + MoveValuey[2] + MoveValuey[3]);
							if(TotalMoveValuex <= TotalMoveValuey * (2 - (TempCircleRate / 100))
								&& TotalMoveValuex >= TotalMoveValuey * (TempCircleRate / 100)
								&& DiffMoveValuex <= TotalMoveValuex * (1 - (TempCircleRate / 100))
								&& DiffMoveValuey <= TotalMoveValuey * (1 - (TempCircleRate / 100)))
							{
								ScrollFlag = TRUE;
								GetCursorPos(&LastPos);
								SetKuruKuruFlag(TRUE);
							}
							else
							{
								MoveValuex[RealMove] = PosDiffx;
								MoveValuey[RealMove] = PosDiffy;
								StartCourse = RealMove;
							}
						}
					}
					else
					{
						LastScrollCourse = -1;
						StartCourse = LastMove;
						RealScrollSensitivity = 0;
					}
				}
				else
				{
					LastScrollCourse = -1;
				}
			}
			else if((RealMove + 1) % 4 == LastMove)//
			{
				if(ScrollFlag == FALSE)
				{
					if(LastScrollCourse == 1)
					{
						if(StartCourse != -1 && StartCourse == (RealMove + 1) % 4)
						{
							TotalMoveValuex = abs(MoveValuex[0]) + abs(MoveValuex[1]) + abs(MoveValuex[2]) + abs(MoveValuex[3]);
							TotalMoveValuey = abs(MoveValuey[0]) + abs(MoveValuey[1]) + abs(MoveValuey[2]) + abs(MoveValuey[3]);
							DiffMoveValuex = abs(MoveValuex[0] + MoveValuex[1] + MoveValuex[2] + MoveValuex[3]);
							DiffMoveValuey = abs(MoveValuey[0] + MoveValuey[1] + MoveValuey[2] + MoveValuey[3]);
							if(TotalMoveValuex <= TotalMoveValuey * (2 - (TempCircleRate / 100))
								&& TotalMoveValuex >= TotalMoveValuey * (TempCircleRate / 100)
								&& DiffMoveValuex <= TotalMoveValuex * (1 - (TempCircleRate / 100))
								&& DiffMoveValuey <= TotalMoveValuey * (1 - (TempCircleRate / 100)))
							{
								ScrollFlag = TRUE;
								GetCursorPos(&LastPos);
								SetKuruKuruFlag(TRUE);
							}
							else
							{
								MoveValuex[RealMove] = PosDiffx;
								MoveValuey[RealMove] = PosDiffy;
								StartCourse = RealMove;
							}
						}
					}
					else
					{
						LastScrollCourse = 1;
						StartCourse = LastMove;
						RealScrollSensitivity = 0;
					}
				}
				else
				{
					LastScrollCourse = 1;
				}
			}
			LastMove = RealMove;
		}
		if(ScrollFlag == TRUE)
		{
			RealScrollSensitivity += abs(PosDiffy);
			RealScrollSensitivity += abs(PosDiffx);
			if(RealScrollSensitivity >= ScrollSensitivity)
			{
				ScrollCount = RealScrollSensitivity / ScrollSensitivity;
				RealScrollSensitivity -= ScrollSensitivity * ScrollCount;
				PostMessage(WindowFromPoint(LastPos), WM_MOUSEWHEEL, MAKEWPARAM(0, 120 * ScrollCount * LastScrollCourse), MAKELPARAM(CursorPosx, CursorPosy));
			}
		}
		else
		{
			LastPos.x = CursorPosx;
			LastPos.y = CursorPosy;
		}
		PosDiffx = 0;
		PosDiffy = 0;
	}
	SetTimer(hWnd, ID_KURUKURUTIMER, KuruKuruTimeOut, KuruKuruTimerProc);
}

void FreeScroll(int CursorPosx, int CursorPosy, BOOL ScrollInitFlag, HWND hWnd)
{
	static HWND hwTarget;
	static POINT LastPos;
	static int MoveValuex;
	static int MoveValuey;
	int ScrollCount;

	if(ScrollInitFlag == TRUE)
	{
		MoveValuex = 0;
		MoveValuey = 0;
		GetCursorPos(&LastPos);
		hwTarget = hWnd;
		return;
	}
	MoveValuex += CursorPosx - LastPos.x;
	MoveValuey += LastPos.y - CursorPosy;
	if(abs(MoveValuex) >= ScrollSensitivity)
	{
		ScrollCount = MoveValuex / ScrollSensitivity;
		MoveValuex -= ScrollSensitivity * ScrollCount;
		PostMessage(hwTarget, WM_MOUSEHWHEEL, MAKEWPARAM(0, 120 * ScrollCount), MAKELPARAM(CursorPosx, CursorPosy));
	}
	if(abs(MoveValuey) >= ScrollSensitivity)
	{
		ScrollCount = MoveValuey / ScrollSensitivity;
		MoveValuey -= ScrollSensitivity * ScrollCount;
		PostMessage(hwTarget, WM_MOUSEWHEEL, MAKEWPARAM(0, 120 * ScrollCount), MAKELPARAM(CursorPosx, CursorPosy));
	}
}

void CALLBACK TimeOutProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	TCHAR MoveS[12];
	int i;
	BOOL GestureTimeOutFlag = FALSE;
	UINT DownButton, UpButton, XButton = 0x0000;

	if(TimeOutFlag == FALSE)
		TimeOutFlag = TRUE;
	if(GestureTimeOutTimer == TRUE)
	{
		GestureTimeOutTimer = FALSE;
		GestureTimeOutFlag = TRUE;
	}
	KillTimer(hwnd, ID_TIMEOUTTIMER);
	if((Gesture.Level <= 0 && Gesture.Start == FALSE) ||
		(Gesture.Level <= MAX_GESTURE_LEVEL && GestureTimeOutFlag == TRUE))
	{
		lstrcpy(GestureString, TEXT(""));
		get_modifiername(Gesture.Modifier, GestureString, 50);
		GestureToString(Gesture.Button, MoveS, 12);
		lstrcat( GestureString, MoveS );
		i = 0;
		while(i < MAX_GESTURE_LEVEL && Gesture.Move[i] > 0)
		{
			GestureToString(Gesture.Move[i], MoveS, 12);
			lstrcat( GestureString, MoveS );
			i ++;
		}
		lstrcpy(CommentString, TEXT("Time-out"));
		Gesture.Level = MAX_GESTURE_LEVEL + 2;
		SetButtonFlag(FALSE);
		SetHookFlag(TRUE);
		SetCursorNumber(0);
		switch(Gesture.Button)
		{
		case BUTTON_L:
			DownButton = MOUSEEVENTF_LEFTDOWN;
			UpButton = MOUSEEVENTF_LEFTUP;
			break;
		case BUTTON_M:
			DownButton = MOUSEEVENTF_MIDDLEDOWN;
			UpButton = MOUSEEVENTF_MIDDLEUP;
			break;
		case BUTTON_R:
			DownButton = MOUSEEVENTF_RIGHTDOWN;
			UpButton = MOUSEEVENTF_RIGHTUP;
			break;
		case BUTTON_X1:
			DownButton = MOUSEEVENTF_XDOWN;
			UpButton = MOUSEEVENTF_XUP;
			XButton = XBUTTON1;
			break;
		case BUTTON_X2:
			DownButton = MOUSEEVENTF_XDOWN;
			UpButton = MOUSEEVENTF_XUP;
			XButton = XBUTTON2;
			break;
		default:
			return;
		}
		SetCursorPos(StartPos.x, StartPos.y);
		if(Gesture.Button == Gesture.Move[0] && DoubleClickFlag == -1)
		{
			mouse_event(DownButton,0,0,XButton,0);
			mouse_event(UpButton,0,0,XButton,0);
			Sleep(ClickWait * 2);
		}
		mouse_event(DownButton,0,0,XButton,0);
		Sleep(ClickWait);
		SetCursorPos(RealPos.x, RealPos.y);
		if(CheckButtonUp(Gesture.Button))
		{
			mouse_event(UpButton,0,0,XButton,0);
			Sleep(ClickWait);
		}
		NaviRefresh(hwnd);
	}
}

void MouseGesture(int FoundTargetNumber)
{
	static POINT DefPos, LastPos;
	TCHAR MoveS[12];
	int i;
	POINT apos;

	GetCursorPos(&apos);
	if(Gesture.Level == -1)
	{
		Gesture.Level = 0;
		Gesture.Modifier = 0;
		if(GetKeyState( VK_SHIFT ) & 0x8000)
			Gesture.Modifier |= MODIFIER_SHIFT;
		if(GetKeyState( VK_CONTROL ) & 0x8000)
			Gesture.Modifier |= MODIFIER_CONTROL;
		for(i=0; i<MAX_GESTURE_LEVEL; i++)
			Gesture.Move[i] = 0;
		Gesture.Start = FALSE;
		//WFX`[
		lstrcpy(GestureString, TEXT(""));
		get_modifiername(Gesture.Modifier, GestureString, 50);
		GestureToString(Gesture.Button, MoveS, 12);
		lstrcat(GestureString, MoveS);
		//
		StartPos = apos;
		RealPos = apos;
		DefPos = apos;
		LastPos = apos;
	}
	else if(Gesture.Level < MAX_GESTURE_LEVEL)
	{
		int PosDiffx, PosDiffy;
		int FoundActionNumber;

		PosDiffx = apos.x - LastPos.x;
		PosDiffy = apos.y - LastPos.y;

		if((PosDiffx * PosDiffx) + (PosDiffy * PosDiffy) >= ((MoveQuantity < 5 ? MoveQuantity : 5) * (MoveQuantity < 5 ? MoveQuantity : 5)))
		{
			if(Gesture.Level > 0 && Gesture.Move[Gesture.Level - 1] == GetGestureMove(PosDiffx, PosDiffy))
			{
				DefPos = apos;
			}
			LastPos = apos;
		}

		PosDiffx = apos.x - DefPos.x;
		PosDiffy = apos.y - DefPos.y;

		if(Gesture.Start == FALSE && Gesture.Level == 0 &&
			((PosDiffx * PosDiffx) + (PosDiffy * PosDiffy) >= (GestureStartQuantity * GestureStartQuantity)))
		{
			Gesture.Start = TRUE;
			if(TimeOutType)
				GestureTimeOutTimer = TRUE;
			SetTarget();
			SetCursorNumber(2);
		}

		if(((PosDiffx * PosDiffx) + (PosDiffy * PosDiffy) >= (MoveQuantity * MoveQuantity)) &&
			Gesture.Button != Gesture.Move[0])
		{
			//WFX`[̕擾
			Gesture.Move[Gesture.Level] = GetGestureMove(PosDiffx, PosDiffy);
			if(Gesture.Level == 0 || Gesture.Move[Gesture.Level] != Gesture.Move[Gesture.Level - 1])
			{
				//WFX`[
				lstrcpy(GestureString, TEXT(""));
				get_modifiername(Gesture.Modifier, GestureString, 50);
				GestureToString(Gesture.Button, MoveS, 12);
				lstrcat( GestureString, MoveS );
				for( i = 0; i <= Gesture.Level; i++)
				{
					GestureToString(Gesture.Move[i], MoveS, 12);
					lstrcat( GestureString, MoveS );
				}
				//WFX`[͂
				Gesture.Level ++;
				//Rg
				FoundActionNumber = SearchAction(FoundTargetNumber, 1);
				if(FoundActionNumber >= 0)
					lstrcpy( CommentString, Action[FoundActionNumber].Comment);
				else
					lstrcpy( CommentString, TEXT(""));
			}
			else
			{
				Gesture.Move[Gesture.Level] = 0;	//0ɖ߂
			}
		}
	}
	else
	{
		lstrcpy(GestureString, TEXT(""));
		get_modifiername(Gesture.Modifier, GestureString, 50);
		GestureToString(Gesture.Button, MoveS, 12);
		lstrcat( GestureString, MoveS );
		i = 0;
		while(i < MAX_GESTURE_LEVEL && Gesture.Move[i] > 0)
		{
			GestureToString(Gesture.Move[i], MoveS, 12);
			lstrcat( GestureString, MoveS );
			i ++;
		}
	}
}

LRESULT OnMauHook(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	static int FoundTargetNumber, FoundActionNumber, LastClick = 0;
	static POINT FirstClickPos;
	static int ScreenWidth = GetSystemMetrics(SM_CXVIRTUALSCREEN) - 1;
	static int ScreenHeight = GetSystemMetrics(SM_CYVIRTUALSCREEN) - 1;
	POINT CursorPos;
	int i, CursorPosition;
	UINT UpButtonMessage, DownButton, UpButton, XButton = 0x0000;
	int TempGestureLevel;

	if (PopupFlag == TRUE || ImplementFlag == TRUE)
		return 0;

	TempGestureLevel = Gesture.Level;
	HookCheckFlag = TRUE;

	switch(Gesture.Button)
	{
	case CORNER_TOP_A:
	case CORNER_TOP_B:
	case CORNER_TOP_C:
	case CORNER_BOTTOM_A:
	case CORNER_BOTTOM_B:
	case CORNER_BOTTOM_C:
	case CORNER_LEFT_A:
	case CORNER_LEFT_B:
	case CORNER_LEFT_C:
	case CORNER_RIGHT_A:
	case CORNER_RIGHT_B:
	case CORNER_RIGHT_C:
	case CORNER_TOPLEFT:
	case CORNER_TOPRIGHT:
	case CORNER_BOTTOMLEFT:
	case CORNER_BOTTOMRIGHT:
	case 0: //{^LłȂƂɃ{^ꂽꍇ̏
		GetCursorPos(&CursorPos);
		switch(wParam)
		{
		case WM_LBUTTONDOWN:
		case WM_NCLBUTTONDOWN:
		case WM_MBUTTONDOWN:
		case WM_NCMBUTTONDOWN:
		case WM_RBUTTONDOWN:
		case WM_NCRBUTTONDOWN:
		case WM_XBUTTON1DOWN:
		case WM_XBUTTON2DOWN:
			switch(wParam)
			{
			case WM_LBUTTONDOWN:
			case WM_NCLBUTTONDOWN:
				if(!(GetSystemMetrics(SM_SWAPBUTTON)))
					Gesture.Button = BUTTON_L;
				else
					Gesture.Button = BUTTON_R;
				break;
			case WM_MBUTTONDOWN:
			case WM_NCMBUTTONDOWN:
				Gesture.Button = BUTTON_M;
				break;
			case WM_RBUTTONDOWN:
			case WM_NCRBUTTONDOWN:
				if(!(GetSystemMetrics(SM_SWAPBUTTON)))
					Gesture.Button = BUTTON_R;
				else
					Gesture.Button = BUTTON_L;
				break;
			case WM_XBUTTON1DOWN:
				Gesture.Button = BUTTON_X1;
				break;
			case WM_XBUTTON2DOWN:
				Gesture.Button = BUTTON_X2;
				break;
			}
			Gesture.Level = -1;
			MouseGesture(-1);
			if(DoubleClickFlag == Gesture.Button &&
				abs(FirstClickPos.x - CursorPos.x) <= GetSystemMetrics(SM_CXDOUBLECLK) &&
				abs(FirstClickPos.y - CursorPos.y) <= GetSystemMetrics(SM_CYDOUBLECLK))
			{
				if(LastClick == Gesture.Button)
					DoubleClickFlag = 0;
				else
					DoubleClickFlag = -1;
				Gesture.Move[0] = Gesture.Button;
				Gesture.Level = MAX_GESTURE_LEVEL;
				MouseGesture(-1);
				Gesture.Level = 0;
			}
			else
			{
				DoubleClickFlag = Gesture.Button;
				FirstClickPos = CursorPos;
				SetTimer(hwnd, ID_DBLCLKTIMER, GetDoubleClickTime(), DoubleClickProc);
			}
			break;
		case WM_LBUTTONDBLCLK:
		case WM_NCLBUTTONDBLCLK:
		case WM_MBUTTONDBLCLK:
		case WM_NCMBUTTONDBLCLK:
		case WM_RBUTTONDBLCLK:
		case WM_NCRBUTTONDBLCLK:
		case WM_XBUTTON1DBLCLK:
		case WM_XBUTTON2DBLCLK:
			switch(wParam)
			{
			case WM_LBUTTONDBLCLK:
			case WM_NCLBUTTONDBLCLK:
				if(!(GetSystemMetrics(SM_SWAPBUTTON)))
					Gesture.Button = BUTTON_L;
				else
					Gesture.Button = BUTTON_R;
				break;
			case WM_MBUTTONDBLCLK:
			case WM_NCMBUTTONDBLCLK:
				Gesture.Button = BUTTON_M;
				break;
			case WM_RBUTTONDBLCLK:
			case WM_NCRBUTTONDBLCLK:
				if(!(GetSystemMetrics(SM_SWAPBUTTON)))
					Gesture.Button = BUTTON_R;
				else
					Gesture.Button = BUTTON_L;
				break;
			case WM_XBUTTON1DBLCLK:
				Gesture.Button = BUTTON_X1;
				break;
			case WM_XBUTTON2DBLCLK:
				Gesture.Button = BUTTON_X2;
				break;
			} 
			Gesture.Level = -1;
			MouseGesture(-1);
			if(DoubleClickFlag == Gesture.Button)
			{
				KillTimer(hwnd, ID_DBLCLKTIMER);
				DoubleClickFlag = -1;
			}
			Gesture.Move[0] = Gesture.Button;
			Gesture.Level = MAX_GESTURE_LEVEL;
			MouseGesture(-1);
			Gesture.Level = 0;
			break;
		case WM_MOUSEWHEEL_UP:
		case WM_MOUSEWHEEL_DOWN:
		case WM_MOUSEWHEEL_LEFT:
		case WM_MOUSEWHEEL_RIGHT:
			if(wParam == WM_MOUSEWHEEL_UP)
				Gesture.Button = WHEEL_UP;
			else if(wParam == WM_MOUSEWHEEL_DOWN)
				Gesture.Button = WHEEL_DOWN;
			else if(wParam == WM_MOUSEWHEEL_LEFT)
				Gesture.Button = WHEEL_LEFT;
			else if(wParam == WM_MOUSEWHEEL_RIGHT)
				Gesture.Button = WHEEL_RIGHT;
			Gesture.Level = -1;
			MouseGesture(-1);
			if(Gesture.Button != 0)
				KillTimer(hwnd, ID_TIMER);
			lstrcpy(CommentString, TEXT(""));

			FoundTargetNumber = SearchTarget((HWND)lParam, FALSE);
			MouseGesture(FoundTargetNumber);
			FoundActionNumber = SearchAction(FoundTargetNumber, 0);
			if(FoundActionNumber >= 0)
			{
				if((FoundTargetNumber < (int)Target.size() && Target[FoundTargetNumber].HookType) ||
					(FoundTargetNumber == (int)Target.size() && Default.HookType))
				{
					SetButtonFlag(TRUE);
				}
			}
			PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
			return TRUE;
		default:
			if(KuruKuruFlag)
				KuruKuruScroll(hwnd, CursorPos.x, CursorPos.y);

			if(CursorPos.x == 0 || CursorPos.x == ScreenWidth || CursorPos.y == 0 || CursorPos.y == ScreenHeight)
			{
				if(CursorPos.x <= CornerPosX && CursorPos.y <= CornerPosY)
				{
					CursorPosition = CORNER_TOPLEFT;
				}
				else if(CursorPos.x <= CornerPosX && CursorPos.y >= ScreenHeight - CornerPosY)
				{
					CursorPosition = CORNER_BOTTOMLEFT;
				}
				else if(CursorPos.x >= ScreenWidth - CornerPosX && CursorPos.y <= CornerPosY)
				{
					CursorPosition = CORNER_TOPRIGHT;
				}
				else if(CursorPos.x >= ScreenWidth - CornerPosX && CursorPos.y >= ScreenHeight - CornerPosY)
				{
					CursorPosition = CORNER_BOTTOMRIGHT;
				}
				else if(CursorPos.y <= 0)
				{
					if(CursorPos.x <= (ScreenWidth - (CornerPosX * 2)) / 3 + CornerPosX)
						CursorPosition = CORNER_TOP_A;
					else if(CursorPos.x >= ScreenWidth - ((ScreenWidth - (CornerPosX * 2)) / 3 + CornerPosX))
						CursorPosition = CORNER_TOP_C;
					else
						CursorPosition = CORNER_TOP_B;
				}
				else if(CursorPos.y >= ScreenHeight)
				{
					if(CursorPos.x <= (ScreenWidth - (CornerPosX * 2)) / 3 + CornerPosX)
						CursorPosition = CORNER_BOTTOM_A;
					else if(CursorPos.x >= ScreenWidth - ((ScreenWidth - (CornerPosX * 2)) / 3 + CornerPosX))
						CursorPosition = CORNER_BOTTOM_C;
					else
						CursorPosition = CORNER_BOTTOM_B;
				}
				else if(CursorPos.x <= 0)
				{
					if(CursorPos.y <= (ScreenHeight - (CornerPosY * 2)) / 3 + CornerPosY)
						CursorPosition = CORNER_LEFT_A;
					else if(CursorPos.y >= ScreenHeight - ((ScreenHeight - (CornerPosY * 2)) / 3 + CornerPosY))
						CursorPosition = CORNER_LEFT_C;
					else
						CursorPosition = CORNER_LEFT_B;
				}
				else if(CursorPos.x >= ScreenWidth)
				{
					if(CursorPos.y <= (ScreenHeight - (CornerPosY * 2)) / 3 + CornerPosY)
						CursorPosition = CORNER_RIGHT_A;
					else if(CursorPos.y >= ScreenHeight - ((ScreenHeight - (CornerPosY * 2)) / 3 + CornerPosY))
						CursorPosition = CORNER_RIGHT_C;
					else
						CursorPosition = CORNER_RIGHT_B;
				}
				else
				{
					CursorPosition = 0;
				}
			}
			else
			{
				CursorPosition = 0;
			}

			if((Gesture.Level > -2 && Gesture.Button != CursorPosition) ||
				(Gesture.Level == -2 && CursorPosition == 0))
			{
				Gesture.Button = CursorPosition;
				Gesture.Level = -1;
				if(Gesture.Button == 0)
				{
					if(FinishActionNumber > -1)
					{
						Gesture.Level = MAX_GESTURE_LEVEL + 1;
						Gesture.Start = FALSE;
						Gesture.Button = CORNER_FINISH;
					}
					else
					{
						KillTimer(hwnd, ID_TIMER);
						SetCursorNumber(0);
						if(NaviDrawFlag == TRUE && NaviDeleteTime > 0 && FoundTargetNumber >= 0 && NaviType > 0)
						{
							NaviDrawFlag = FALSE;
							SetTimer(hwnd, ID_NAVITIMER, NaviDeleteTime, NaviDeleteProc);
						}
					}
				}
				else
				{
					lstrcpy(CommentString, TEXT(""));

					FoundTargetNumber = SearchTarget(GetForegroundWindow(), TRUE);
					MouseGesture(FoundTargetNumber);
					FoundActionNumber = SearchAction(FoundTargetNumber, 0);
					if(FoundActionNumber >= 0)
					{
						lstrcpy(CommentString, Action[FoundActionNumber].Comment);
						NaviRefresh(hwnd);
						SetCursorNumber(1);
						SetTimer(hwnd, ID_TIMER, CornerTime, NULL);
					}
					else
					{
						KillTimer(hwnd, ID_TIMER);
						Gesture.Level = -1;
						if(NaviDrawFlag == TRUE && NaviDeleteTime > 0 && FoundTargetNumber >= 0 && NaviType > 0)
						{
							NaviDrawFlag = FALSE;
							SetTimer(hwnd, ID_NAVITIMER, NaviDeleteTime, NaviDeleteProc);
						}
					}
				}
			}
			else
			{
				if(Gesture.Level == MAX_GESTURE_LEVEL)
				{
					Gesture.Level = MAX_GESTURE_LEVEL + 1;
					Gesture.Start = TRUE;
					SetCursorNumber(0);
				}
			}
			break;
		}

		if(Gesture.Button == BUTTON_L || Gesture.Button == BUTTON_M || Gesture.Button == BUTTON_R ||
			Gesture.Button == BUTTON_X1 || Gesture.Button == BUTTON_X2)
		{
			if(Gesture.Button != 0)
				KillTimer(hwnd, ID_TIMER);

			lstrcpy(CommentString, TEXT(""));
			LastClick = 0;
			TimeOutFlag = TRUE;

			FoundTargetNumber = SearchTarget((HWND)lParam, FALSE);
			MouseGesture(FoundTargetNumber);
			FoundActionNumber = SearchAction(FoundTargetNumber, 0);
			if(FoundActionNumber >= 0)
			{
				int Number;

				Number = SearchAction(FoundTargetNumber, 1);
				if(Number >= 0)
					lstrcpy(CommentString, Action[Number].Comment);

				if((FoundTargetNumber < (int)Target.size() && !Target[FoundTargetNumber].HookType) ||
					(FoundTargetNumber == (int)Target.size() && !Default.HookType))
				{
					Gesture.Start = TRUE;
				}
				else
				{
					SetButtonFlag(TRUE);
					SetCursorNumber(1);
					TimeOutFlag = FALSE;
					SetTimer(hwnd, ID_TIMEOUTTIMER, GestureTimeOut, TimeOutProc);
				}

				if(SearchAction(FoundTargetNumber, 2) == -1)
				{
					ClickOnlyFlag = TRUE;
					KillTimer(hwnd, ID_TIMEOUTTIMER);
					SetCursorNumber(2);
					TimeOutFlag = TRUE;
					Gesture.Start = TRUE;
					Gesture.Level = MAX_GESTURE_LEVEL + 1;
					SetTarget();
					NaviRefresh(hwnd);
				}
				else if(SearchAction(FoundTargetNumber, 1) >= 0)
				{
					NaviRefresh(hwnd);
				}
			}
			else
			{
				if(FoundTargetNumber < 0)
					lstrcpy(GestureString, NaviTitle);
			}
			SetTimer(hwnd, ID_TIMER, CheckInterval, NULL);
			return TRUE;
		}
		break;
	case BUTTON_L:
		UpButtonMessage = WM_LBUTTONUP;
		DownButton = MOUSEEVENTF_LEFTDOWN;
		UpButton = MOUSEEVENTF_LEFTUP;
		break;
	case BUTTON_M:
		UpButtonMessage = WM_MBUTTONUP;
		DownButton = MOUSEEVENTF_MIDDLEDOWN;
		UpButton = MOUSEEVENTF_MIDDLEUP;
		break;
	case BUTTON_R:
		UpButtonMessage = WM_RBUTTONUP;
		DownButton = MOUSEEVENTF_RIGHTDOWN;
		UpButton = MOUSEEVENTF_RIGHTUP;
		break;
	case BUTTON_X1:
		UpButtonMessage = WM_XBUTTON1UP;
		DownButton = MOUSEEVENTF_XDOWN;
		UpButton = MOUSEEVENTF_XUP;
		XButton = XBUTTON1;
		break;
	case BUTTON_X2:
		UpButtonMessage = WM_XBUTTON2UP;
		DownButton = MOUSEEVENTF_XDOWN;
		UpButton = MOUSEEVENTF_XUP;
		XButton = XBUTTON2;
		break;
	case WHEEL_UP:
	case WHEEL_DOWN:
	case WHEEL_LEFT:
	case WHEEL_RIGHT:
		Gesture.Start = TRUE;
		if(FoundActionNumber >= 0)
			Gesture.Level = MAX_GESTURE_LEVEL + 1;
		else
			Gesture.Level = MAX_GESTURE_LEVEL + 2;
		break;
	}

	switch(Gesture.Button)
	{
	case BUTTON_L:
	case BUTTON_M:
	case BUTTON_R:
	case BUTTON_X1:
	case BUTTON_X2:
		if(wParam == UpButtonMessage)
		{
			KillTimer(hwnd, ID_TIMER);
			if(TimeOutFlag == FALSE)
				KillTimer(hwnd, ID_TIMEOUTTIMER);

			SetCursorNumber(0);

			if(Gesture.Move[0] == Gesture.Button || Gesture.Move[0] == 0)
			{
				if(TimeOutFlag == FALSE && Gesture.Start == FALSE)
				{
					if(SearchAction(FoundTargetNumber, 1) < 0)
					{
						SetHookFlag(TRUE);
						mouse_event(DownButton, 0, 0, XButton, 0);
						mouse_event(UpButton, 0, 0, XButton, 0);
						Sleep(ClickWait * 2);
						if(Gesture.Move[0] == Gesture.Button && DoubleClickFlag == -1)
						{
							mouse_event(DownButton, 0, 0, XButton, 0);
							mouse_event(UpButton, 0, 0, XButton, 0);
							Sleep(ClickWait * 2);
						}
						LastClick = Gesture.Button;
					}
					else
					{
						SetTarget();
						Gesture.Start = TRUE;
					}
				}

				if(ClickOnlyFlag == TRUE)
					Gesture.Level = MAX_GESTURE_LEVEL + 2;
				else
					Gesture.Level = MAX_GESTURE_LEVEL + 1;
			}
			else if(Gesture.Move[0] == BUTTON_L || Gesture.Move[0] == BUTTON_M || Gesture.Move[0] == BUTTON_R ||
				Gesture.Move[0] == BUTTON_X1 || Gesture.Move[0] == BUTTON_X2 ||
				Gesture.Move[0] == WHEEL_UP || Gesture.Move[0] == WHEEL_DOWN || Gesture.Move[0] == WHEEL_LEFT || Gesture.Move[0] == WHEEL_RIGHT)
			{
				Gesture.Level = MAX_GESTURE_LEVEL + 2;
				Gesture.Move[0] = 0;
			}
			else
			{
				Gesture.Level = MAX_GESTURE_LEVEL + 1;
			}
		}
		break;
	}

	if((TimeOutFlag == FALSE || Gesture.Start == TRUE) && Gesture.Level <= MAX_GESTURE_LEVEL)
	{
		if(Gesture.Button == BUTTON_L || Gesture.Button == BUTTON_M || Gesture.Button == BUTTON_R ||
			Gesture.Button == BUTTON_X1 || Gesture.Button == BUTTON_X2)
		{
			switch(wParam)
			{
			case WM_MOUSEWHEEL:
				if(lParam > 0)
					Gesture.Move[0] = WHEEL_UP;
				else if(lParam < 0)
					Gesture.Move[0] = WHEEL_DOWN;
				break;
			case WM_MOUSEHWHEEL:
				if(lParam < 0)
					Gesture.Move[0] = WHEEL_LEFT;
				else if(lParam > 0)
					Gesture.Move[0] = WHEEL_RIGHT;
				break;
			case WM_LBUTTONDOWN:
			case WM_NCLBUTTONDOWN:
				if((!(GetSystemMetrics(SM_SWAPBUTTON)) && Gesture.Button == BUTTON_L) ||
					(GetSystemMetrics(SM_SWAPBUTTON) && Gesture.Button == BUTTON_R))
					break;
				if(!(GetSystemMetrics(SM_SWAPBUTTON)))
					Gesture.Move[0] = BUTTON_L;
				else
					Gesture.Move[0] = BUTTON_R;
				break;
			case WM_MBUTTONDOWN:
			case WM_NCMBUTTONDOWN:
				if(Gesture.Button == BUTTON_M)
					break;
				Gesture.Move[0] = BUTTON_M;
				break;
			case WM_RBUTTONDOWN:
			case WM_NCRBUTTONDOWN:
				if((!(GetSystemMetrics(SM_SWAPBUTTON)) && Gesture.Button == BUTTON_R) ||
					(GetSystemMetrics(SM_SWAPBUTTON) && Gesture.Button == BUTTON_L))
					break;
				if(!(GetSystemMetrics(SM_SWAPBUTTON)))
					Gesture.Move[0] = BUTTON_R;
				else
					Gesture.Move[0] = BUTTON_L;
				break;
			case WM_XBUTTON1DOWN:
				if(Gesture.Button == BUTTON_X1)
					break;
				Gesture.Move[0] = BUTTON_X1;
				break;
			case WM_XBUTTON2DOWN:
				if(Gesture.Button == BUTTON_X2)
					break;
				Gesture.Move[0] = BUTTON_X2;
				break;
			}

			switch(wParam)
			{
			case WM_MOUSEWHEEL:
			case WM_LBUTTONDOWN:
			case WM_NCLBUTTONDOWN:
			case WM_MBUTTONDOWN:
			case WM_NCMBUTTONDOWN:
			case WM_RBUTTONDOWN:
			case WM_NCRBUTTONDOWN:
			case WM_XBUTTON1DOWN:
			case WM_XBUTTON2DOWN:
				if(Gesture.Move[0] == 0)
					break;
				if(TimeOutFlag == FALSE)
				{
					SetCursorNumber(2);
					TimeOutFlag = TRUE;
					SetTarget();
				}
				Gesture.Start = TRUE;
				for(i=1; i<MAX_GESTURE_LEVEL; i++)
					Gesture.Move[i] = 0;
				Gesture.Level = MAX_GESTURE_LEVEL + 1;
				MouseGesture(FoundTargetNumber);
				break;
			default:
				if(Gesture.Level < MAX_GESTURE_LEVEL)
					MouseGesture(FoundTargetNumber);
				if(TimeOutType)
				{
					GetCursorPos(&CursorPos);
					if(GestureTimeOutTimer == TRUE && (RealPos.x != CursorPos.x || RealPos.y != CursorPos.y))
					{
						SetTimer(hwnd, ID_TIMEOUTTIMER, GestureTimeOut, TimeOutProc);
						RealPos = CursorPos;
					}
				}
				break;
			}
		}
	}

	if((Gesture.Level > MAX_GESTURE_LEVEL && Gesture.Start == TRUE) ||
		(Gesture.Level == MAX_GESTURE_LEVEL + 1 && Gesture.Start == FALSE))
	{
		GestureTimeOutTimer = FALSE;
		KillTimer(hwnd, ID_TIMER);

		if(Gesture.Level == MAX_GESTURE_LEVEL + 1 && Gesture.Start == TRUE)
		{
			FoundActionNumber = SearchAction(FoundTargetNumber, 1);
			if(FoundActionNumber >= 0)
			{
				//o^ĂANVsꂽ
				lstrcpy(CommentString, Action[FoundActionNumber].Comment);
				NaviRefresh(hwnd);
				GetCursorPos(&FinishPos);
				ImplementFlag = TRUE;
				SetHookFlag(TRUE);
				ImplementCommand(hwnd, FoundActionNumber, FALSE);	//R}hs
				SetHookFlag(FALSE);
				ImplementFlag = FALSE;
			}
			else
			{
				//o^ĂȂANVsꂽ
				lstrcpy(CommentString, TEXT("no entry"));
				NaviRefresh(hwnd);
			}
		}

		if(Gesture.Button == Gesture.Move[0])	//_uNbN
			Gesture.Move[0] = 0;

		switch(Gesture.Move[0])
		{
		case BUTTON_L:
		case BUTTON_M:
		case BUTTON_R:
		case BUTTON_X1:
		case BUTTON_X2:
		case WHEEL_UP:
		case WHEEL_DOWN:
		case WHEEL_LEFT:
		case WHEEL_RIGHT:
			//bJ[WFX`[iR LȂǁj
			Gesture.Level = MAX_GESTURE_LEVEL;
			SetTimer(hwnd, ID_TIMER, CheckInterval, NULL);
			break;
		default:
			if(Gesture.Level == MAX_GESTURE_LEVEL + 1 && ClickOnlyFlag == TRUE)
			{
				Gesture.Level = MAX_GESTURE_LEVEL;
				SetTimer(hwnd, ID_TIMER, CheckInterval, NULL);
				break;
			}

			if(FinishActionNumber > -1 &&
				(Gesture.Button == BUTTON_L || Gesture.Button == BUTTON_M || Gesture.Button == BUTTON_R ||
				Gesture.Button == BUTTON_X1 || Gesture.Button == BUTTON_X2 ||
				Gesture.Button == WHEEL_UP || Gesture.Button == WHEEL_DOWN ||
				Gesture.Button == WHEEL_LEFT || Gesture.Button == WHEEL_RIGHT || Gesture.Button == CORNER_FINISH))
			{
				GetCursorPos(&FinishPos);
				ImplementFlag = TRUE;
				SetHookFlag(TRUE);
				ImplementCommand(hwnd, FinishActionNumber, TRUE);	//R}hs
				SetHookFlag(FALSE);
				ImplementFlag = FALSE;
			}

			ResetButtonFlag();
			Gesture.Button = 0;
			Gesture.Level = -2;
			ClickOnlyFlag = FALSE;

			if(NaviDrawFlag == TRUE && NaviDeleteTime > 0 && FoundTargetNumber >= 0 && NaviType > 0)
			{
				NaviDrawFlag = FALSE;
				SetTimer(hwnd, ID_NAVITIMER, NaviDeleteTime, NaviDeleteProc);
			}
			break;
		}
		return TRUE;
	}

	if(Gesture.Button > 0 && TempGestureLevel != Gesture.Level && Gesture.Start == TRUE)
		NaviRefresh(hwnd);

	return 0;
}

void OnTimer(HWND hwnd, UINT id)
{
	switch(Gesture.Button)
	{
	case BUTTON_L:
		if(CheckButtonUp(Gesture.Button))
			PostMessage(hwnd, MAUHOOK_MSG, WM_LBUTTONUP, 0);
		else
			PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
		break;
	case BUTTON_M:
		if(CheckButtonUp(Gesture.Button))
			PostMessage(hwnd, MAUHOOK_MSG, WM_MBUTTONUP, 0);
		else
			PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
		break;
	case BUTTON_R:
		if(CheckButtonUp(Gesture.Button))
			PostMessage(hwnd, MAUHOOK_MSG, WM_RBUTTONUP, 0);
		else
			PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
		break;
	case BUTTON_X1:
		if(CheckButtonUp(Gesture.Button))
			PostMessage(hwnd, MAUHOOK_MSG, WM_XBUTTON1UP, 0);
		else
			PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
		break;
	case BUTTON_X2:
		if(CheckButtonUp(Gesture.Button))
			PostMessage(hwnd, MAUHOOK_MSG, WM_XBUTTON2UP, 0);
		else
			PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
		break;
	case CORNER_TOP_A:
	case CORNER_TOP_B:
	case CORNER_TOP_C:
	case CORNER_BOTTOM_A:
	case CORNER_BOTTOM_B:
	case CORNER_BOTTOM_C:
	case CORNER_LEFT_A:
	case CORNER_LEFT_B:
	case CORNER_LEFT_C:
	case CORNER_RIGHT_A:
	case CORNER_RIGHT_B:
	case CORNER_RIGHT_C:
	case CORNER_TOPLEFT:
	case CORNER_TOPRIGHT:
	case CORNER_BOTTOMLEFT:
	case CORNER_BOTTOMRIGHT:
		//R[i[}EX̃R}hs
		Gesture.Level = MAX_GESTURE_LEVEL;
		PostMessage(hwnd, MAUHOOK_MSG, 0, 0);
		break;
	}
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static UINT WM_TASKBARCREATED = RegisterWindowMessage(TEXT("TaskbarCreated"));
	static BOOL IniEditFlag = FALSE;
	int RedirectTarget;

	switch( msg )
	{
	case WM_CREATE:
		ShowWindow(hwnd, SW_SHOW);
		if(NaviType > 0)
			ShowParam = TRUE;
		else
			ShowParam = FALSE;
		ShowMauSujiNavi(hwnd, ShowParam);
		Gesture.Button = 0;
		Gesture.Level = -1;
		SetMouseHook(hwnd); //}EXtbNJn
		SetCursorHandle(GestureCursor, WaitCursor, CursorChange);
		if(ShowTaskTray)
			MyTaskTray(hwnd);
		lstrcpy(GestureString, NaviTitle);
		NaviRefresh(hwnd);
		PostMessage(hwnd, NAVIMINIMIZE_MSG, 0, 0);
		SetTimer(hwnd, ID_HOOKCHECKTIMER, 5000, HookCheckProc);
		SetListViewHitTestFlag(ListViewHitTestFlag);
		SetTreeViewHitTestFlag(TreeViewHitTestFlag);
		break;
	case WM_PAINT:
		NaviPaint(hwnd);
		break;
	case WM_CLOSE:
		PostMessage(hwnd, WM_COMMAND, IDM_ENDMAUSUJI, 0);
		break;
	case WM_QUERYENDSESSION:
		if(IniEditFlag == FALSE)
		{
			if(NaviType == 1)
				GetWindowPosition(hwnd, &MauSujiNavi);
			IniWrite();
			IniChange = FALSE;
		}
		KillTimer(hwnd, ID_HOOKCHECKTIMER);
		MouseUnHook(); //tbNI
		MyTaskTray(NULL);
		return TRUE;
	case WM_NCHITTEST:
		wParam = DefWindowProc(hwnd, msg, wParam, lParam);
		if(wParam==HTCLIENT)
			return HTCAPTION;
		return wParam;
	case WM_NCRBUTTONUP:
	case WM_RBUTTONUP:
		MakeTrayMenu(hwnd);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_OPENHELP:
			OpenHelp();
			break;
		case IDM_VERSIONINFO:
			ShowVersionInfo(hwnd);
			break;
		case IDM_MOUSEHOOK:
			if(IniEditFlag)
			{
				ToggleMouseHook(NULL);
			}
			else
			{
				MouseHookFlag = !MouseHookFlag;
				if(MouseHookFlag)
					SetMouseHook(hwnd);
				else
					MouseUnHook();
			}
			break;
		case IDM_WHEELREDIRECT:
			if(IniEditFlag)
			{
				ToggleWheelRedirect(NULL);
			}
			else
			{
				WheelRedirect = !WheelRedirect;
				SetWheelRedirectFlag(WheelRedirect);
				IniChange = TRUE;
			}
			break;
		case IDM_SHOWDIALOG:
			if(IniEditFlag == FALSE)
			{
				IniEditFlag = TRUE;
				if(NaviType == 1)
					GetWindowPosition(hwnd, &MauSujiNavi);
				IniWrite();
				IniChange = FALSE;
				DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_INIEDIT), NULL, IniEditDialogProc, (LPARAM)hwnd);
				PostMessage(hwnd, NAVIMINIMIZE_MSG, 0, 0);
				IniEditFlag = FALSE;
			}
			break;
		case IDM_HIDEMAUSUJINAVI:
			if(NaviType != 0)
			{
				NaviType = 0;
				ShowMauSujiNavi(hwnd, NaviType);
			}
			break;
		case IDM_SHOWMAUSUJINAVI:
			if(NaviType != 1)
			{
				NaviType = 1;
				NaviEditRefresh(hwnd);
				ShowMauSujiNavi(hwnd, NaviType);
			}
			break;
		case IDM_TIPMAUSUJINAVI:
			if(NaviType != 2)
			{
				NaviType = 2;
				NaviEditRefresh(hwnd);
				ShowMauSujiNavi(hwnd, NaviType);
			}
			break;
		case IDM_ENDMAUSUJI:
			//I
			if(IniEditFlag == FALSE)
			{
				if(NaviType == 1)
					GetWindowPosition(hwnd, &MauSujiNavi);
				IniWrite();
				IniChange = FALSE;
			}
			else if(IniChange == TRUE)
			{
				PopupFlag = TRUE;
				switch(MessageBox(hwnd, TEXT("ύXꂽݒۑ܂H"), TEXT("}E؂I"), MB_YESNOCANCEL))
				{
				case IDYES:
					IniWrite();
					IniChange = FALSE;
					break;
				case IDCANCEL:
					PopupFlag = FALSE;
					return 0;
				}
			}
			KillTimer(hwnd, ID_HOOKCHECKTIMER);
			MouseUnHook(); //tbNI
			MyTaskTray(NULL);
			PostQuitMessage(0);
			break;
		}
		break;
	case WM_TIMER:
		OnTimer(hwnd, (UINT)wParam);
		break;

	case MYMSG_TRAY:
		if(wParam == ID_MYTRAY)
		{
			switch(lParam)
			{
			case WM_LBUTTONDOWN:
				PostMessage(hwnd, WM_COMMAND, IDM_SHOWDIALOG, 0);
				break;
			case WM_RBUTTONUP:
				PostMessage(hwnd, WM_RBUTTONUP, 0, 0);
				break;
			case WM_MBUTTONUP:
				SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(IDM_MOUSEHOOK, 0), 0);
				break;
			}
		}
		break;
	case MAUHOOK_MSG:
		return OnMauHook(hwnd, wParam, lParam);
	case WHEELREDIRECT_MSG:
		RedirectTarget = SearchTarget((HWND)wParam, FALSE);
		if(RedirectTarget < 0)
			RedirectTarget = (int)Target.size();
		if(RedirectTarget < (int)Target.size())
		{
			if(Target[RedirectTarget].WheelRedirect)
				return TRUE;
		}
		else
		{
			if(Default.WheelRedirect)
				return TRUE;
		}
		break;
	case NAVIMINIMIZE_MSG:
		ShowWindow(hwnd, SW_HIDE);
		ShowWindow(hwnd, SW_MINIMIZE);
		ShowWindow(hwnd, SW_HIDE);
		ShowWindow(hwnd, SW_RESTORE);
		if(NaviType > 0)
			ShowParam = TRUE;
		else
			ShowParam = FALSE;
		ShowMauSujiNavi(hwnd, ShowParam);
		SetTimer(hwnd, ID_NAVITIMER, NaviDeleteTime, NaviDeleteProc);
		break;
	case FREESCROLL_MSG:
		FreeScroll((INT)wParam, (INT)lParam, FALSE, NULL);
		break;
	case KURUKURUHOOK_MSG:
		KuruKuruScroll(hwnd, (INT)wParam, (INT)lParam);
		break;
	case FREESCROLLSEARCH_MSG:
		RedirectTarget = SearchTarget((HWND)wParam, FALSE);
		if(RedirectTarget < 0)
			RedirectTarget = (int)Target.size();
		if(RedirectTarget < (int)Target.size())
		{
			if(Target[RedirectTarget].FreeScroll)
				return TRUE;
		}
		else
		{
			if(Default.FreeScroll)
				return TRUE;
		}
		break;
	case FREESCROLLINIT_MSG:
		FreeScroll(0, 0, TRUE, (HWND)wParam);
		break;
	default:
		if(msg==WM_TASKBARCREATED && ShowTaskTray)
			MyTaskTray(hwnd);
		return DefWindowProc(hwnd, msg, wParam, lParam);
	}
	return 0;
}

BOOL CALLBACK FindWindowProc(HWND hWnd, LPARAM lParam)
{
	/* EBhEAłɋNĂAvP[ṼEBhEׂ */
	if(GetProp(hWnd, TEXT("MauSujiProp")))
	{
		PostMessage(hWnd, WM_COMMAND, IDM_SHOWDIALOG, 0);
		return FALSE; /* 񋓂𒆒f */
	}
	return TRUE;  /* 񋓂𑱂 */
}

static void StartCommandLine(LPTSTR StrCmdLine)
{
	TCHAR *p, *r;

	p = StrCmdLine;
	while(*p != '\0'){
		for(; *p == ' '; p++);
		if(*p == '\0') break;

		if(*p != '/'){
			if(*p == '"'){
				p++;
				for(p++; *p != '\0' && *p != '"'; p++);
			}else{
				for(; *p != '\0' && *p != ' '; p++);
			}
			if(*p != '\0') p++;
			continue;
		}

		for(p++; *p != '\0' && *p != ' '; p++){
			switch(*p)
			{
			case 'i':
			case 'I':
				p++;
				if(*p != ':') break;
				p++;
				if(*p == '"'){
					p++;
					for(r = p; *r != '\0' && *r != '"'; r++);
				}else{
					for(r = p; *r != '\0' && *r != ' '; r++);
				}
				lstrcpyn(IniFileName, p, (int)(r - p + 1));
				p = r;
				if(*p == '\"') p++;
				break;
			case 'l':
			case 'L':
				LeftyMode = TRUE;
				break;
			}
			if(*p == '\0') break;
		}
	}
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	HANDLE hMutex;
	WNDCLASSEX wcex;
	HWND hWnd;
	MSG msg;

	hInstance = hInst;

	hMutex = CreateMutex(NULL, FALSE, TEXT("MPaIurSouCjhi")); //IuWFNg͓KBj[Nłǂ
	if(GetLastError() == ERROR_ALREADY_EXISTS) //ɓIuWFNg
	{ 
		EnumWindows(&FindWindowProc, NULL);
		CloseHandle(hMutex);
		return 0;
	}

	StartCommandLine(GetCommandLine());	//StartCommandLine(lpCmdLine);

	if(IniCheck())
	{
		if(MessageBox(NULL, TEXT("ݒǂݍނƂł܂B\n݂̐ݒe͔j܂낵łH"), TEXT("ݒt@C̃o[WႢ܂"), MB_YESNO) == IDNO)
		{
			CloseHandle(hMutex); //~[ebNXnh̃N[Y
			return 0;
		}
	}
	IniRead();

	hFont = CreateFontIndirect(&lf);
	NaviHeight = GetNaviHeight() + 4;
	SetWheelRedirectFlag(WheelRedirect);
	SetWheelActiveFlag(WheelActive);
	SetPriorityClass(GetCurrentProcess(), Priority);

	wcex.cbSize        = sizeof(WNDCLASSEX);
	wcex.style         = 0;
	wcex.lpfnWndProc   = (WNDPROC)WndProc;
	wcex.cbClsExtra    = 0;
	wcex.cbWndExtra    = 0;
	wcex.hInstance     = hInstance;
	wcex.hIcon         = NULL;
	wcex.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)CreateSolidBrush(BackColor);
	wcex.lpszMenuName  = NULL;
	wcex.lpszClassName = TEXT("MauSujiNavi");
	wcex.hIconSm       = NULL;

	RegisterClassEx( &wcex );

	hWnd = CreateWindowEx(
		WS_EX_TOPMOST | WS_EX_TOOLWINDOW,
		TEXT("MauSujiNavi"),
		NULL,
		WS_POPUP | WS_BORDER,
		MauSujiNavi.x, MauSujiNavi.y, NaviWidth, NaviHeight,
		NULL, NULL, hInstance, NULL);

	SetProp(hWnd, TEXT("MauSujiProp"), (HANDLE)1);

	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	if(hFont)
		DeleteObject(hFont);
	RemoveProp(hWnd, TEXT("MauSujiProp"));
	CloseHandle(hMutex); //~[ebNXnh̃N[Y

	return (int)msg.wParam;
}
